Attribute VB_Name = "General"
Option Explicit

Public glPrevWndProc As Long
Public uOldMessage As String

Global Const GWL_WNDPROC = (-4)
Global Const HTBORDER = 18
Global Const HTBOTTOM = 15
Global Const HTBOTTOMLEFT = 16
Global Const HTBOTTOMRIGHT = 17
Global Const HTCAPTION = 2
Global Const HTCLIENT = 1
Global Const HTERROR = (-2)
Global Const HTGROWBOX = 4
Global Const HTHSCROLL = 6
Global Const HTLEFT = 10
Global Const HTMAXBUTTON = 9
Global Const HTMENU = 5
Global Const HTMINBUTTON = 8
Global Const HTNOWHERE = 0
Global Const HTREDUCE = HTMINBUTTON
Global Const HTRIGHT = 11
Global Const HTSIZE = HTGROWBOX
Global Const HTSIZEFIRST = HTLEFT
Global Const HTSIZELAST = HTBOTTOMRIGHT
Global Const HTSYSMENU = 3
Global Const HTTOP = 12
Global Const HTTOPLEFT = 13
Global Const HTTOPRIGHT = 14
Global Const HTTRANSPARENT = -1
Global Const HTVSCROLL = 7
Global Const HTZOOM = HTMAXBUTTON
Global Const LF_FACESIZE = 32
Global Const WM_EXITSIZEMOVE = &H232
Global Const WM_FONTCHANGE = &H1D
Global Const WM_LBUTTONDOWN = &H201
Global Const WM_MOUSEMOVE = &H200
Global Const WM_NCACTIVATE = &H86
Global Const WM_NCCALCSIZE = &H83
Global Const WM_NCCREATE = &H81
Global Const WM_NCDESTROY = &H82
Global Const WM_NCHITTEST = &H84
Global Const WM_NCLBUTTONDBLCLK = &HA3
Global Const WM_NCLBUTTONDOWN = &HA1
Global Const WM_NCLBUTTONUP = &HA2
Global Const WM_NCMBUTTONDBLCLK = &HA9
Global Const WM_NCMBUTTONDOWN = &HA7
Global Const WM_NCMBUTTONUP = &HA8
Global Const WM_NCMOUSEMOVE = &HA0
Global Const WM_NCPAINT = &H85
Global Const WM_NCRBUTTONDBLCLK = &HA6
Global Const WM_NCRBUTTONDOWN = &HA4
Global Const WM_NCRBUTTONUP = &HA5
Global Const WM_NEXTDLGCTL = &H28
Global Const WM_NULL = &H0
Global Const WM_OTHERWINDOWCREATED = &H42
Global Const WM_OTHERWINDOWDESTROYED = &H43
Global Const WM_PAINT = &HF
Global Const WM_PAINTCLIPBOARD = &H309
Global Const WM_PAINTICON = &H26
Global Const WM_PALETTECHANGED = &H311
Global Const WM_PALETTEISCHANGING = &H310
Global Const WM_PARENTNOTIFY = &H210
Global Const WM_PASTE = &H302
Global Const WM_PENWINFIRST = &H380
Global Const WM_PENWINLAST = &H38F
Global Const WM_POWER = &H48
Global Const WM_USER = &H400

     Type LogFont
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName As String * LF_FACESIZE
    End Type

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function CreateFontIndirect Lib "GDI32" Alias "CreateFontIndirectA" (lpLogFont As LogFont) As Long
Declare Function ReleaseCapture Lib "user32" () As Long
Declare Function SelectObject Lib "GDI32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Long) As Long
Declare Function DeleteObject Lib "GDI32" (ByVal hObject As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Function localWMSGProc(ByVal hw As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim uMessage As String
'
' This is the callback procedure used when a message is received
' by this form.  The desired message is processed and all others are
' passed back to the original procedure associated with the form.
'
UnSubClass
    
    If _
    (uMsg = 33) Or _
    (uMsg = 32) Or _
    (uMsg = 38) _
    Then
    
    UserControl.lblCaption.Caption = Hex$(hw) & " - " & Hex$(uMsg) & " - " & Hex$(wParam) & " - " & Hex$(lParam)
        
    End If
    
SubClass

localWMSGProc = CallWindowProc(glPrevWndProc, hw, uMsg, wParam, lParam)

End Function
Public Function SubClass() As Long
' Subclass the form by eplacing the "normal" procedures associated
' with the form with procedure "localWMSGProc".
'
' NOTE: Comment all calls to fSubClass while in IDE.
fSubClass = SetWindowLong(UserControl.hwnd, GWL_WNDPROC, AddressOf localWMSGProc)
End Function



Public Sub UnSubClass()
'
' Stops the form from intercepting Window's messages
' by resetting the default procedures associated
' with the form.
'
Call SetWindowLong(UserControl.hwnd, GWL_WNDPROC, glPrevWndProc)
End Sub

Sub DrawBorders(FrmTarget As Form, Optional ShowFooter As Boolean)
On Error GoTo DrawBorders_Err

Dim YPlace As Integer
YPlace = IIf(Mid$(FrmTarget.Tag, 1, 1) = "B", 26, 16)

FrmTarget.AutoRedraw = True
FrmTarget.Line (1, 1)-((FrmTarget.ScaleWidth - 1), 1), &HFFFFFF
FrmTarget.Line (1, 1)-(1, (FrmTarget.ScaleHeight - 1)), &HFFFFFF

FrmTarget.Line (FrmTarget.ScaleWidth - 1, 1)-(FrmTarget.ScaleWidth - 1, FrmTarget.ScaleHeight - 1), &H0
FrmTarget.Line (1, FrmTarget.ScaleHeight - 1)-(FrmTarget.ScaleWidth, FrmTarget.ScaleHeight - 1), &H0

FrmTarget.Line (FrmTarget.ScaleWidth - 2, 2)-(FrmTarget.ScaleWidth - 2, FrmTarget.ScaleHeight - 2), &H808080
FrmTarget.Line (2, FrmTarget.ScaleHeight - 2)-(FrmTarget.ScaleWidth - 1, FrmTarget.ScaleHeight - 2), &H808080

    If ShowFooter Then
    FrmTarget.Line (3, FrmTarget.ScaleHeight - 24)-(FrmTarget.ScaleWidth - 3, FrmTarget.ScaleHeight - 24), &H808080
    FrmTarget.Line (3, FrmTarget.ScaleHeight - 23)-(FrmTarget.ScaleWidth - 3, FrmTarget.ScaleHeight - 23), &HFFFFFF
    End If
    
Exit Sub
DrawBorders_Err:
Exit Sub
End Sub

