Attribute VB_Name = "LibFileSystem"
Option Explicit
Function FileFound(strFileName As String) As Boolean
On Error GoTo FileFound_Err

    Dim lpFindFileData As WIN32_FIND_DATA
    Dim hFindFirst As Long
    hFindFirst = FindFirstFile(strFileName, lpFindFileData)


    If hFindFirst > 0 Then
        FindClose hFindFirst
        FileFound = True
    Else
        FileFound = False
    End If

Exit Function
FileFound_Err:
ErrH , "Function FileFound"
Exit Function

End Function
Public Function AddRecent(ByVal uName As String) As Boolean
On Error GoTo AddRecent_Err

Call SHAddToRecentDocs(2, uName)
AddRecent = True

Exit Function
AddRecent_Err:
ErrH "", "Public Function AddRecent"
Exit Function

End Function
Public Function BrowseForFolder(hwndOwner As Long, sPrompt As String) As String
On Error GoTo BrowseForFolder_Err

'declare variables to be used
Dim iNull As Integer, lpIDList As Long, lResult As Long, sPath As String, _
udtBI As BrowseInfo

'initialise variables
    With udtBI
    .hwndOwner = hwndOwner
    .lpszTitle = lstrcat(sPrompt, "")
    .ulFlags = BIF_RETURNONLYFSDIRS
    End With

'Call the browse for folder API
lpIDList = SHBrowseForFolder(udtBI)

'get the resulting string path
    If lpIDList Then
    sPath = String$(MAX_PATH, 0)
    lResult = SHGetPathFromIDList(lpIDList, sPath)
    Call CoTaskMemFree(lpIDList)
    iNull = InStr(sPath, vbNullChar)
    
        If iNull Then sPath = Left$(sPath, iNull - 1)
    
    End If

'If cancel was pressed, sPath = ""
BrowseForFolder = sPath

Exit Function
BrowseForFolder_Err:
ErrH "", "Public Function BrowseForFolder"
Exit Function

End Function
Public Function FindFiles(Optional uPath As String = "C:\", Optional uPattern As String = "*.*") As String
On Error GoTo FindFiles_Err

Open "C:\BAIT.BAT" For Output As #1
Print #1, "@ECHO OFF"
Print #1, "ECHO ---Starting file scan... ---"
Print #1, "DIR /B /S " & uPath & uPattern & " > C:\FILESCAN.LOG"
Close #1

ExecuteWait "C:\BAIT.BAT"

Exit Function
FindFiles_Err:
ErrH , "Public Function FindFiles"
Exit Function

End Function
Public Function SendToRecycleBin(ParamArray vntFilename() As Variant) As Boolean
On Error GoTo SendToRecycleBin_Err

Dim intK As Integer
Dim strFiles As String
Dim udtShellFileOper As SHFILEOPSTRUCT
Dim lngResult As Long

    For intK = LBound(vntFilename) To UBound(vntFilename)
    strFiles = strFiles & vntFilename(intK) & vbNullChar
    Next

strFiles = strFiles & vbNullChar

    With udtShellFileOper
    .wFunc = &H3
    .pFrom = strFiles
    .fFlags = &H40
    End With

lngResult = SHFileOperation(udtShellFileOper)

SendToRecycleBin = True

Exit Function
SendToRecycleBin_Err:
ErrH App.ProductName & " code library", "Public Function SendToRecycleBin"
Exit Function

End Function
Function ReadFileChunk(FileName As String, Optional Action As Integer) As String
On Error GoTo ReadFileChunk_Err

'   This routine reads the contents of ANY file (ignoring delimiters)
'   and returns the entire file in the function.  This
    
'   <Action=0> = From the beginning
'   <Action=1> = Continue from last chunk read
    Dim FBuffer As Integer
    Static CyclesRead As Integer
    Static FullLenString As String * 1000
    Static PartialString As String
    Dim Indicator As Long
    Static Temp As String
    
    If Action = 0 Then CyclesRead = 0
    
    FBuffer = FreeFile
    Open FileName For Random As #FBuffer Len = 1000
    
        If CyclesRead * 1000 > LOF(FBuffer) Then
        Close #FBuffer: Exit Function ' You've read all there is
        End If
        
    CyclesRead = CyclesRead + 1
    Get #FBuffer, CyclesRead, FullLenString
    
        If LOF(FBuffer) - (CyclesRead * 1000) > -1 Then
        'Not yet gone past end of file - return everything just read
        ReadFileChunk = FullLenString
        
        Else
        'You just read past the end of file
        'Obtain the portion you want and discard the rest
        ReadFileChunk = Left(FullLenString, LOF(FBuffer) - (CyclesRead * 1000) + 1000)
        
        End If
        
    Close #FBuffer

Exit Function
ReadFileChunk_Err:
ErrH App.ProductName & " code library", "Function ReadFileChunk"
Exit Function

End Function
Function SetFileTime(FileName As String, datDateTime As Date) As Boolean
On Error GoTo SetFileTime_Err

Dim blnRet As Boolean
    Dim lngRet As Long
    Dim lngHandle As Long
    Dim udtFileTime As FILETIME
    Dim udtLocalTime As FILETIME
    Dim udtSystemTime As SYSTEMTIME

    udtSystemTime.wYear = Year(datDateTime)
    udtSystemTime.wMonth = Month(datDateTime)
    udtSystemTime.wDay = Day(datDateTime)
    udtSystemTime.wDayOfWeek = Weekday(datDateTime) - 1
    udtSystemTime.wHour = Hour(datDateTime)
    udtSystemTime.wSecond = Second(datDateTime)
    udtSystemTime.wMilliseconds = 0

    lngRet = SystemTimeToFileTime(udtSystemTime, udtLocalTime)

    lngRet = LocalFileTimeToFileTime(udtLocalTime, udtFileTime)

    lngHandle = CreateFile(FileName, GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, 0, 0)

    blnRet = SetFileTimeA(lngHandle, udtFileTime, udtFileTime, udtFileTime)

    lngRet = CloseHandle(lngHandle)

Exit Function
SetFileTime_Err:
ErrH App.ProductName & " code library", "Function SetFileTime"
Exit Function

End Function
Function GetFileTime(FileName As String, Optional LastAccess As Date, Optional LastWrite As Date) As Date
On Error GoTo GetFileTime_Err

Dim lngRet As Long, lngHandle As Long, blnRet As Boolean
Dim udtCreation As FILETIME, _
udtLastAccess As FILETIME, _
udtLastWrite As FILETIME, _
udtSystemTime As SYSTEMTIME

lngHandle = CreateFile(FileName, GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, 0, 0)
blnRet = GetFileTimeA(lngHandle, udtCreation, udtLastAccess, udtLastWrite)
lngRet = CloseHandle(lngHandle)

lngRet = FileTimeToSystemTime(udtCreation, udtSystemTime)
GetFileTime = DateAdd("h", -3, CVDate(udtSystemTime.wMonth & "/" & udtSystemTime.wDay & "/" & udtSystemTime.wYear & " " & udtSystemTime.wHour & ":" & udtSystemTime.wMinute & ":" & udtSystemTime.wSecond))

lngRet = FileTimeToSystemTime(udtLastAccess, udtSystemTime)
LastAccess = DateAdd("h", -3, CVDate(udtSystemTime.wMonth & "/" & udtSystemTime.wDay & "/" & udtSystemTime.wYear & " " & udtSystemTime.wHour & ":" & udtSystemTime.wMinute & ":" & udtSystemTime.wSecond))

lngRet = FileTimeToSystemTime(udtLastWrite, udtSystemTime)
LastWrite = DateAdd("h", -3, CVDate(udtSystemTime.wMonth & "/" & udtSystemTime.wDay & "/" & udtSystemTime.wYear & " " & udtSystemTime.wHour & ":" & udtSystemTime.wMinute & ":" & udtSystemTime.wSecond))

Exit Function
GetFileTime_Err:
ErrH App.ProductName & " code library", "Function GetFileTime", , False
Exit Function

End Function

Public Function FindExecutable(S As String) As String
On Error GoTo FindExecutable_Err

Dim i As Integer
   Dim s2 As String
   
   s2 = String(MAX_FILENAME_LEN, 32) & Chr$(0)
   
   i = FindExecutableA(S & Chr$(0), vbNullString, s2)
   
   Dim Counter As Long
   
    For Counter = 1 To Len(s2)
    If Mid$(s2, Counter, 1) = Chr$(0) Then Mid$(s2, Counter, 1) = " "
    Next Counter
    
    s2 = Trim(s2)
   
   If i > 32 Then
      FindExecutable = Left$(s2, InStr(s2, Chr$(34)) - 1)
   Else
      FindExecutable = ""
   End If
   
Exit Function
FindExecutable_Err:
ErrH App.ProductName & " code library", "Public Function FindExecutable"
Exit Function

End Function
Public Function ShellDelete(ParamArray vntFilename() As Variant) As Boolean
On Error GoTo ShellDelete_Err

Dim i As Integer
   Dim sFileNames As String
   Dim SHFileOp As SHFILEOPSTRUCT

   For i = LBound(vntFilename) To UBound(vntFilename)
      sFileNames = sFileNames & vntFilename(i) & vbNullChar
   Next
        
   sFileNames = sFileNames & vbNullChar

   With SHFileOp
      .wFunc = FO_DELETE
      .pFrom = sFileNames
      .fFlags = FOF_ALLOWUNDO + FOF_SILENT + FOF_NOCONFIRMATION
   End With

   i = SHFileOperation(SHFileOp)
   
   If i = 0 Then
      ShellDelete = True
   Else
      ShellDelete = False
   End If

Exit Function
ShellDelete_Err:
ErrH App.ProductName & " code library", "Public Function ShellDelete"
Exit Function

End Function
Public Function ShellWait(cCommandLine As String) As Boolean
On Error GoTo ShellWait_Err

Dim NameOfProc As Process_Information
    Dim NameStart As StartupInfo
    Dim i As Long

    NameStart.cb = Len(NameStart)
    i = CreateProcessA(0&, cCommandLine, 0&, 0&, 1&, _
        NORMAL_PRIORITY_CLASS, 0&, 0&, NameStart, NameOfProc)
   
    If i <> 0 Then
       Call WaitForSingleObject(NameOfProc.hProcess, INFINITE)
       Call CloseHandle(NameOfProc.hProcess)
       ShellWait = True
    Else
       ShellWait = False
    End If
    
Exit Function
ShellWait_Err:
ErrH App.ProductName & " code library", "Public Function ShellWait"
Exit Function

End Function
Public Function ExecuteWait(lStrFile As String, Optional param As Variant) As Boolean
    On Error GoTo ExecuteWait_Err
    
    Dim s2 As String
    
    s2 = FindExecutable(lStrFile)
    
        If s2 <> "" Then
        ExecuteWait = ShellWait(s2 & IIf(IsMissing(param), " ", " " & CStr(param) & " ") & lStrFile)
        
        Else
        ExecuteWait = False
        
        End If
    
    Exit Function
ExecuteWait_Err:
    ErrH App.ProductName & " code library", "Public Function ExecuteWait"
    Exit Function

End Function
Public Function AddBackslash(S As String) As String
On Error GoTo AddBackslash_Err

If Len(S) > 0 Then
        
        If Right$(S, 1) <> "\" Then
        AddBackslash = S + "\"
        
        Else
        AddBackslash = S
        
        End If
    
    Else
    AddBackslash = "\"
    
    End If

Exit Function
AddBackslash_Err:
ErrH App.ProductName & " code library", "Public Function AddBackslash"
Exit Function

End Function
Public Function Execute(ByVal hWnd As Integer, S As String, Optional param As Variant, Optional windowstyle As VbAppWinStyle) As Boolean
On Error GoTo Execute_Err

Dim i As Long
   
   If IsMissing(windowstyle) Then
      windowstyle = vbNormalFocus
   End If
   
   i = ShellExecute(hWnd, vbNullString, S, IIf(IsMissing(param) Or (param = ""), vbNullString, CStr(param)), GetPath(S), CLng(windowstyle))
   If i > 32 Then
      Execute = True
   Else
      Execute = False
   End If

Exit Function
Execute_Err:
ErrH App.ProductName & " code library", "Public Function Execute"
Exit Function

End Function
Public Function GetFile(S As String) As String
On Error GoTo GetFile_Err

Dim i As Integer
Dim J As Integer

i = 0
J = 0

i = InStr(S, "\")

    Do While i <> 0
    J = i
    i = InStr(J + 1, S, "\")
    Loop

    If J = 0 Then
    GetFile = ""
    
    Else
    GetFile = Right$(S, Len(S) - J)
    
    End If

Exit Function
GetFile_Err:
ErrH App.ProductName & " code library", "Public Function GetFile"
Exit Function

End Function
Public Function GetPath(S As String) As String
On Error GoTo GetPath_Err

Dim i As Integer
   Dim J As Integer
   
   i = 0
J = 0

i = InStr(S, "\")

    Do While i <> 0
    J = i
    i = InStr(J + 1, S, "\")
    Loop

    If J = 0 Then
    GetPath = ""
    
    Else
    GetPath = Left$(S, J)
    
    End If

Exit Function
GetPath_Err:
ErrH App.ProductName & " code library", "Public Function GetPath"
Exit Function

End Function
Public Function GetSerialNumber(sDrive As String) As Long
On Error GoTo GetSerialNumber_Err

Dim ser As Long
Dim S As String * MAX_FILENAME_LEN
Dim s2 As String * MAX_FILENAME_LEN
Dim i As Long
Dim J As Long

Call GetVolumeInformation(sDrive + ":\" & Chr$(0), S, MAX_FILENAME_LEN, ser, i, J, s2, MAX_FILENAME_LEN)
GetSerialNumber = ser

Exit Function
GetSerialNumber_Err:
ErrH App.ProductName & " code library", "Public Function GetSerialNumber"
Exit Function

End Function
Public Function GetShortPathName(longpath As String) As String
On Error GoTo GetShortPathName_Err

Dim S As String
Dim i As Long

i = Len(longpath) + 1
S = String(i, 0)
GetShortPathNameA longpath, S, i

GetShortPathName = Left$(S, InStr(S, Chr$(0)) - 1)

Exit Function
GetShortPathName_Err:
ErrH App.ProductName & " code library", "Public Function GetShortPathName"
Exit Function

End Function
Public Function GetVolumeName(sDrive As String) As String
On Error GoTo GetVolumeName_Err

Dim ser As Long
Dim S As String * MAX_FILENAME_LEN
Dim s2 As String * MAX_FILENAME_LEN
Dim i As Long
Dim J As Long

Call GetVolumeInformation(sDrive + ":\" & Chr$(0), S, MAX_FILENAME_LEN, ser, i, J, s2, MAX_FILENAME_LEN)
GetVolumeName = Left$(S, InStr(S, Chr$(0)) - 1)

Exit Function
GetVolumeName_Err:
ErrH App.ProductName & " code library", "Public Function GetVolumeName"
Exit Function

End Function
Public Function SetVolumeName(sDrive As String, N As String) As Boolean
On Error GoTo SetVolumeName_Err

Dim i As Long
i = SetVolumeLabelA(sDrive + ":\" & Chr$(0), N & Chr$(0))
SetVolumeName = IIf(i = 0, False, True)

Exit Function
SetVolumeName_Err:
ErrH App.ProductName & " code library", "Public Function SetVolumeName"
Exit Function

End Function
Public Function GetSystemDirectory() As String
On Error GoTo GetSystemDirectory_Err

Dim S As String
Dim i As Integer
i = GetSystemDirectoryA("", 0)
S = Space(i)
Call GetSystemDirectoryA(S, i)
GetSystemDirectory = AddBackslash(Left$(S, i - 1))

Exit Function
GetSystemDirectory_Err:
ErrH App.ProductName & " code library", "Public Function GetSystemDirectory"
Exit Function

End Function
Public Function GetTempFileName() As String
On Error GoTo GetTempFileName_Err

Dim S As String
Dim s2 As String

s2 = GetTempPath
S = Space(Len(s2) + MAX_FILENAME_LEN)
Call GetTempFileNameA(s2, App.EXEName, UNIQUE_NAME, S)
GetTempFileName = Left$(S, InStr(S, Chr$(0)) - 1)

Exit Function
GetTempFileName_Err:
ErrH App.ProductName & " code library", "Public Function GetTempFileName"
Exit Function

End Function
Public Function GetTempPath() As String
On Error GoTo GetTempPath_Err

Dim S As String
Dim i As Integer
i = GetTempPathA(0, "")
S = Space(i)
Call GetTempPathA(i, S)
GetTempPath = AddBackslash(Left$(S, i - 1))

Exit Function
GetTempPath_Err:
ErrH App.ProductName & " code library", "Public Function GetTempPath"
Exit Function

End Function
Public Function GetWindowsDirectory() As String
On Error GoTo GetWindowsDirectory_Err

Dim S As String
Dim i As Integer
i = GetWindowsDirectoryA("", 0)
S = Space(i)
Call GetWindowsDirectoryA(S, i)
GetWindowsDirectory = AddBackslash(Left$(S, i - 1))

Exit Function
GetWindowsDirectory_Err:
ErrH App.ProductName & " code library", "Public Function GetWindowsDirectory"
Exit Function

End Function
Public Function RemoveBackslash(S As String) As String
On Error GoTo RemoveBackslash_Err

Dim i As Integer
i = Len(S)
    
    If i <> 0 Then
    
        If Right$(S, 1) = "\" Then
        RemoveBackslash = Left$(S, i - 1)
        
        Else
        RemoveBackslash = S
        
        End If
    
    Else
    RemoveBackslash = ""
    
    End If

Exit Function
RemoveBackslash_Err:
ErrH App.ProductName & " code library", "Public Function RemoveBackslash"
Exit Function

End Function
Public Function sDriveType(sDrive As String) As String
On Error GoTo sDriveType_Err

Dim lRet As Long

lRet = GetDriveTypeA(sDrive & ":\")

    Select Case lRet
    Case 0
    'sDriveType = "Cannot be determined!"
    sDriveType = "Unknown"
    
    Case 1
    'sDriveType = "The root directory does not exist!"
    sDriveType = "Unknown"
    Case DRIVE_CDROM:
    sDriveType = "CD-ROM Drive"
    
    Case DRIVE_REMOVABLE:
    sDriveType = "Removable Drive"
    
    Case DRIVE_FIXED:
    sDriveType = "Fixed Drive"
    
    Case DRIVE_REMOTE:
    sDriveType = "Remote Drive"
    
    End Select
    

Exit Function
sDriveType_Err:
ErrH App.ProductName & " code library", "Public Function sDriveType"
Exit Function

End Function
Public Function DriveType(sDrive As String) As Long
On Error GoTo DriveType_Err

Dim lRet As Long
lRet = GetDriveTypeA(sDrive & ":\")

    If lRet = 1 Then
    lRet = 0
    End If

DriveType = lRet

Exit Function
DriveType_Err:
ErrH App.ProductName & " code library", "Public Function DriveType"
Exit Function

End Function
Public Function FileExists(ByVal strPathName As String) As Integer
On Error GoTo FileExists_Err

Dim intFileNum As Integer

On Error Resume Next

'
'Remove any trailing directory separator character
'
    If Right$(strPathName, 1) = "\" Then
    strPathName = Left$(strPathName, Len(strPathName) - 1)
    End If

'
'Attempt to open the file, return value of this function is False
'if an error occurs on open, True otherwise
'
intFileNum = FreeFile
Open strPathName For Input As intFileNum

FileExists = IIf(Err, False, True)

Close intFileNum

Err = 0

Exit Function
FileExists_Err:
ErrH App.ProductName & " code library", "Public Function FileExists"
Exit Function

End Function
Function CheckSum(pFile As String, Optional pBufferSize As Long = 256, Optional pJustSignature As Boolean = False) As Currency
Dim lObjFSO As New FileSystemObject, lObjStream As TextStream, lStrTemp As String, lLngTotal As Currency, lLngCounter As Long, lCurTmp As Currency, uLimit As Long

    If Trim(pFile) = "" Then Exit Function

    If Not lObjFSO.FileExists(pFile) Then Exit Function
    
    If lObjFSO.GetFile(pFile).Size = 0 Then Exit Function

lLngTotal = lObjFSO.GetFile(pFile).Size

Set lObjStream = lObjFSO.GetFile(pFile).OpenAsTextStream(ForReading, TristateFalse)

    Do
    
        If lLngTotal > pBufferSize Then
        lStrTemp = lObjStream.Read(pBufferSize)
        uLimit = IIf(pJustSignature, 1, pBufferSize)
            
            For lLngCounter = 1 To uLimit
            lCurTmp = lCurTmp + Asc(Mid$(lStrTemp, lLngCounter, 1))
            Next lLngCounter
        
        lLngTotal = lLngTotal - pBufferSize
        
        ElseIf lLngTotal = pBufferSize Then
        lStrTemp = lObjStream.Read(pBufferSize)
        uLimit = IIf(pJustSignature, 1, pBufferSize)
        
            For lLngCounter = 1 To uLimit
            lCurTmp = lCurTmp + Asc(Mid$(lStrTemp, lLngCounter, 1))
            Next lLngCounter
                
        Exit Do
        
        Else
        lStrTemp = lObjStream.Read(lLngTotal)
        uLimit = IIf(pJustSignature, 1, lLngTotal)
        
            For lLngCounter = 1 To uLimit
            lCurTmp = lCurTmp + Asc(Mid$(lStrTemp, lLngCounter, 1))
            Next lLngCounter
        
        Exit Do
        
        End If
        
    Loop

CheckSum = lCurTmp

End Function
