Attribute VB_Name = "LibForm"
Option Private Module
Option Explicit
Dim DragMode  As Boolean, FRight As Boolean, FBotton As Boolean, FTop As Boolean, FLeft As Boolean, N As Long, nRet&
Public Function EnableSystemFileDrag(ByVal hWnd As Long, uStatus As Boolean, Optional uPassedHandler As Long) As Long
On Error GoTo EnableSystemFileDrag_Err

    Select Case uStatus
    Case True

    DragAcceptFiles hWnd, True ' Get ready to accept files
    ' set the address of windows message handler to that of File Drop Handler
    ' save address of original handler in lProcOld
    EnableSystemFileDrag = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf FileDropHandler)
    
    Case False
    DragAcceptFiles hWnd, False
    ' reset the address of windows message handler to it original value
    ' failing to do so will certainly cause a crash
    SetWindowLong hWnd, GWL_WNDPROC, uPassedHandler
    
    End Select

Exit Function
EnableSystemFileDrag_Err:
ErrH , "Public Function EnableSystemFileDrag"
Exit Function
End Function
Public Function FileDropHandler(ByVal hWnd As Long, ByVal iMsg As Long, ByVal wParam As Long, ByVal lParam As Long, lProcOld As Long) As Long
On Error GoTo FileDropHandler_Err

Dim FileName As String * 128

    If iMsg = WM_DROPFILES Then
    ' DragQueryFile(wParam,-1,filename,127) will return number of files dropped on the form
    ' DragQueryFile wParam, i, filename,127 sets filename to name of (i+1) th file
    ' Statement below sets filename to name of first dropped first file
    DragQueryFile wParam, 0, FileName, 127
    ' string filename now contains the (first) dropped file
    ' do whatever you want with this file, here the name of file will be displayes
    MsgBox "Dropped File " & Trim(FileName)
    Exit Function
    
    End If

'Important to call original message handler!
'Your app may not be the only subclasser around...
FileDropHandler = CallWindowProc(lProcOld, hWnd, iMsg, wParam, lParam)

Exit Function
FileDropHandler_Err:
ErrH , "Public Function FileDropHandler"
Exit Function
End Function
Function IncMenuItem(ByRef uMenu As Object, ByVal uCaption As String) As Boolean
On Error GoTo IncMenuItem_Err

Load uMenu(uMenu.Count) 'Vlido para todos...
uMenu(uMenu.Count - 1).Caption = uCaption
uMenu(uMenu.Count - 1).Visible = True

Exit Function
IncMenuItem_Err:
ErrH , "Function IncMenuItem"
Exit Function
End Function
Function IsFontInstalled(ByVal uFontName As String, Optional uIgnoreCaps As Boolean) As Boolean
On Error GoTo IsFontInstalled_Err

Dim Counter As Integer, uMark As Boolean

uFontName = Trim(uFontName)

If uFontName = "" Then Exit Function

    For Counter = 0 To Screen.FontCount - 1
    DoEvents
    
        If uIgnoreCaps Then
        uMark = (UCase(uFontName) = UCase(Screen.Fonts(Counter)))
        
        Else
        uMark = (Screen.Fonts(Counter) = uFontName)
        
        End If
        
        If uMark Then
        IsFontInstalled = True
        Exit Function
        End If
    
    Next Counter
    
IsFontInstalled = False
    

Exit Function
IsFontInstalled_Err:
ErrH , "Function IsFontInstalled"
Exit Function
End Function
Sub ClearListSel(ByRef uControl As ListBox)
On Error GoTo ClearListSel_Err

Dim Counter As Integer

        Do
        
            If Counter = uControl.ListCount Then Exit Do
            If uControl.Selected(Counter) Then _
            uControl.Selected(Counter) = False
            
        Counter = Counter + 1
        
        Loop

Exit Sub
ClearListSel_Err:
ErrH , "Sub ClearListSel"
Exit Sub
End Sub
Public Function LimitMouseArea(Optional X1 As Integer, Optional Y1 As Integer, Optional X2 As Integer, Optional Y2 As Integer) As Variant
On Error GoTo LimitMouseArea_Err

Dim uRetangle As RECT
uRetangle.Left = X1
uRetangle.Top = Y1
uRetangle.Right = X2
uRetangle.Bottom = Y2
ClipCursor uRetangle

Exit Function
LimitMouseArea_Err:
ErrH , "Public Function LimitMouseArea"
Exit Function
End Function
Function DumpListViewText(ByRef uControl As Control, ByVal uAddTotal As Boolean, Optional uPrinterWidth As Long = 80, Optional usePrinter As Boolean = False) As String
On Error GoTo DumpListViewText_Err

Dim uTmp As String, Counter As Integer, totWidth As Long, usblSpc As Long, ulnCnt As Long, Counter2 As Long
Dim lPort() As Long, pMaxFill As Long, pPage As Long, pIsFirstData As Boolean, T As String

    If usePrinter Then
    pMaxFill = Printer.ScaleHeight * 12 / 13
    pPage = 1
    End If

pIsFirstData = True

'ListViewGetColumnOrder uControl, lPort()

    If uControl.ListItems.Count = 0 Then
    T = "(Sem registros a imprimir.)" & vbCrLf
    Add uTmp, T
    If usePrinter Then Printer.Print T;
    
    Else
    
        For Counter2 = 1 To uControl.ColumnHeaders.Count
        Add totWidth, uControl.ColumnHeaders(Counter2).Width
        Next Counter2
    
    usblSpc = uPrinterWidth - uControl.ColumnHeaders.Count
    
    ' Registro...

        For ulnCnt = 1 To uControl.ListItems.Count
        
            For Counter = 1 To uControl.ColumnHeaders.Count
            
                If pIsFirstData Then 'Deve construir cabealho?
                pIsFirstData = False
        
                    If usePrinter Then
                    T = Right$(String$(uPrinterWidth, "_") & " Pgina " & Printer.Page, uPrinterWidth)
                    Printer.Print T & vbCrLf & vbCrLf;
                    End If
                    
                    For Counter2 = 1 To uControl.ColumnHeaders.Count
                    T = FixWidthText(uControl.ColumnHeaders(lPort(Counter2 - 1)).Text, usblSpc * (uControl.ColumnHeaders(lPort(Counter2 - 1)).Width / totWidth)) & " "
                    Add uTmp, T
                    If usePrinter Then Printer.Print T;
                    
                    Next Counter2
        
                Add uTmp, vbCrLf
                If usePrinter Then Printer.Print vbCrLf;
        
                    For Counter2 = 1 To uControl.ColumnHeaders.Count
                    T = String$(usblSpc * (uControl.ColumnHeaders(lPort(Counter2 - 1)).Width / totWidth), "_") & " "
                    Add uTmp, T
                    If usePrinter Then Printer.Print T;
                    
                    Next Counter2
        
                Add uTmp, vbCrLf
                If usePrinter Then Printer.Print vbCrLf;
        
                End If
            
                ' Teste de cabealho encerrado...
            
                If lPort(Counter - 1) = 1 Then
                T = FixWidthText(uControl.ListItems(ulnCnt).Text, usblSpc * (uControl.ColumnHeaders(lPort(Counter - 1)).Width / totWidth), False) & " "
                Add uTmp, T
                If usePrinter Then Printer.Print T;
                
                Else
                T = FixWidthText(uControl.ListItems(ulnCnt).SubItems(lPort(Counter - 1) - 1), usblSpc * (uControl.ColumnHeaders(lPort(Counter - 1)).Width / totWidth), False) & " "
                Add uTmp, T
                If usePrinter Then Printer.Print T;
                
                End If
                
            Next Counter
            
        Add uTmp, vbCrLf
        If usePrinter Then Printer.Print vbCrLf;
        
        If usePrinter Then
        
            If Printer.CurrentY >= pMaxFill Then
            ' Fechando pgina...
                For Counter = 1 To uControl.ColumnHeaders.Count
                Printer.Print String$(usblSpc * (uControl.ColumnHeaders(lPort(Counter - 1)).Width / totWidth), "_") & " ";
                Next Counter
                
            Printer.NewPage
            pIsFirstData = True
            
            End If
        
        End If
        
        Next ulnCnt
        
        For Counter = 1 To uControl.ColumnHeaders.Count
        T = String$(usblSpc * (uControl.ColumnHeaders(lPort(Counter - 1)).Width / totWidth), "_") & " "
        Add uTmp, T
        If usePrinter Then Printer.Print T;
        
        Next Counter
        
    Add uTmp, vbCrLf
    If usePrinter Then Printer.Print vbCrLf;
    
        If uAddTotal Then
        T = vbCrLf & "Total de itens impressos: " & uControl.ListItems.Count & vbCrLf
        Add uTmp, T
        If usePrinter Then Printer.Print T;

        End If
    
    End If

DumpListViewText = uTmp

Exit Function
DumpListViewText_Err:
ErrH , "Function DumpListViewText"
Exit Function
End Function
Public Sub GoSystemTray(uForm As Form)
On Error GoTo GoSystemTray_Err

VBGTray.cbSize = Len(VBGTray)
VBGTray.hWnd = uForm.hWnd
VBGTray.uId = vbNull
VBGTray.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
VBGTray.ucallbackMessage = WM_MOUSEMOVE
VBGTray.hIcon = uForm.Icon
VBGTray.szTip = App.ProductName & vbNullChar

Call Shell_NotifyIcon(NIM_ADD, VBGTray)

App.TaskVisible = False
uForm.Hide

Exit Sub
GoSystemTray_Err:
ErrH "", "Public Sub GoSystemTray"
Exit Sub
End Sub
Sub SelectListItemByID(ByRef uControl As Control, ByVal uIndex As Long)
Dim Counter As Long
    
    For Counter = 0 To uControl.ListCount - 1
        
        If uControl.ItemData(Counter) = uIndex Then
        uControl.ListIndex = Counter
        Exit Sub
        End If
    
    Next Counter
        
End Sub
Public Sub SystemTrayForm_MouseMove(uForm As Form, Button As Integer, Shift As Integer, X As Single, Y As Single, Optional uMenu As Menu)
On Error GoTo TrayForm_MouseMove_Err

'Put this on a Tray-ed application.

Static lngMsg As Long
Static blnFlag As Boolean
Dim Result As Long

lngMsg = X / Screen.TwipsPerPixelX

    If blnFlag = False Then
    blnFlag = True
    
        Select Case lngMsg
        Case WM_LBUTTONDBLCLK
        uForm.Show
        
        Case WM_RBUTTONUP
        Result = SetForegroundWindow(uForm.hWnd)
        uForm.PopupMenu uMenu
        
        End Select
    
    blnFlag = False
    
    End If

Exit Sub
TrayForm_MouseMove_Err:
ErrH "", "Public Sub SystemTrayForm_MouseMove"
Exit Sub
End Sub
Public Sub SystemTrayForm_QueryUnload(uForm As Form, Cancel As Integer, UnloadMode As Integer)
On Error GoTo SystemTrayForm_QueryUnload_Err

VBGTray.cbSize = Len(VBGTray)
VBGTray.hWnd = uForm.hWnd
VBGTray.uId = vbNull
Call Shell_NotifyIcon(NIM_DELETE, VBGTray)

Exit Sub
SystemTrayForm_QueryUnload_Err:
ErrH "", "Public Sub SystemTrayForm_QueryUnload"
Exit Sub
End Sub
Public Sub CenterForm(f As Form, Optional f2 As Variant, Optional pBolStyle As Boolean = False)
On Error GoTo CenterForm_Err

Dim uPlaceIndex As Byte

uPlaceIndex = IIf(pBolStyle, 1, 2)

    If IsMissing(f2) Then
    f.Move (Screen.Width - f.Width) / uPlaceIndex, (Screen.Height - f.Height) / uPlaceIndex
    
    Else
    ' If f is an MDI child in a MDI parent then
    ' center f within the parent.
    
        If f.MDIChild And Not (TypeOf f2 Is MDIForm) Then
        f.Move ((f2.Width - f.Width) / uPlaceIndex), ((f2.Height - f.Height) / uPlaceIndex)
        
        Else
        f.Move ((f2.ScaleWidth - f.Width) / uPlaceIndex), ((f2.ScaleHeight - f.Height) / uPlaceIndex)
        
        End If
        
    End If

Exit Sub
CenterForm_Err:
ErrH App.ProductName & " code library", "Public Sub CenterForm"
Exit Sub
End Sub
Sub Enable(ByRef N As Control)
On Error GoTo Enable_Err

    If N.Enabled = False Then N.Enabled = True

Exit Sub
Enable_Err:
ErrH App.ProductName & " code library", "Sub Enable"
Exit Sub
End Sub
Sub Disable(ByRef N As Control)
On Error GoTo Disable_Err

If N.Enabled = True Then N.Enabled = False

Exit Sub
Disable_Err:
ErrH App.ProductName & " code library", "Sub Disable"
Exit Sub
End Sub
Function IsSameControl(ByVal N As Control, M As Control)
On Error GoTo IsSameControl_Err

Dim Name1 As String, Name2 As String, Index1 As Integer, Index2 As Integer, non As Boolean

IsSameControl = (N.hWnd = M.hWnd)

    If non Then non = False Else Exit Function

Name1 = N.Name
Name2 = M.Name
Index1 = N.Index + 1
Index2 = M.Index + 1

IsSameControl = ((Name1 = Name2) And (Index1 = Index2))

Exit Function
IsSameControl_Err:
If Err = 343 Then Resume Next
If Err = 438 Then non = True: Resume Next
If Err = 91 Then Exit Function

ErrH App.ProductName & " code library", "Function IsSameControl"
Exit Function
End Function
Sub SimulateEnlargementControls(ByVal Frm As Form, ByVal X As Single, Y As Single)
On Error GoTo SimulateEnlargementControls_Err

FLeft = (X <= 4)
FRight = (X >= (Frm.ScaleWidth - 4))
FTop = (Y <= 4)
FBotton = (Y >= (Frm.ScaleHeight - 4))

N = 0

    If FTop Then N = vbSizeNS
    If FBotton Then N = vbSizeNS
    If FLeft Then N = vbSizeWE
    If FRight Then N = vbSizeWE
    
    If (FLeft And FBotton) Or (FRight And FTop) Then N = vbSizeNESW
    If (FRight And FBotton) Or (FLeft And FTop) Then N = vbSizeNWSE
    
Frm.MousePointer = N
    
Exit Sub
SimulateEnlargementControls_Err:
ErrH App.ProductName & " code library", "Sub SimulateEnlargementControls"
Exit Sub
End Sub
Sub StartDrag(ByVal XForm As Form)
On Error GoTo StartDrag_Err

Dim Counter As Integer, TmpTop As Integer, Position As POINTAPI, Rctn As RECT, _
BPos As POINTAPI

DragMode = True
Run GetCursorPos(Position)
Run GetWindowRect(XForm.hWnd, Rctn)

    Do While DragMode = True
    Run GetCursorPos(BPos)
    XForm.Left = ((BPos.X - Position.X) + Rctn.Left) * Screen.TwipsPerPixelX
    XForm.Top = ((BPos.Y - Position.Y) + Rctn.Top) * Screen.TwipsPerPixelY
    DoEvents
    Loop

Exit Sub
StartDrag_Err:
ErrH App.ProductName & " code library", "Sub StartDrag"
Exit Sub
End Sub
Function GetWinPos(ByVal Target As Form) As FormPos
On Error GoTo GetWinPos_Err

Dim RawForm As String, FLAG As Boolean, Counter As Byte

    For Counter = 0 To Forms.Count - 1
        If Target.hWnd = Forms(Counter).hWnd Then FLAG = True
    Next Counter
    
    If FLAG Then
    GetWinPos.Visible = Target.Visible
    
    Else
    GetWinPos.Visible = False
    
    End If
    
GetWinPos.Height = Target.Height
GetWinPos.Width = Target.Width
GetWinPos.Top = Target.Top
GetWinPos.Left = Target.Left

Exit Function
GetWinPos_Err:
ErrH App.ProductName & " code library", "Function GetWinPos"
Exit Function
End Function
Sub SetWinPos(Coords As FormPos, ByRef RawForm As Form)
On Error GoTo SetWinPos_Err

RawForm.Visible = Coords.Visible
RawForm.Height = Coords.Height
RawForm.Width = Coords.Width
RawForm.Top = Coords.Top
RawForm.Left = Coords.Left

Exit Sub
SetWinPos_Err:
ErrH App.ProductName & " code library", "Sub SetWinPos"
Exit Sub
End Sub
Sub SelectListItem(ListControl As Control, Text As String)
On Error GoTo SelectListItem_Error
'___
'   This routine will highlight a given line in a listbox based on the
'   String being searched for.
Dim i As Integer
i = SendMessage(ListControl.hWnd, LB_SELECTSTRING, -1, ByVal Text)

Exit Sub
'___
SelectListItem_Error:
ErrH App.ProductName & " code library", "Sub SelectListItem"
Exit Sub
End Sub
Sub TrytoDrag(ByVal XForm As Form, ByVal YY As Single)
On Error GoTo TrytoDrag_Error
    
    If YY <= IIf(Mid$(XForm.Tag, 1, 1) = "S", 24, 34) And YY > 4 Then
    Drag XForm
    End If

Exit Sub
'___
TrytoDrag_Error:
ErrH App.ProductName & " code library", "Sub SelectListItem"
Exit Sub
End Sub
Sub TryToResize(ByVal XForm As Form, ByVal X As Single, ByVal Y As Single)
On Error GoTo TryToResize_Err

FLeft = (X <= 4)
FRight = (X >= (XForm.ScaleWidth - 4))
FTop = (Y <= 4)
FBotton = (Y >= (XForm.ScaleHeight - 4))

    If FTop Then N = HTTOP
    If FBotton Then N = HTBOTTOM
    If FLeft Then N = HTLEFT
    If FRight Then N = HTRIGHT
    
    If (FLeft And FBotton) Then N = HTBOTTOMLEFT
    If (FRight And FBotton) Then N = HTBOTTOMRIGHT
    If (FLeft And FTop) Then N = HTTOPLEFT
    If (FRight And FTop) Then N = HTTOPRIGHT

    If N <> 0 Then
    
    ReleaseCapture
    nRet = SendMessage(XForm.hWnd, WM_NCLBUTTONDOWN, N, 0&)
    
'    XForm.Cls
'    DrawBorders XForm
'    DrawHeader XForm

    End If

Exit Sub
TryToResize_Err:
ErrH App.ProductName & " code library", "Sub TryToResize"
Exit Sub
End Sub
Sub Undo()
On Error GoTo Undo_Error
'___
SendKeys "{ESC 2}", True

Exit Sub
'___
Undo_Error:
ErrH App.ProductName & " code library", "Sub Undo"
Exit Sub
End Sub
Sub ValidateDateControl(ByRef DateControl As Control, Optional AtualDateControl As Boolean)
On Error GoTo ValidateDateControl_Error
'___

Dim TextBuffer As String

TextBuffer = DateControl

    If Not IsDate(TextBuffer) Then
    MsgBox "DATA invlida."
    DateControl = Date
    
    Else
    DateControl = DateValue(TextBuffer)
    
    End If

    If AtualDateControl Then
        If DateValue(DateControl) > Date Then
        MsgBox "A DATA fornecida  invlida: esta  maior que a do sistema."
        DateControl = Date
        End If
    End If

Exit Sub
'___
ValidateDateControl_Error:
ErrH App.ProductName & " code library", "Sub ValidateDateControl"
Exit Sub
End Sub
Sub Drag(TargetForm As Form) ' Incluir apenas no evento Mouse_Down
On Error GoTo DestroyHeader_Error

Dim nRet&
ReleaseCapture
nRet = SendMessage(TargetForm.hWnd, WM_NCLBUTTONDOWN, HTCAPTION, 0&)

Exit Sub
DestroyHeader_Error:
ErrH App.ProductName & " code library", "DestroyHeader"
Exit Sub
End Sub
Sub InvokeResize(TargetForm As Form) ' Incluir apenas no evento Mouse_Down
On Error GoTo DestroyHeader_Error

Dim nRet&
ReleaseCapture
nRet = SendMessage(TargetForm.hWnd, WM_LBUTTONDOWN, HTBORDER, HTGROWBOX)

Exit Sub
DestroyHeader_Error:
ErrH App.ProductName & " code library", "DestroyHeader"
Exit Sub
End Sub
Function FindForm(Formname As String) As Boolean
On Error GoTo FindForm_Err
Dim Counter As Integer

    For Counter = 0 To Forms.Count - 1
        If Forms(Counter).Name = Formname Then
        FindForm = True
        Exit Function
        End If
    Next Counter
    
FindForm = False
    
Exit Function
FindForm_Err:
ErrH App.ProductName & " code library", "Function FindForm"
Exit Function
End Function
Function KBNumFilter(ByRef AsciiCode As Integer)
On Error GoTo KBNumFilter_Error

'Insert this function on [KeyPress] event.

    If (AsciiCode < 48 Or AsciiCode > 57) And AsciiCode <> 8 Then
    KBNumFilter = 0
    
    Else
    KBNumFilter = AsciiCode
    
    End If

Exit Function

KBNumFilter_Error:
ErrH App.ProductName & " code library", "KBNumFilter"
Exit Function
End Function
Sub NoMove(ByRef Place As Form, ByVal DesParm As Integer)
On Error GoTo NoMove_Error

Dim Success As Integer

    Select Case Val(DesParm)
    
    Case True
    SetWindowPos Place.hWnd, SWP_NOMOVE, 0, 0, 0, 0, FLAG
    
    Case False
    SetWindowPos Place.hWnd, 0, 0, 0, 0, 0, FLAG
    
    End Select

Exit Sub

Exit Sub

NoMove_Error:
ErrH App.ProductName & " code library", "GeneralProcedures - NoMove"
Exit Sub
End Sub
Sub OnTop(ByVal OnTopForm As Form, Optional Status As Boolean = True)
On Error GoTo AwaysOnTop_Error

Dim Success As Integer

    Select Case Status
    
    Case True
    SetWindowPos OnTopForm.hWnd, HWND_TOPMOST, 0, 0, 0, 0, FLAG
    
    Case False
    SetWindowPos OnTopForm.hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, FLAG
    
    End Select

Exit Sub

AwaysOnTop_Error:

    If Err.number = 364 Then Resume Next

ErrH App.ProductName & " code library", "AwaysOnTop"
Exit Sub
End Sub
Sub OpenForm(ByVal Destiny As Form, ByVal Origin As Form, ByRef DestVar As Form)
On Error GoTo OpenForm_Err
Dim Counter As Integer, TmpTop As Integer, Position As POINTAPI, Rctn As RECT

Load Destiny
Destiny.Left = Origin.Left + Origin.Width - (Destiny.Width / 2)

Destiny.Top = Origin.Top

    If Destiny.Top > Screen.Height - Destiny.Height Then
    Destiny.Top = Screen.Height - Destiny.Height
    End If

Set DestVar = Destiny
Destiny.Visible = True

Run GetWindowRect(Destiny.hWnd, Rctn)
Run GetCursorPos(Position)
Run SetCursorPos(Int((Rctn.Left + Rctn.Right) / 2), Position.Y)

Exit Sub
OpenForm_Err:
ErrH App.ProductName & " code library", "Sub OpenForm"
Exit Sub
End Sub
Sub StopDrag()
On Error GoTo StopDrag_Err

DragMode = False

Exit Sub
StopDrag_Err:
ErrH App.ProductName & " code library", "Sub StopDrag"
Exit Sub
End Sub
Sub ClipMouseToWindow(Optional ByVal hWnd As Long)
    Dim rcTarg As RECT
                         
    If hWnd Then
    'clip the mouse to the specified window
    'get the window's client area
    GetClientRect hWnd, rcTarg
    'convert to screen coordinates. Two steps:
    'first, the upper-left corner
    ClientToScreen hWnd, rcTarg
    'next, the bottom-right corner
    ClientToScreen hWnd, rcTarg.Right
    'finally, we can clip the cursor
    ClipCursor rcTarg
    
    Else
    'unclip the mouse if no argument has been passed
    ClipCursor ByVal 0&
    
    End If

End Sub
Function ChangeRes(iWidth As Long, iHeight As Long, Optional ColorDepth As Integer = 32) As Boolean
Dim DevM As DEVMODE, lBolFlag As Boolean, lLngAnswer As Long
    
'Get the info into DevM
lBolFlag = EnumDisplaySettings(0&, 0&, DevM)

DevM.dmFields = DM_PELSWIDTH Or DM_PELSHEIGHT Or DM_BITSPERPEL
DevM.dmPelsWidth = iWidth 'ScreenWidth
DevM.dmPelsHeight = iHeight 'ScreenHeight
DevM.dmBitsPerPel = ColorDepth '(could be 8, 16, 32 or even 4)
'Now change the display and check if possible
lBolFlag = ChangeDisplaySettings(DevM, CDS_TEST)
'Check if succesfull

    Select Case lBolFlag
    Case DISP_CHANGE_RESTART
    lLngAnswer = MsgBox("You've to reboot", vbYesNo + vbSystemModal, "Info")
        
        If lLngAnswer = vbYes Then
        lBolFlag = ExitWindowsEx(EWX_REBOOT, 0&)
        End If
    
    Case DISP_CHANGE_SUCCESSFUL
    lBolFlag = ChangeDisplaySettings(DevM, CDS_UPDATEREGISTRY)
    ChangeRes = True
    
    Case Else
    ChangeRes = False
    
    End Select

End Function
Public Sub ListViewAutoSize(lv As ListView)

Dim col2adjust As Long

    For col2adjust = 0 To lv.ColumnHeaders.Count - 1
    Call SendMessage(lv.hWnd, LVM_SETCOLUMNWIDTH, col2adjust, ByVal LVSCW_AUTOSIZE_USEHEADER)
    Next
   
End Sub
Public Sub ListViewAutoSizeByItems(lv As ListView)

   Dim col2adjust As Long

   For col2adjust = 0 To lv.ColumnHeaders.Count - 1
   
      Call SendMessage(lv.hWnd, _
                       LVM_SETCOLUMNWIDTH, _
                       col2adjust, _
                       ByVal LVSCW_AUTOSIZE)
   Next
   
End Sub
Public Sub ListViewAutoSizeMax(lv As ListView)
   
   Dim col2adjust As Long
   
   col2adjust = lv.ColumnHeaders.Count - 1
   
   Call SendMessage(lv.hWnd, _
            LVM_SETCOLUMNWIDTH, _
            col2adjust, _
            ByVal LVSCW_AUTOSIZE_USEHEADER)
   
End Sub
Sub ListItemOrderByColumn(ByRef lstItems As ListView, ColumnHeader As MSComctlLib.ColumnHeader)

    With lstItems
    .Sorted = True

        If (.SortKey = ColumnHeader.Index - 1) Then

            If .SortOrder <> lvwAscending Then
            .SortOrder = lvwAscending
            Else
            .SortOrder = lvwDescending
            End If

        Else
        .SortOrder = lvwAscending

        End If

    .SortKey = ColumnHeader.Index - 1
    End With

End Sub
Sub DragList(lObject As ListView, X As Single, Y As Single)
On Error Resume Next

Dim uIndex As String
uIndex = lObject.HitTest(X, Y).Tag

If Err.number <> 0 Then Exit Sub

Dim uI As ListItem

    For Each uI In lObject.ListItems
    uI.Selected = False
    Next uI

lObject.HitTest(X, Y).Selected = True
Data.UserOnDrag = uIndex
lObject.Drag 1

End Sub
Public Function ListViewGetSelectedList(ByRef uLV As ListView) As String
Dim uTmp As String, uItem As ListItem

    For Each uItem In uLV.ListItems
        
        If uItem.Selected Then
        uTmp = uTmp & IIf(uTmp <> "", "|", "") & _
        uItem.Tag
        End If
        
    Next uItem

ListViewGetSelectedList = uTmp

End Function
Public Function CaptureScreen(Optional uSecs As Long) As IPictureDisp
Dim uNow As Long
uNow = GetTickCount

    Do While Not GetTickCount > uNow + uSecs * 1000
    DoEvents
    Loop

Debug.Print "Click!"
keybd_event vbKeySnapshot, 3, 0, 0

Set CaptureScreen = Clipboard.GetData(vbCFBitmap)
Clipboard.SetText "", vbCFText

End Function
Public Function SaveScreen(ByVal uFile As String)
keybd_event vbKeySnapshot, 1, 0, 0
SavePicture Clipboard.GetData(vbCFBitmap), uFile
Clipboard.SetText ""
End Function
Sub ParseColor(ByVal uColor As OLE_COLOR, URed As Byte, uGreen As Byte, uBlue As Byte)
Dim uBaseColor As String
uBaseColor = Right$("000000" & Hex$(uColor), 6)
URed = Val("&H" & Mid$(uBaseColor, 1, 2))
uGreen = Val("&H" & Mid$(uBaseColor, 3, 2))
uBlue = Val("&H" & Mid$(uBaseColor, 5, 2))
End Sub
Function ComposeColor(ByVal URed As Byte, ByVal uGreen As Byte, ByVal uBlue As Byte) As OLE_COLOR
ComposeColor = Val("&H" & _
Right$("00" & Hex$(URed), 2) & _
Right$("00" & Hex$(uGreen), 2) & _
Right$("00" & Hex$(uBlue), 2))
End Function
Sub StoreFormPos(ByRef uForm As Form, Optional umode As String)
SaveSetting App.ProductName, "Disposition preferences", uForm.Name & IIf(umode <> "", "." & umode, "") & ".Left", uForm.Left
SaveSetting App.ProductName, "Disposition preferences", uForm.Name & IIf(umode <> "", "." & umode, "") & ".Top", uForm.Top
SaveSetting App.ProductName, "Disposition preferences", uForm.Name & IIf(umode <> "", "." & umode, "") & ".Width", uForm.Width
SaveSetting App.ProductName, "Disposition preferences", uForm.Name & IIf(umode <> "", "." & umode, "") & ".Height", uForm.Height
End Sub
Sub RestoreFormPos(ByRef uForm As Form, Optional umode As String)
uForm.Left = GetSetting(App.ProductName, "Disposition preferences", uForm.Name & IIf(umode <> "", "." & umode, "") & ".Left", uForm.Left)
uForm.Top = GetSetting(App.ProductName, "Disposition preferences", uForm.Name & IIf(umode <> "", "." & umode, "") & ".Top", uForm.Top)
uForm.Width = GetSetting(App.ProductName, "Disposition preferences", uForm.Name & IIf(umode <> "", "." & umode, "") & ".Width", uForm.Width)
uForm.Height = GetSetting(App.ProductName, "Disposition preferences", uForm.Name & IIf(umode <> "", "." & umode, "") & ".Height", uForm.Height)
End Sub
Sub TreeViewSetBGColor(ByRef uControl As Object, uColor As OLE_COLOR)
SendMessage uControl.hWnd, TVM_SETBKCOLOR, 0, ByVal uColor
End Sub
Sub TreeViewSetForeColor(ByRef uControl As Object, uColor As OLE_COLOR)
SendMessage uControl.hWnd, TVM_SETTEXTCOLOR, 0, ByVal uColor
End Sub
