VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Network"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private mAPIErrName As String
Private mAPIErrNo   As Byte

Private Const HEAP_GENERATE_EXCEPTIONS = &H4
Private Const HEAP_ZERO_MEMORY = &H8
Private Const MIN_SOCKETS_REQD = 1
Private Const NCBASTAT = &H33
Private Const NCBNAMSZ = 16
Private Const NCBRESET = &H32
Private Const SOCKET_ERROR = -1
Private Const WS_VERSION_REQD = &H101
Private Const WS_VERSION_MAJOR = WS_VERSION_REQD \ &H100 And &HFF&
Private Const WS_VERSION_MINOR = WS_VERSION_REQD And &HFF&
Private Const WSADescription_Len = 256
Private Const WSASYS_Status_Len = 128

Private Declare Function GetComputerNameA Lib "kernel32" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function gethostbyname Lib "WSOCK32.DLL" (ByVal hostname$) As Long
Private Declare Function gethostname Lib "WSOCK32.DLL" (ByVal hostname$, HostLen&) As Long
Private Declare Function GetProcessHeap Lib "kernel32" () As Long
Private Declare Function GetUserName Lib "advapi32.dll" Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function HeapAlloc Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function HeapFree Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, lpMem As Any) As Long
Private Declare Function Netbios Lib "netapi32.dll" (pncb As NCB) As Byte
Private Declare Function WSACleanup Lib "WSOCK32.DLL" () As Long
Private Declare Function WSAGetLastError Lib "WSOCK32.DLL" () As Long
Private Declare Function WSAStartup Lib "WSOCK32.DLL" (ByVal wVersionRequired&, lpWSAData As WSADATA) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, ByVal hpvSource As Long, ByVal cbCopy As Long)
Private Declare Sub RtlMoveMemory Lib "kernel32" (hpvDest As Any, ByVal hpvSource&, ByVal cbCopy&)

Private Type ADAPTER_STATUS: adapter_address(5) As Byte: rev_major As Byte: reserved0 As Byte: adapter_type As Byte: rev_minor As Byte: duration As Integer: frmr_recv As Integer: frmr_xmit As Integer: iframe_recv_err As Integer: xmit_aborts As Integer: xmit_success As Long: recv_success As Long: iframe_xmit_err As Integer: recv_buff_unavail As Integer: t1_timeouts As Integer: ti_timeouts As Integer: Reserved1 As Long: free_ncbs As Integer: max_cfg_ncbs As Integer: max_ncbs As Integer: xmit_buf_unavail As Integer: max_dgram_size As Integer: pending_sess As Integer: max_cfg_sess As Integer: max_sess As Integer: max_sess_pkt_size As Integer: name_count As Integer: End Type
Private Type HOSTENT: hName As Long: hAliases As Long: hAddrType As Integer: hLength As Integer: hAddrList As Long: End Type
Private Type NAME_BUFFER: name As String * NCBNAMSZ: name_num As Integer: name_flags As Integer: End Type
Private Type NCB: ncb_command As Byte: ncb_retcode As Byte: ncb_lsn As Byte: ncb_num As Byte: ncb_buffer As Long: ncb_length As Integer: ncb_callname As String * NCBNAMSZ: ncb_name As String * NCBNAMSZ: ncb_rto As Byte: ncb_sto As Byte: ncb_post As Long: ncb_lana_num As Byte: ncb_cmd_cplt As Byte: ncb_reserve(9) As Byte: ncb_event As Long: End Type
Private Type WSADATA: wversion As Integer: wHighVersion As Integer: szDescription(0 To WSADescription_Len) As Byte: szSystemStatus(0 To WSASYS_Status_Len) As Byte: iMaxSockets As Integer: iMaxUdpDg As Integer: lpszVendorInfo As Long: End Type
Private Type ASTAT: adapt As ADAPTER_STATUS: NameBuff(30) As NAME_BUFFER: End Type
Public Function MACAddress(Optional ByVal lIntNIC As Integer = 0) As String
Attribute MACAddress.VB_Description = "Returns the specified MAC address of a given network adapter"
Dim udtNCB       As NCB
Dim bytResponse  As Byte
Dim udtASTAT     As ASTAT
Dim udtTempASTAT As ASTAT
Dim lngASTAT     As Long
Dim strOut       As String
Dim x            As Integer

udtNCB.ncb_command = NCBRESET
bytResponse = Netbios(udtNCB)
udtNCB.ncb_command = NCBASTAT
udtNCB.ncb_lana_num = lIntNIC
udtNCB.ncb_callname = "* "
udtNCB.ncb_length = Len(udtASTAT)
lngASTAT = HeapAlloc(GetProcessHeap(), HEAP_GENERATE_EXCEPTIONS Or HEAP_ZERO_MEMORY, udtNCB.ncb_length)
strOut = ""
    
    If lngASTAT Then
    udtNCB.ncb_buffer = lngASTAT
    bytResponse = Netbios(udtNCB)
    CopyMemory udtASTAT, udtNCB.ncb_buffer, Len(udtASTAT)
        
        With udtASTAT.adapt
            
            For x = 0 To 5
            strOut = strOut & IIf(strOut <> "", ".", "") & Right$("00" & Hex$(.adapter_address(x)), 2)
            Next x
        
        End With
    
    HeapFree GetProcessHeap(), 0, lngASTAT
    
    End If

MACAddress = strOut

End Function
Public Function NetworkUserName() As String
Dim lStrBuffer        As String * 25
Dim lLngReturnValue   As Long

lLngReturnValue = GetUserName(lStrBuffer, 25)
NetworkUserName = Left(lStrBuffer, InStr(lStrBuffer, Chr(0)) - 1)

End Function
Public Function MachineName() As String
Dim lStrBuffer As String * 255

    If GetComputerNameA(lStrBuffer, 255&) > 0 Then
    MachineName = Left$(lStrBuffer, InStr(lStrBuffer, vbNullChar) - 1)
    Else
    MachineName = "?"
    End If

End Function
