Attribute VB_Name = "ModDynaForm"
Option Private Module
Option Explicit

Public Type UsrListViewColumn: Field As String: Relation As String: CorrectField As String: Format As String: End Type
Public Type userEntityFormDynamicDATA: ColumnCount As Integer: Column(12) As UsrListViewColumn: End Type
Public Enum UsrOpCode: OC_Add = 1: OC_Edit = 2: OC_Del = 3: OC_AddAll = 4: OC_EditAll = 5: OC_DelAll = 6: OC_LOGIN = 7: OC_Logout = 8: OC_ChangeRels = 9: OC_PrintReport: End Enum
Public Enum ESEF: SEF_Visible = 0: SEF_NoVisible = 1: End Enum
Public Enum uDFButtons: DFB_Add = 0: DFB_Edit = 1: DFB_Del = 2: DFB_Search = 3: DFB_Print = 4: DFB_Functions = 5: DFB_Relations = 6: DFB_Minimize = 7: End Enum
Public Enum uEntityStatus: uEntityStatus_Wait = 0: uEntityStatus_Load = 1: uEntityStatus_Edit = 2: uEntityStatus_Close = 3: uEntityStatus_Error = 4: uEntityStatus_Lock = 5: uEntityStatus_Ok = 6: uEntityStatus_Assembling = 7: End Enum
Public Type usrXField: uName As String: Alias As String: ExternalField As String: ExternalID As Long: ExternalRelation As String: ShowOrder As Integer: PlaceOrder As Integer: EntryRestriction As DataTypeEnum: EntrySize As Byte: CanFilter As Boolean: Length As Integer: EntryFormat As String: End Type
Public Type EditSet: Alias As String: name As String: EntryRestriction As DataTypeEnum: Relation As String: EntrySize As Byte: Control As Control: LabelControl As Label: ShadowControl As Label: EntryFormat As String: End Type
Public Type QuerySet: Use As Boolean: Alias As String: name As String: EntryRestriction As DataTypeEnum: Relation As String: RelationName As String: EntrySize As Byte: OrderType As Byte: Kind As Byte: SPEC As String: frameControl As Frame: UseControl As CheckBox: LabelControl As Label: KindControl As ComboBox: SPECControl As Control: OrderControl As ComboBox: InternalSpec As Boolean: End Type
Public Enum DFOpMode: OM0BrowseCommon = 0: OM1New = 1: OM2Edit = 2: OM3Del = 3: OM4Search = 4: OM5ContinuousEdit = 5: OM6DedicatedMenu = 6: OM7BrowseTiny = 7: End Enum

Public Type Entity
    Form As New frmDynaForm
    Index As Integer
    FatherID As Long
    IsShownOnMenu As Boolean
    IsLog As Boolean
    IsUser As Boolean
    IsSystem As Boolean
    IsImage As Boolean
    name As String
    TableName As String
    TableObject As Recordset
    ReadOnly As Boolean
    ForcedFromClause As String
    ForcedWhereClause As String
    SearchField As String
    Status As uEntityStatus
    SQLdefs As SQLPattern
    CurrentUpdateID As Long
    Field() As usrXField
    QueryFields() As QuerySet
    EditFields() As EditSet
    RecCount As Long
    IsFirstLoad As Boolean
    ForceLoadStop As Boolean
    ReloadCount As Long
    OpMode As DFOpMode
    OpModeDefaultBrowseStyle As DFOpMode
    RemoteLink As Label
    End Type

Function GetEntExtRel(ByVal EntityID As Long, uField As String) As String
Dim Counter As Integer

    For Counter = 0 To UBound(Entities(EntityID).Field) - 1
    
        If Entities(EntityID).Field(Counter).uName = uField Then
        GetEntExtRel = Entities(EntityID).Field(Counter).ExternalField
        Exit Function
        End If
    
    Next Counter
    
End Function

Function GetEntRegStatus(ByVal EntCode As Long, uId As Long) As Byte
On Error GoTo GetEntRegStatus_Err

Dim uBasis As Byte

    If Entities(EntCode).IsImage Then

'    AppTables.ImageRel.Index = "ImageRec"
'    AppTables.ImageRel.Seek "=", uId
    uBasis = 4

    Else
'    AppTables.ImageRel.Index = "EntityRec"
'    AppTables.ImageRel.Seek "=", Entities(EntCode).Index, uId
    
    End If

'    If AppTables.ImageRel.NoMatch Then uBasis = 2
    If Not Entities(EntCode).ReadOnly Then Inc uBasis

GetEntRegStatus = uBasis + 1

Exit Function
GetEntRegStatus_Err:
ErrH , "Function GetEntRegStatus"
Exit Function

End Function
Function GetEntFieldsByID(ByVal NTable As String, NField As String, NValue As Long, ParamArray OptionalFields()) As String
On Error Resume Next

Dim Counter As Integer, BMark As Variant, Count As Integer, Output As String, RS As Recordset
              
Counter = GetEntIDByTable(NTable)
    
    With Entities(Counter)
    
        If .Status <> uEntityStatus_Ok Then EntLoad Counter, 1
    
    Set RS = .TableObject
    
    BMark = RS.Bookmark
    RS.Index = "SearchKey"
    RS.Seek "=", NValue
    
        If .TableObject.NoMatch Then .TableObject.Bookmark = BMark: Error 5000
        
    Output = ValidStr(RS.Fields(NField))
    
        Do
        
            If OptionalFields(Count) = "" Then
            GetEntFieldsByID = Output
            Exit Do
            End If
            
        Output = Output & Chr$(0) & ValidStr(RS.Fields(OptionalFields(Count)))
        Count = Count + 1
            
        Loop
    
        If AppSetts.ConnectionType <> ADCD_Remote Then
        .TableObject.Bookmark = BMark
        End If
    
    End With

GetEntFieldsByID = Output

End Function
Sub CheckUpdateNecessity(ByVal EntCode As Long, Code As UsrOpCode, ID As Long)
On Error GoTo CheckUpdateNecessity_Err

Dim UpdtID As Long, RS As Recordset, tmpSQL As String
    
If EntCode <> LogTable() Then RegLog EntCode, Code
If (Code = OC_Add Or Code = OC_Del Or Code = OC_Edit) And ID = 0 Then Exit Sub
    
    With AppTables
    
        .EntitiesLog.AddNew
        .EntitiesLog("ID_ENTITY") = EntCode
        .EntitiesLog("ID_OPCODE") = Code
        .EntitiesLog("REFERENCE_ID") = ID
        
        UpdtID = .EntitiesLog("ID_ENTITYUPDATE")
        .EntitiesLog.Update
        
        Set RS = .EntitiesTables
        RS.Index = "SearchKey"
        RS.Seek "=", EntCode
            
        RS.Edit
        RS("CURRENTUPDATEID") = UpdtID
        RS.Update
        
    End With
            
Exit Sub
CheckUpdateNecessity_Err:
ErrH App.ProductName & " code library", "Sub CheckUpdateNecessity"
Exit Sub
End Sub
Function GetEntIDByTable(ByVal N As String) As Long
On Error GoTo GetEntIDByTable_Err

Dim Counter As Integer

    For Counter = 0 To AppSetts.EntityCount
        
        If Entities(Counter).TableName = N Then
        GetEntIDByTable = Counter
        Counter = AppSetts.EntityCount
        Exit Function
        End If
    
    Next Counter

Exit Function
GetEntIDByTable_Err:
ErrH App.ProductName & " code library", "Function GetEntIDByTable"
Exit Function
End Function

Function GetEntUserTableID() As Long
On Error GoTo GetEntUserTableID_Err

Dim Counter As Integer

    For Counter = 0 To AppSetts.EntityCount
        
        If Entities(Counter).IsUser Then
        GetEntUserTableID = Counter
        Counter = AppSetts.EntityCount
        Exit Function
        End If
    
    Next Counter

Exit Function
GetEntUserTableID_Err:
ErrH App.ProductName & " code library", "Function GetEntUserTableID"
Exit Function
End Function
Function GetEntIDByTableID(ByVal ID As Long) As Long
On Error GoTo GetEntIDByTableID_Err

Dim Counter As Integer

    For Counter = 0 To AppSetts.EntityCount
        
        If Entities(Counter).Index = ID Then
        GetEntIDByTableID = Counter
        Counter = AppSetts.EntityCount
        Exit Function
        End If
    
    Next Counter

Exit Function
GetEntIDByTableID_Err:
ErrH App.ProductName & " code library", "Function GetEntIDByTableID"
Exit Function
End Function


Function GetEntTableByAlias(ByVal N As String) As String
On Error GoTo GetEntTableByAlias_Err

Dim Counter As Integer

    For Counter = 0 To AppSetts.EntityCount
        
        If Entities(Counter).name = N Then
        GetEntTableByAlias = Entities(Counter).TableName
        Counter = AppSetts.EntityCount
        Exit Function
        End If
    
    Next Counter

Exit Function
GetEntTableByAlias_Err:
ErrH App.ProductName & " code library", "Function GetEntTableByAlias"
Exit Function
End Function

Function GetEntFirstField(ByVal nTABLENAME As String) As String
On Error GoTo GetEntFirstField_Err

Dim Counter As Integer, Counter2 As Integer

    Select Case nTABLENAME
    Case "Sys_Entities"
    GetEntFirstField = "NAME"
    Exit Function
    
    Case "SYS_OPERATIONALCODES"
    GetEntFirstField = "DESCR"
    Exit Function
    
    Case "AUX_TIPOSCALCULO"
    GetEntFirstField = "DESCR"
    Exit Function
    
    End Select
    
    For Counter = 0 To AppSetts.EntityCount
        
        If Entities(Counter).TableName = nTABLENAME Then
        
            For Counter2 = 0 To 16
                
                If Entities(Counter).Field(Counter2).ShowOrder Mod 64 = 1 Then
                GetEntFirstField = Entities(Counter).Field(Counter2).uName
                Counter2 = 16
                
                End If
            
            Next Counter2
        
        Counter = AppSetts.EntityCount
        End If
        
    Next Counter

Exit Function
GetEntFirstField_Err:
ErrH App.ProductName & " code library", "Function GetEntFirstField"
Exit Function
End Function
Function GetForeignDATA(ByVal ForeignField As String, ForeignTable As String, LocalValue As String, Optional SearchField As String) As String
On Error GoTo GetForeignDATA_Err

Dim Rec As Recordset, SQL As String, N As String

If SearchField = "" Then N = GetIDFieldName(ForeignTable) Else N = SearchField

SQL = "SELECT [" & ForeignField & "] FROM " & ForeignTable & " WHERE [" & N & "] = " & LocalValue & ";"
Set Rec = GlobalDB.OpenRecordset(SQL)
GetForeignDATA = ValidStr(Rec(ForeignField))

Exit Function
GetForeignDATA_Err:

    If Err.number = 3464 Then
    SQL = "SELECT [" & ForeignField & "] FROM " & ForeignTable & " WHERE [" & N & "] = '" & LocalValue & "';"
    Resume
    End If

ErrH App.ProductName & " code library", "Function GetForeignDATA"

Exit Function
End Function

Sub EntLoadSpecMenus(ByVal N As Long, M As Object)
On Error GoTo EntLoadSpecMenus_Err

Dim M2 As Object

    Select Case N
'    Case GSQL.DB_Entity_LOGOPERACIONAL
'    Load M(M.Count)
'    M(M.Count - 1).Caption = "Limpar Log &operacional"
    
'    Case AppSetts.EntityCount
'    Load M(M.Count)
'    M(M.Count - 1).Caption = "Realizar novo LOGIN"
        
    End Select
    
Exit Sub
EntLoadSpecMenus_Err:
ErrH App.ProductName & " code library", "Sub EntLoadSpecMenus"
Exit Sub

End Sub
Sub EntTrgItemClick(ByVal EntCode As Integer)

End Sub
Sub ProccessEntMenu(ByVal uEntity As Long, uItem As Integer)
On Error GoTo ProccessEntMenu_Err

    Select Case uEntity
    
    End Select

Exit Sub
ProccessEntMenu_Err:
ErrH App.ProductName & " code library", "Sub ProccessEntMenu"
Exit Sub

End Sub
Sub ProccessFunctionMenu(ByVal uEntity As Long, uItem As Integer)
On Error GoTo ProccessFunctionMenu_Err

    Select Case uItem
    
    End Select

Exit Sub
ProccessFunctionMenu_Err:
ErrH App.ProductName & " code library", "Sub ProccessSPECialMenu"
Exit Sub

End Sub


Function LogTable()
Dim Counter As Integer

    For Counter = 0 To AppSetts.EntityCount
    
        If Entities(Counter).IsLog Then
        LogTable = Entities(Counter).Index
        Counter = AppSetts.EntityCount
        End If
        
    Next Counter

End Function
Function UserTable()
Dim Counter As Integer

    For Counter = 0 To AppSetts.EntityCount
    
        If Entities(Counter).IsUser Then
        UserTable = Entities(Counter).Index
        Counter = AppSetts.EntityCount
        End If
        
    Next Counter

End Function

Sub RegLog(ByVal EntCode As Integer, Code As UsrOpCode)
On Error GoTo Sub_Err

Dim RS As Recordset, ID As Long
Set RS = GlobalDB.OpenRecordset("TBLOGOPERACIONAL")
RS.AddNew

ID = RS("IDLOG")

RS("IDUSUARIO") = AppSetts.Login.ID
RS("ID_ENTITY") = EntCode
RS("ID_OPCODE") = Code
RS("DH") = Now()
RS.Update

CheckUpdateNecessity LogTable(), OC_Add, ID

Exit Sub
Sub_Err:
ErrH App.ProductName & " code library", "Sub Sub"
Exit Sub

End Sub
Sub SetCorrectIndex(ByRef TRset As Recordset)
On Error GoTo SetCorrectIndex_Err

TRset.Index = "SearchKey"

Exit Sub
'Apenas para suporte a antigas verses...

Dim Counter As Integer, TDef As TableDef, Counter2 As Integer

    For Counter = 0 To GlobalDB.TableDefs.Count - 1
    
        If GlobalDB.TableDefs(Counter).name = TRset.name Then
        Set TDef = GlobalDB.TableDefs(Counter)
        Counter = GlobalDB.TableDefs.Count - 1
        End If
        
    Next Counter

    For Counter = 0 To TDef.Indexes.Count - 1
    
        If TDef.Indexes(Counter).Primary Then
        TRset.Index = TDef.Indexes(Counter).name
        Counter = TDef.Indexes.Count - 1
        End If
        
    Next Counter

Exit Sub
SetCorrectIndex_Err:
ErrH App.ProductName & " code library", "Sub SetCorrectIndex"
Exit Sub
End Sub
Sub EntLoad(ByVal bytEntity As Long, Optional N As ESEF)
On Error GoTo EntLoad_Err

Dim Msg As String

    If AppSetts.Login.Status = LSD_NoUser Then
    Msg = "     No  possvel exibir a lista de " & _
    Entities(bytEntity).name & _
    ": Nenhum usurio realizou LOGIN." & Chr$(13) & Chr$(10) & _
    "     Deseja informar o usurio para LOGIN agora?"
    
        Select Case XMsgBox(Msg, , XMBB_YesNo, XMB_Warn)
        
        Case 1
        Call Login
        Exit Sub
        
        Case 2
        Exit Sub
        
        End Select
    
    End If

Entities(bytEntity).Form.Initialize bytEntity, N

Exit Sub
EntLoad_Err:
ErrH App.ProductName & " code library", "Sub EntLoad"
Exit Sub
End Sub
Function GetEntIDField(ByVal N As Long) As String
On Error GoTo GetEntIDField_Err

Dim Counter As Integer, Counter2 As Integer

    For Counter2 = 0 To 16
    
        If Entities(N).Field(Counter2).ShowOrder And 64 Then
        GetEntIDField = Entities(N).Field(Counter2).uName
        Counter2 = 16
        End If
    
    Next Counter2

Exit Function
GetEntIDField_Err:
ErrH App.ProductName & " code library", "Function GetEntIDField"
Exit Function
End Function
Function GetIDFieldName(ByVal N As String) As String
On Error GoTo GetIDFieldName_Err

Dim Counter As Integer, Counter2 As Integer, tmpTblDef As TableDef, ExtCount As Integer, tmpIdx As Index

    Select Case N
    Case "Sys_Entities"
    GetIDFieldName = "ID_ENTITY"
    Exit Function
    
    Case "SYS_OPERATIONALCODES"
    GetIDFieldName = "ID_OPCODE"
    Exit Function
    
    End Select
    
    If Val(N) <> 0 Then N = Entities(Val(N)).TableName

    Set tmpTblDef = GlobalDB.TableDefs(N)
    
        For Counter = 0 To tmpTblDef.Indexes.Count - 1
        
            If tmpTblDef.Indexes(Counter).name = "SearchKey" Then
            ExtCount = Counter
            Set tmpIdx = tmpTblDef.Indexes(Counter)
            GetIDFieldName = tmpIdx.Fields(0).name
            Counter = tmpTblDef.Indexes.Count - 1
            End If
        
        Next Counter
    
Exit Function
GetIDFieldName_Err:
ErrH App.ProductName & " code library", "Function GetIDFieldName"
Exit Function
End Function
Function GetEntFieldFormat(ByVal N As String, M As String) As String
On Error GoTo GetEntFieldFormat_Err

Dim Counter As Integer, Counter2 As Integer, tmpTblDef As TableDef, ExtCount As Integer, tmpIdx As Index

    If Val(N) <> 0 Then N = Entities(Val(N)).TableName

    For Counter = 1 To AppSetts.EntityCount
        
        If N = Entities(Counter).TableName Then
        
            For Counter2 = 0 To 16
            
                If Entities(Counter).Field(Counter2).uName = M Then
                GetEntFieldFormat = Entities(Counter).Field(Counter2).EntryFormat
                Counter2 = 16
                End If
            
            Next Counter2
            
        Counter = AppSetts.EntityCount
        End If
    Next Counter

Exit Function
GetEntFieldFormat_Err:
ErrH App.ProductName & " code library", "Function GetEntFieldFormat"
Exit Function

End Function
Function ShowVldtionErrMSG(ByVal N As ErrObject, ByVal NEnt As Integer) As Boolean

Dim Counter As Integer, Mark1 As Integer, Mark2 As Integer, SPEC(10) As String

ShowVldtionErrMSG = False
    Select Case Err.number
    
    Case 3200
    Mark1 = InStr(1, N.DESCRiption, "'")
    Mark2 = InStr(Mark1 + 1, N.DESCRiption, "'")
    SPEC(0) = Mid$(N.DESCRiption, Mark1 + 1, (Mark2 - Mark1) - 1)
    
            For Counter = 0 To AppSetts.EntityCount

                If Entities(Counter).TableName = SPEC(0) Then
                SPEC(1) = Entities(Counter).name
                Counter = AppSetts.EntityCount
                End If

            Next Counter
            
    ShowVldtionErrMSG = True
    
    XMsgBox "     O registro, ou um dos registros indicados, no pode ser excludo ou modificado." & _
    " Existem registros em " & SPEC(1) & " que fazem menes ao(s) registros." & Chr$(13) & Chr$(10) & _
    "      necessria a excluso dos registros em " & SPEC(1) & " em primeiro lugar.", , XMBB_Ok, XMB_Search
    
    Case 3156
    XMsgBox "     O ambiente Oracle emitiu um alerta sobre a impossibilidade de excluso, " & _
    "porm no forneceu informaes adicionais. Provavelmente a excluso foi limitada pela " & _
    "existncia de registros em outras tabelas que no podem ser excludos em cascata; " & _
    "Verifique as ligaes entre as entidades relacionadas, exclua os registros desejados e " & _
    "tente a operao de novo.", , XMBB_Ok, XMB_Search
    
    ShowVldtionErrMSG = True
    
    Case 3155
    XMsgBox "     O ambiente Oracle emitiu um alerta sobre a impossibilidade de incluso, " & _
    "porm no forneceu informaes adicionais. Provavelmente a incluso foi limitada pela " & _
    "falta de dados no registro, ou existncia no cadastro de um registro similar; " & _
    "Verifique as ligaes entre as entidades relacionadas, informe os dados corretamente e " & _
    "tente a operao de novo.", , XMBB_Ok, XMB_Search
    
    ShowVldtionErrMSG = True
    
    End Select

End Function
Function EntityMemID(ByVal uEntTableID As Long) As Long
Dim Counter As Long

    For Counter = 0 To AppSetts.EntityCount
        
        If Entities(Counter).Index = uEntTableID Then
        EntityMemID = Counter
        Counter = AppSetts.EntityCount
        End If
        
    Next Counter

End Function

Function EntTrgMethodStart(ByVal N As Long, ByVal M As uDFButtons) As Boolean
On Error GoTo EntTrgMethodStart_Err

EntTrgMethodStart = False

'    If UCase(Entities(N).TableName) = "TBIMAGES" And (M = DFB_Add) Then
'    EntTrgMethodStart = True
    
'        If M = 0 Then frmUsuarios.Initialize
'        If M = 1 Then frmUsuarios.LoadDATA
    
'    End If

Exit Function
EntTrgMethodStart_Err:
ErrH App.ProductName & " code library", "Function EntTrgMethodStart"
Exit Function
End Function
Sub ValidateEntityKeyPress(ByRef ctlN As Control, intKey As Integer)
On Error GoTo ValidateEntityKeyPress_Err

Dim intKind As Integer, bolDoNotUpdate

intKind = Val(Right$(ctlN.Tag, Len(ctlN.Tag) - InStr(ctlN.Tag, Chr$(0))))

    Select Case intKind
    
    Case dbLong, dbBigInt, dbByte, dbInteger, dbLong, dbLongBinary, dbVarBinary
            If (intKey >= 64) Or (intKey >= 32 And intKey <= 47) Then
            intKey = 0
            End If
    
    Case dbCurrency, dbDecimal, dbDouble, dbFloat, dbNumeric, dbSingle
            If (intKey >= 64) Or ((intKey >= 32 And intKey <= 47) And (intKey <> 44) And (intKey <> 46)) Then
            intKey = 0
            End If
            
    Case dbTime, dbTimeStamp, dbDate
            If (intKey >= 64) Or (intKey >= 32 And intKey < 47) Then
            intKey = 0
            End If
            
    Case dbChar, dbMemo, dbText
    
    End Select

    If intKey >= 32 Then
        If Val(ctlN.Tag) = Len(Trim(ctlN.Text)) Then
        intKey = 0
        End If
    End If

Exit Sub
ValidateEntityKeyPress_Err:
ErrH App.ProductName & " code library", "Sub ValidateEntityKeyPress"
Exit Sub
End Sub
Sub ResetDragLabel(ByRef N As Label)
On Error GoTo ResetDragLabel_Err

N.Caption = "Dado no informado"
N.Tag = 0

Exit Sub
ResetDragLabel_Err:
ErrH App.ProductName & " code library", "Sub ResetDragLabel"
Exit Sub

End Sub
Sub showFunctionMnuToEntity(ByVal L As Form, ByVal N As Long)
On Error GoTo showFunctionMnuToEntity_Err

Exit Sub
showFunctionMnuToEntity_Err:
ErrH App.ProductName & " code library", "Sub showFunctionMnuToEntity"
Exit Sub
End Sub

