VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Machine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "Member0" ,"Ambient"
Attribute VB_Ext_KEY = "Member1" ,"User"
Option Explicit

'local variable(s) to hold property value(s)
Public OnParse As Boolean 'If set, no database updates will be made.
Private mvarID As Long 'Local Copy
Private mvarAmbient As Ambient 'Local Copy
Private mvarIpaddress As String 'Local Copy
Private mvarMACAddress As String 'Local Copy
Private mvarNetname As String 'Local Copy
Private mvarSign As String 'Local Copy
'local variable(s) to hold property value(s)
Private mvarStatus As Long 'local copy
Private mvarLastStatusUpdate As Long 'local copy

    Public Enum u_MachineStatus
    MSDisconnected = 0
    MSReceivingFile = 1
    MSOnError = 2
    MSOnUse = 3
    MSLocked = 4
    End Enum
Public Property Get LastStatusUpdate() As Long
    LastStatusUpdate = mvarLastStatusUpdate
End Property
Public Property Let Status(ByVal vData As u_MachineStatus)
'Dim uSQL As String, uRS As Recordset
mvarLastStatusUpdate = GetTickCount()

    If (OnParse) Then Exit Property

    If mvarStatus = vData Then Exit Property

mvarStatus = vData

    If TypeName(Data.Machine_Statuses.SeekMachine(Data.Machines.SeekID(mvarID))) = "Nothing" Then
    Dim uNewMachine_status As New Machine_Status
    uNewMachine_status.OnParse = True
        
        With uNewMachine_status
        Set .Machine = Data.Machines.SeekID(mvarID)
        End With
    
    Data.Machine_Statuses.Add uNewMachine_status
    End If
    
Data.Machine_Statuses.SeekMachine(Data.Machines.SeekID(mvarID)).machine_status_def = vData
    
Call RegMachineEvent(mvarMACAddress)

End Property
Public Property Get Status() As u_MachineStatus
Status = mvarStatus
End Property
Public Sub QueryID()
ScreenLock False
Send mvarIpaddress, "QUERYID"
End Sub
Public Sub TurnOff()
Send mvarIpaddress, "TURNOFF"
End Sub
Public Sub SetUpdateRate(uRate As String)
Send mvarIpaddress, "UPDATERATE|" & uRate
End Sub
Public Sub SetTime(ByVal uTime As String)
Send mvarIpaddress, "SETTIME|" & Now()
End Sub
Public Sub ScreenLock(ByVal Status As Boolean)

    Select Case Status
    Case True
    Send mvarIpaddress, "LOCK"
    
    Case False
    Send mvarIpaddress, "UNLOCK"
    
    End Select
    
End Sub
Public Sub Reboot()
Send mvarIpaddress, "SHUTANDLOAD"
End Sub
Public Sub LogOff()
Send mvarIpaddress, "LOGOFF"
End Sub
Public Sub KillNeuron()
Send mvarIpaddress, "SHUTDOWN"
End Sub
Public Sub Ping()
Send mvarIpaddress, "PING?"
End Sub
Public Sub SetResolution(ByVal uWidth As Integer, ByVal uHeight As Integer, Optional uBitDepth As Byte)
Send mvarIpaddress, "SETRESOLUTION|" & uWidth & "|" & uHeight & "|" & uBitDepth
End Sub
Public Property Let ID(ByVal pData As Long)
On Error GoTo ErrHPropLetID

    If ID <> 0 Then
    Err.Raise &H5001, "Machine Item Class", "Couldn't change [ID] field value after initial setting."
    Exit Property
    End If
mvarID = pData
Exit Property
ErrHPropLetID:
Err.Raise Err.number, Err.Source, "Property Let ID (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Set Ambient(ByVal pData As Ambient)
On Error GoTo ErrHPropSetAmbient

    If (Not OnParse) And (mvarMACAddress <> "") Then
    Data.Database.Execute "UPDATE [Machine] SET [AmbientID]=" & pData.ID & " WHERE [MACAddress] = '" & mvarMACAddress & "'"
    End If
Set mvarAmbient = pData
Exit Property
ErrHPropSetAmbient:
Err.Raise Err.number, Err.Source, "Property Set Ambient (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Ipaddress(ByVal pData As String)
On Error GoTo ErrHPropLetIpaddress

    If (Not OnParse) And (mvarMACAddress <> "") Then
    Data.Database.Execute "UPDATE [Machine] SET [Ipaddress]='" & pData & "' WHERE [MACAddress] = '" & mvarMACAddress & "'"
    End If
mvarIpaddress = pData
Exit Property
ErrHPropLetIpaddress:
Err.Raise Err.number, Err.Source, "Property Let Ipaddress (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Macaddress(ByVal pData As String)
On Error GoTo ErrHPropLetMacaddress

    If mvarMACAddress <> "" Then
    Err.Raise &H5001, "Machine Item Class", "Couldn't change [Macaddress] field value after initial setting."
    Exit Property
    End If
mvarMACAddress = pData
Exit Property
ErrHPropLetMacaddress:
Err.Raise Err.number, Err.Source, "Property Let Macaddress (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Netname(ByVal pData As String)
On Error GoTo ErrHPropLetNetname

    If (Not OnParse) And (mvarMACAddress <> "") Then
    Data.Database.Execute "UPDATE [Machine] SET [Netname]='" & pData & "' WHERE [MACAddress] = '" & mvarMACAddress & "'"
    End If
mvarNetname = pData
Exit Property
ErrHPropLetNetname:
Err.Raise Err.number, Err.Source, "Property Let Netname (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Sign(ByVal pData As String)
On Error GoTo ErrHPropLetSign

    If (Not OnParse) And (mvarMACAddress <> "") Then
    Data.Database.Execute "UPDATE [Machine] SET [Sign]='" & pData & "' WHERE [MACAddress] = '" & mvarMACAddress & "'"
    End If
mvarSign = pData
Exit Property
ErrHPropLetSign:
Err.Raise Err.number, Err.Source, "Property Let Sign (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Get ID() As Long
ID = mvarID
End Property
Public Property Get Ambient() As Ambient
Set Ambient = mvarAmbient
End Property
Public Property Get Ipaddress() As String
Ipaddress = mvarIpaddress
End Property
Public Property Get Macaddress() As String
Macaddress = mvarMACAddress
End Property
Public Property Get Netname() As String
Netname = mvarNetname
End Property
Public Property Get Sign() As String
Sign = mvarSign
End Property
