VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Shop_queue"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"Shop"
Attribute VB_Ext_KEY = "Member1" ,"User"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'================================================================================================
'Shop_queue Member Class
'================================================================================================

Option Explicit

'local variable(s) to hold property value(s)
Public OnParse As Boolean 'If set, no database updates will be made.
Private mvarID As Long 'Local Copy
Private mvarShop As Shop 'Local Copy
Private mvarUser As User 'Local Copy
Private mvarVolatilename As String 'Local Copy
Private mvarDescr As String 'Local Copy
Private mvarGrouptempkey As String 'Local Copy
Private mvarArrivaldt As Date 'Local Copy
Private mvarServicedt As Date 'Local Copy
Private mvarProcessed As Boolean 'Local Copy

Public Property Let ID(ByVal pData As Long)
On Error GoTo ErrHPropLetID
Dim uEval As String

    If mvarID <> 0 Then
    Err.Raise &H5001, "Shop_queue Item Class", "Couldn't change [ID] field value after initial setting."
    Exit Property
    End If

mvarID = pData

Exit Property
ErrHPropLetID:
Err.Raise Err.number, Err.Source, "Property Let ID (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Set Shop(ByVal pData As Shop)
On Error GoTo ErrHPropSetShop
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then

        If TypeName(pData) = "Nothing" Then uEval = "null" Else uEval = pData.ID

    Data.Database.Execute "UPDATE [Shop_queue] SET [ShopID]=" & uEval & " WHERE [ID]=" & mvarID
    End If

Set mvarShop = pData

Exit Property
ErrHPropSetShop:
Err.Raise Err.number, Err.Source, "Property Set Shop (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Set User(ByVal pData As User)
On Error GoTo ErrHPropSetUser
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then

        If TypeName(pData) = "Nothing" Then uEval = "null" Else uEval = pData.ID

    Data.Database.Execute "UPDATE [Shop_queue] SET [UserID]=" & uEval & " WHERE [ID]=" & mvarID
    End If

Set mvarUser = pData

Exit Property
ErrHPropSetUser:
Err.Raise Err.number, Err.Source, "Property Set User (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Volatilename(ByVal pData As String)
On Error GoTo ErrHPropLetVolatilename
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = "", "null", "'" & pData & "'")
    Data.Database.Execute "UPDATE [Shop_queue] SET [Volatilename]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarVolatilename = pData

Exit Property
ErrHPropLetVolatilename:
Err.Raise Err.number, Err.Source, "Property Let Volatilename (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Descr(ByVal pData As String)
On Error GoTo ErrHPropLetDescr
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = "", "null", "'" & pData & "'")
    Data.Database.Execute "UPDATE [Shop_queue] SET [Descr]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarDescr = pData

Exit Property
ErrHPropLetDescr:
Err.Raise Err.number, Err.Source, "Property Let Descr (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Grouptempkey(ByVal pData As String)
On Error GoTo ErrHPropLetGrouptempkey
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = "", "null", "'" & pData & "'")
    Data.Database.Execute "UPDATE [Shop_queue] SET [Grouptempkey]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarGrouptempkey = pData

Exit Property
ErrHPropLetGrouptempkey:
Err.Raise Err.number, Err.Source, "Property Let Grouptempkey (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Arrivaldt(ByVal pData As Date)
On Error GoTo ErrHPropLetArrivaldt
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = "", "null", "#" & pData & "#")
    Data.Database.Execute "UPDATE [Shop_queue] SET [Arrivaldt]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarArrivaldt = pData

Exit Property
ErrHPropLetArrivaldt:
Err.Raise Err.number, Err.Source, "Property Let Arrivaldt (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Servicedt(ByVal pData As Date)
On Error GoTo ErrHPropLetServicedt
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = "", "null", "#" & pData & "#")
    Data.Database.Execute "UPDATE [Shop_queue] SET [Servicedt]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarServicedt = pData

Exit Property
ErrHPropLetServicedt:
Err.Raise Err.number, Err.Source, "Property Let Servicedt (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Processed(ByVal pData As Boolean)
On Error GoTo ErrHPropLetProcessed
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = 0, "null", pData)
    Data.Database.Execute "UPDATE [Shop_queue] SET [Processed]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarProcessed = pData

Exit Property
ErrHPropLetProcessed:
Err.Raise Err.number, Err.Source, "Property Let Processed (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Get ID() As Long
ID = mvarID
End Property
Public Property Get Shop() As Shop
Set Shop = mvarShop
End Property
Public Property Get User() As User
Set User = mvarUser
End Property
Public Property Get Volatilename() As String
Volatilename = mvarVolatilename
End Property
Public Property Get Descr() As String
Descr = mvarDescr
End Property
Public Property Get Grouptempkey() As String
Grouptempkey = mvarGrouptempkey
End Property
Public Property Get Arrivaldt() As Date
Arrivaldt = mvarArrivaldt
End Property
Public Property Get Servicedt() As Date
Servicedt = mvarServicedt
End Property
Public Property Get Processed() As Boolean
Processed = mvarProcessed
End Property

