VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Shop_queues"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'================================================================================================
'Shop_queues Collection
'================================================================================================

Option Explicit

'local variable to hold collection
Private mCol As Collection
Public Function Add(ByVal uShop_queue As Shop_queue) As Shop_queue
Dim lObjRS As Recordset, lStrSQL As String

    With uShop_queue
        If False Then
        Err.Raise &H5002, "Shop_queues Collection", "Couldn't insert Item: Essential info missing."
        Exit Function
        End If

    Set lObjRS = Data.Database.Execute("SELECT * FROM [Shop_queue] WHERE [ID]=" & .ID)

        If Not lObjRS.EOF Then
        Err.Raise &H5003, "Shop_queues Collection", "Couldn't insert Item: trying to replicate Unique Identifier field [ID]."
        Exit Function
        End If

Dim uTmpShop As String, _
uTmpUser As String, _
uTmpVolatilename As String, _
uTmpDescr As String, _
uTmpGrouptempkey As String, _
uTmpArrivaldt As String, _
uTmpServicedt As String, _
uTmpProcessed As String

    If TypeName(.Shop) = "Nothing" Then uTmpShop = "null" Else uTmpShop = .Shop.ID
    If TypeName(.User) = "Nothing" Then uTmpUser = "null" Else uTmpUser = .User.ID
uTmpVolatilename = IIf(.Volatilename = "", "null", "'" & .Volatilename & "'")
uTmpDescr = IIf(.Descr = "", "null", "'" & .Descr & "'")
uTmpGrouptempkey = IIf(.Grouptempkey = "", "null", "'" & .Grouptempkey & "'")
uTmpArrivaldt = IIf(.Arrivaldt = "", "null", "#" & .Arrivaldt & "#")
uTmpServicedt = IIf(.Servicedt = "", "null", "#" & .Servicedt & "#")
uTmpProcessed = IIf(.Processed = 0, "0", .Processed)

    lStrSQL = "INSERT INTO [Shop_queue] ([ShopID], [UserID], [Volatilename], [Descr], [Grouptempkey], [Arrivaldt], [Servicedt], [Processed]) VALUES (" & _
    uTmpShop & ", " & _
    uTmpUser & ", " & _
    uTmpVolatilename & ", " & _
    uTmpDescr & ", " & _
    uTmpGrouptempkey & ", " & _
    uTmpArrivaldt & ", " & _
    uTmpServicedt & ", " & _
    uTmpProcessed & ")"

    Data.Database.Execute lStrSQL
    Set lObjRS = Data.Database.Execute("SELECT TOP 1 ID FROM [Shop_queue] ORDER BY ID DESC")
    .ID = lObjRS("ID")

    mCol.Add uShop_queue, "N" & uShop_queue.ID

    Set Add = uShop_queue
    Set uShop_queue = Nothing

    End With

End Function
Public Property Get Item(vntIndexKey As Variant) As Shop_queue
Set Item = mCol(vntIndexKey)
End Property
Public Property Get Count() As Long
Count = mCol.Count
End Property
Public Sub Remove(vntIndexKey As Variant)
Dim lObjRS As Recordset, lStrSQL As String, lShop_queue As Shop_queue
Set lShop_queue = mCol(vntIndexKey)
Data.Database.Execute "DELETE FROM [Shop_queue] WHERE [ID]=" & lShop_queue.ID
mCol.Remove vntIndexKey
End Sub
Public Property Get NewEnum() As IUnknown
Set NewEnum = mCol.[_NewEnum]
End Property
Private Sub Class_Initialize()
Set mCol = New Collection
Call LoadItems
End Sub
Private Sub Class_Terminate()
Set mCol = Nothing
End Sub
Private Sub LoadItems()
Dim lObjRS As Recordset, lClsShop_queue As Shop_queue
Set lObjRS = Data.Database.Execute("SELECT * FROM [Shop_queue]")

    Do While Not lObjRS.EOF
    Set lClsShop_queue = New Shop_queue

        With lClsShop_queue
        .OnParse = True
        .ID = ValidNum(lObjRS("ID"))
        If Not IsNull(lObjRS("ShopID")) Then Set .Shop = Data.Shops.SeekID(lObjRS("ShopID"))
        If Not IsNull(lObjRS("UserID")) Then Set .User = Data.Users.SeekID(lObjRS("UserID"))
        .Volatilename = ValidStr(lObjRS("Volatilename"))
        .Descr = ValidStr(lObjRS("Descr"))
        .Grouptempkey = ValidStr(lObjRS("Grouptempkey"))
        .Arrivaldt = (lObjRS("Arrivaldt"))
        .Servicedt = (lObjRS("Servicedt"))
        .Processed = (lObjRS("Processed"))
        .OnParse = False
        End With

    mCol.Add lClsShop_queue, ValidStr("N" & lObjRS("ID"))
    lObjRS.MoveNext
    Loop

End Sub
Public Function SeekID(uParm As Long) As Shop_queue
Dim uItem As Shop_queue

    For Each uItem In mCol

        If uItem.ID = uParm Then
        Set SeekID = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekShop(uParm As Shop) As Shop_queue
Dim uItem As Shop_queue

    For Each uItem In mCol

        If uItem.Shop = uParm Then
        Set SeekShop = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekUser(uParm As User) As Shop_queue
Dim uItem As Shop_queue

    For Each uItem In mCol

        If uItem.User = uParm Then
        Set SeekUser = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekVolatilename(uParm As String) As Shop_queue
Dim uItem As Shop_queue

    For Each uItem In mCol

        If uItem.Volatilename = uParm Then
        Set SeekVolatilename = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekDescr(uParm As String) As Shop_queue
Dim uItem As Shop_queue

    For Each uItem In mCol

        If uItem.Descr = uParm Then
        Set SeekDescr = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekGrouptempkey(uParm As String) As Shop_queue
Dim uItem As Shop_queue

    For Each uItem In mCol

        If uItem.Grouptempkey = uParm Then
        Set SeekGrouptempkey = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekArrivaldt(uParm As Date) As Shop_queue
Dim uItem As Shop_queue

    For Each uItem In mCol

        If uItem.Arrivaldt = uParm Then
        Set SeekArrivaldt = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekServicedt(uParm As Date) As Shop_queue
Dim uItem As Shop_queue

    For Each uItem In mCol

        If uItem.Servicedt = uParm Then
        Set SeekServicedt = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekProcessed(uParm As Boolean) As Shop_queue
Dim uItem As Shop_queue

    For Each uItem In mCol

        If uItem.Processed = uParm Then
        Set SeekProcessed = uItem
        Exit Function
        End If

    Next uItem

End Function

