VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "User_Clans"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"UserDefinedCollection"
Attribute VB_Ext_KEY = "Member0" ,"User_clan"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'================================================================================================
'User_Clans Collection
'================================================================================================

Option Explicit

'local variable to hold collection
Private mCol As Collection
Public Function Add(ByVal uUser_Clan As User_clan) As User_clan
Dim lObjRS As Recordset, lStrSQL As String

    With uUser_Clan
        If False Then
        Err.Raise &H5002, "User_Clans Collection", "Couldn't insert Item: Essential info missing."
        Exit Function
        End If

    Set lObjRS = Data.Database.Execute("SELECT * FROM [User_Clan] WHERE [ID]=" & .ID)

        If Not lObjRS.EOF Then
        Err.Raise &H5003, "User_Clans Collection", "Couldn't insert Item: trying to replicate Unique Identifier field [ID]."
        Exit Function
        End If

Dim uTmpName As String, _
uTmpDescr As String, _
uTmpSponsored As String, _
uTmpFreeminperday As String, _
uTmpDiscount As String

uTmpName = IIf(.Name = "", "null", "'" & .Name & "'")
uTmpDescr = IIf(.Descr = "", "null", "'" & .Descr & "'")
uTmpSponsored = IIf(.Sponsored = 0, "0", .Sponsored)
uTmpFreeminperday = IIf(.Freeminperday = 0, "null", .Freeminperday)
uTmpDiscount = IIf(.Discount = 0, "null", .Discount)

    lStrSQL = "INSERT INTO [User_Clan] ([Name], [Descr], [Sponsored], [Freeminperday], [Discount]) VALUES (" & _
    uTmpName & ", " & _
    uTmpDescr & ", " & _
    uTmpSponsored & ", " & _
    uTmpFreeminperday & ", " & _
    uTmpDiscount & ")"

    Data.Database.Execute lStrSQL
    Set lObjRS = Data.Database.Execute("SELECT TOP 1 ID FROM [User_Clan] ORDER BY ID DESC")
    .ID = lObjRS("ID")

    mCol.Add uUser_Clan, "N" & uUser_Clan.ID

    Set Add = uUser_Clan
    Set uUser_Clan = Nothing

    End With

End Function
Public Property Get Item(vntIndexKey As Variant) As User_clan
Set Item = mCol(vntIndexKey)
End Property
Public Property Get Count() As Long
Count = mCol.Count
End Property
Public Sub Remove(vntIndexKey As Variant)
Dim lObjRS As Recordset, lStrSQL As String, lUser_Clan As User_clan
Set lUser_Clan = mCol(vntIndexKey)
Data.Database.Execute "DELETE FROM [User_Clan] WHERE [ID]=" & lUser_Clan.ID
mCol.Remove vntIndexKey
End Sub
Public Property Get NewEnum() As IUnknown
Set NewEnum = mCol.[_NewEnum]
End Property
Private Sub Class_Initialize()
Set mCol = New Collection
Call LoadItems
End Sub
Private Sub Class_Terminate()
Set mCol = Nothing
End Sub
Private Sub LoadItems()
Dim lObjRS As Recordset, lClsUser_Clan As User_clan
Set lObjRS = Data.Database.Execute("SELECT * FROM [User_Clan]")

    Do While Not lObjRS.EOF
    Set lClsUser_Clan = New User_clan

        With lClsUser_Clan
        .OnParse = True
        .ID = ValidNum(lObjRS("ID"))
        .Name = ValidStr(lObjRS("Name"))
        .Descr = ValidStr(lObjRS("Descr"))
        .Sponsored = (lObjRS("Sponsored"))
        .Freeminperday = ValidNum(lObjRS("Freeminperday"))
        .Discount = (lObjRS("Discount"))
        .OnParse = False
        End With

    mCol.Add lClsUser_Clan, ValidStr("N" & lObjRS("ID"))
    lObjRS.MoveNext
    Loop

End Sub
Public Function SeekID(uParm As Long) As User_clan
Dim uItem As User_clan

    For Each uItem In mCol

        If uItem.ID = uParm Then
        Set SeekID = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekName(uParm As String) As User_clan
Dim uItem As User_clan

    For Each uItem In mCol

        If uItem.Name = uParm Then
        Set SeekName = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekDescr(uParm As String) As User_clan
Dim uItem As User_clan

    For Each uItem In mCol

        If uItem.Descr = uParm Then
        Set SeekDescr = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekSponsored(uParm As Boolean) As User_clan
Dim uItem As User_clan

    For Each uItem In mCol

        If uItem.Sponsored = uParm Then
        Set SeekSponsored = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekFreeminperday(uParm As Long) As User_clan
Dim uItem As User_clan

    For Each uItem In mCol

        If uItem.Freeminperday = uParm Then
        Set SeekFreeminperday = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekDiscount(uParm As Byte) As User_clan
Dim uItem As User_clan

    For Each uItem In mCol

        If uItem.Discount = uParm Then
        Set SeekDiscount = uItem
        Exit Function
        End If

    Next uItem

End Function

