Attribute VB_Name = "LibAPI"

Public Function GetActiveWindowTitle(ByVal ReturnParent As Boolean) As String
On Error GoTo GetActiveWindowTitle_Err

Dim i As Long
Dim J As Long

i = GetForegroundWindow

    If ReturnParent Then
    
        Do While i <> 0
        J = i
        i = GetParent(i)
        Loop

    i = J
    End If

GetActiveWindowTitle = GetWindowTitle(i)

Exit Function
GetActiveWindowTitle_Err:
ErrH App.ProductName & " code library", "Public Function GetActiveWindowTitle"
Exit Function

End Function
Public Sub HideTaskBar()
On Error GoTo HideTaskBar_Err

TaskBarhWnd = FindWindow("Shell_traywnd", "")

    If TaskBarhWnd <> 0 Then
    Call SetWindowPos(TaskBarhWnd, 0, 0, 0, 0, 0, SWP_HIDEWINDOW)
    End If
    

Exit Sub
HideTaskBar_Err:
ErrH App.ProductName & " code library", "Public Sub HideTaskBar"
Exit Sub

End Sub
Public Sub ShowTaskBar()
On Error GoTo ShowTaskBar_Err

If TaskBarhWnd <> 0 Then
    Call SetWindowPos(TaskBarhWnd, 0, 0, 0, 0, 0, SWP_SHOWWINDOW)
    End If

Exit Sub
ShowTaskBar_Err:
ErrH App.ProductName & " code library", "Public Sub ShowTaskBar"
Exit Sub

End Sub
Public Function GetActiveWindow(ByVal ReturnParent As Boolean) As Long
On Error GoTo GetActiveWindow_Err

Dim i As Long
Dim J As Long

i = GetForegroundWindow

    If ReturnParent Then
    
        Do While i <> 0
        J = i
        i = GetParent(i)
        Loop
    
    i = J
    End If

GetActiveWindow = i

Exit Function
GetActiveWindow_Err:
ErrH App.ProductName & " code library", "Public Function GetActiveWindow"
Exit Function

End Function
Public Function GetWindowTitle(ByVal hWnd As Long) As String
On Error GoTo GetWindowTitle_Err

Dim L As Long
Dim S As String
   
L = GetWindowTextLength(hWnd)
S = Space(L + 1)

GetWindowText hWnd, S, L + 1
GetWindowTitle = Left$(S, L)

Exit Function
GetWindowTitle_Err:
ErrH App.ProductName & " code library", "Public Function GetWindowTitle"
Exit Function

End Function

Public Sub TopMostForm(f As Form, Top As Boolean)
On Error GoTo TopMostForm_Err

    If Top Then
    SetWindowPos f.hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE
    
    Else
    SetWindowPos f.hWnd, 0, 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE
    
    End If

Exit Sub
TopMostForm_Err:
ErrH App.ProductName & " code library", "Public Sub TopMostForm"
Exit Sub

End Sub
Public Sub Pause(ByVal seconds As Single)
On Error GoTo Pause_Err

Call Sleep(Int(seconds * 1000#))

Exit Sub
Pause_Err:
ErrH App.ProductName & " code library", "Public Sub Pause"
Exit Sub

End Sub
Public Sub AboutBox(Frm As Form, Optional copyright As Variant)
On Error GoTo AboutBox_Err

    If VarType(copyright) = vbString Then
    Call ShellAbout(Frm.hWnd, App.ProductName, copyright, Frm.Icon)
    
    Else
    Call ShellAbout(Frm.hWnd, App.ProductName, "", Frm.Icon)
    
    End If

Exit Sub
AboutBox_Err:
ErrH App.ProductName & " code library", "Public Sub AboutBox"
Exit Sub

End Sub
