Attribute VB_Name = "LibCommon"
Option Explicit

Declare Function InitCommonControlsEx Lib "comctl32" (lpInitCtrls As tagINITCOMMONCONTROLSEX) As Boolean
Declare Function AbortSystemShutdown& Lib "advapi32.dll" Alias "AbortSystemShutdownA" (ByVal lpMachineName$)
Declare Function AddFontResource Lib "gdi32" Alias "AddFontResourceA" (ByVal lpFileName As String) As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDCDest As Long, ByVal XDest As Long, ByVal YDest As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hDCSrc As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function ChangeDisplaySettings Lib "user32" Alias "ChangeDisplaySettingsA" (lpDevMode As Any, ByVal dwFlags As Long) As Long
Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As Any) As Long
Declare Function ClipCursor Lib "user32" (lpRect As Any) As Long
Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Declare Function CopyIcon Lib "user32" (ByVal hIcon As Long) As Long
Declare Function CopyImage Lib "user32" (ByVal Handle As Long, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Declare Function CopyRect Lib "user32" (lpDestRect As RECT, lpSourceRect As RECT) As Long
Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Declare Function CreateDCA Lib "gdi32" (ByVal Driver As String, ByVal Dev As Long, ByVal O As Long, ByVal Init As Long) As Long
Declare Function CreateEllipticRgn& Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long)
Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal htemplateFile As Long) As Long
Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Declare Function CreatePalette Lib "gdi32" (lpLogPalette As LogPalette) As Long
Declare Function CreatePolygonRgn Lib "gdi32" (lpPoint As POINTAPI, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Declare Function CreatePolyPolygonRgn& Lib "gdi32" (lpPoint As POINTAPI, lpPolyCounts As Long, ByVal nCount As Long, ByVal nPolyFillMode As Long)
Declare Function CreateProcessA Lib "kernel32" (ByVal lpApplicationName As Long, ByVal lpCommandLine As String, ByVal lpProcessAttributes As Long, ByVal lpThreadAttributes As Long, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, ByVal lpEnvironment As Long, ByVal lpCurrentDirectory As Long, lpStartupInfo As StartupInfo, lpProcessInformation As Process_Information) As Long
Declare Function CreateRoundRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long) As Long
Declare Function CreateScalableFontResource Lib "gdi32" Alias "CreateScalableFontResourceA" (ByVal fHidden As Long, ByVal lpszResourceFile As String, ByVal lpszFontFile As String, ByVal lpszCurrentPath As String) As Long
Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function DragDetect Lib "user32" (ByVal hwnd As Long, ByVal pt As POINTAPI) As Long
Declare Function DragQueryFile Lib "shell32.dll" Alias "DragQueryFileA" (ByVal hDrop As Long, ByVal UINT As Long, ByVal lpStr As String, ByVal ch As Long) As Long
Declare Function DrawIcon& Lib "user32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal hIcon As Long)
Declare Function EmptyClipboard Lib "user32" () As Long
Declare Function EnumDisplaySettings Lib "user32" Alias "EnumDisplaySettingsA" (ByVal lpszDeviceName As Long, ByVal iModeNum As Long, lpDevMode As Any) As Boolean
Declare Function ExitWindows Lib "user32" (ByVal dwReserved As Long, ByVal uReturnCode As Long) As Long
Declare Function ExitWindowsEx Lib "user32" (ByVal uFlags As Long, ByVal dwReserved As Long) As Long
Declare Function ExtFloodFill Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long, ByVal wFillType As Long) As Long
Declare Function ExtractIcon& Lib "shell32.dll" Alias "ExtractIconA" (ByVal hInst As Long, ByVal lpszExeFileName As String, ByVal nIconIndex As Long)
Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long
Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Declare Function FindExecutableA Lib "shell32.dll" (ByVal lpFile As String, ByVal lpdirectory As String, ByVal lpResult As String) As Long
Declare Function FindFirstFile& Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA)
Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Declare Function FlashWindow Lib "user32" (ByVal hwnd%, ByVal bInvert%) As Integer
Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Declare Function GetComputerNameA Lib "kernel32" (ByVal lpBuffer As String, nSize As Long) As Long
Declare Function GetCurrentProcessId Lib "kernel32" () As Long
Declare Function GetCursor Lib "user32" () As Long
Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetDesktopWindow Lib "user32" () As Long
Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Declare Function GetDialogBaseUnits Lib "user32" () As Long
Declare Function GetDiskFreeSpace Lib "kernel32" Alias "GetDiskFreeSpaceA" (ByVal lpRootPathName As String, lpSectorsPerCluster As Long, lpBytesPerSector As Long, lpNumberOfFreeClusters As Long, lpTtoalNumberOfClusters As Long) As Long
Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
Declare Function GetDriveTypeA Lib "kernel32" (ByVal nDrive As String) As Long
Declare Function GetFileTimeA Lib "kernel32" Alias "GetFileTime" (ByVal hFile As Long, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME) As Long
Declare Function GetFocus Lib "user32" () As Long
Declare Function GetForegroundWindow Lib "user32" () As Long
Declare Function GetLogicalDrives Lib "kernel32" () As Long
Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Declare Function GetMenu Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetMenuItemID Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function GetProcessHeap Lib "kernel32" () As Long
Declare Function GetProfileString Lib "kernel32" Alias "GetProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hwnd As Long, ByVal lpString As String) As Long
Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Declare Function GetShortPathNameA Lib "kernel32" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Declare Function GetSystemDirectoryA Lib "kernel32" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Declare Function GetSystempaletteEntries Lib "gdi32" (ByVal hDC As Long, ByVal wStartIndex As Long, ByVal wNumEntries As Long, lpPaletteEntries As PaletteEntry) As Long
Declare Function GetTempFileNameA Lib "kernel32" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Declare Function GetTempPathA Lib "kernel32" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Declare Function GetTextMetrics Lib "gdi32" Alias "GetTextMetricsA" (ByVal hDC As Long, lpMetrics As TEXTMETRIC) As Long
Declare Function GetTickCount Lib "kernel32" () As Long
Declare Function GetUserNameA Lib "advapi32.dll" (ByVal lpBuffer As String, nSize As Long) As Long
Declare Function GetVersion Lib "kernel32" () As Long
Declare Function GetVersionEx& Lib "kernel32.dll" Alias "GetVersionExA" (lpStruct As OSVERSIONINFO)
Declare Function GetVolumeInformation& Lib "kernel32" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal pVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long)
Declare Function GetWindowDC Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetWindowPlacement Lib "user32" (ByVal hwnd As Long, lpwndpl As WINDOWPLACEMENT) As Long
Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Declare Function GetWindowsDirectoryA Lib "kernel32" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long
Declare Function HeapAlloc Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, ByVal dwBytes As Long) As Long
Declare Function HeapFree Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, lpMem As Any) As Long
Declare Function HideCaret Lib "user32" (ByVal hwnd As Long) As Long
Declare Function IsCharAlpha Lib "user32" Alias "IsCharAlphaA" (ByVal cChar As Byte) As Long
Declare Function IsCharAlphaNumeric Lib "user32" Alias "IsCharAlphaNumericA" (ByVal cChar As Byte) As Long
Declare Function IsCharLower Lib "user32" Alias "IsCharLowerA" (ByVal cChar As Byte) As Long
Declare Function IsCharUpper Lib "user32" Alias "IsCharUpperA" (ByVal cChar As Byte) As Long
Declare Function IsWindowEnabled Lib "user32" (ByVal hwnd As Long) As Long
Declare Function joyGetDevCaps Lib "WINMM.DLL" Alias "joyGetDevCapsA" (ByVal ID As Long, lpCaps As JOYCAPS, ByVal uSize As Long) As Long
Declare Function joyGetNumDevs Lib "WINMM.DLL" () As Long
Declare Function joyGetPos Lib "WINMM.DLL" (ByVal uJoyID As Long, pji As JOYINFO) As Long
Declare Function LoadCursorFromFile Lib "user32" Alias "LoadCursorFromFileA" (ByVal lpFileName As String) As Long
Declare Function LocalFileTimeToFileTime Lib "kernel32" (lpLocalFileTime As FILETIME, lpFileTime As FILETIME) As Long
Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Declare Function LZCopy Lib "lz32.dll" (ByVal hfSource As Long, ByVal hfDest As Long) As Long
Declare Function LZInit Lib "lz32.dll" (ByVal hfSrc As Long) As Long
Declare Function LZOpenFile Lib "lz32.dll" Alias "LZOpenFileA" (ByVal lpszFile As String, lpOf As OFSTRUCT, ByVal Style As Long) As Long
Declare Function LZRead Lib "lz32.dll" (ByVal hfFile As Long, ByVal lpvBuf As String, ByVal cbread As Long) As Long
Declare Function LZSeek Lib "lz32.dll" (ByVal hfFile As Long, ByVal lOffset As Long, ByVal nOrigin As Long) As Long
Declare Function LZStart Lib "lz32" () As Long
Declare Function mciSendString Lib "WINMM.DLL" Alias "mciSendStringA" (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, ByVal uReturnLength As Long, ByVal hwndCallback As Long) As Long
Declare Function midiOutGetNumDevs Lib "winmm" () As Integer
Declare Function midiOutGetVolume Lib "WINMM.DLL" (ByVal uDeviceID As Long, lpdwVolume As Long) As Long
Declare Function midiOutSetVolume Lib "WINMM.DLL" (ByVal uDeviceID As Long, lpdwVolume As Long) As Long
Declare Function ModifyMenu Lib "user32" Alias "ModifyMenuA" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpString As Any) As Long
Declare Function NetApiBufferFree Lib "Netapi32.dll" (Buffer As Any) As Long
Declare Function NetBios Lib "Netapi32.dll" Alias "Netbios" (pncb As NCB) As Byte
Declare Function NetGetDCName Lib "Netapi32.dll" (strServerName As Any, strDomainName As Any, pBuffer As Long) As Long
Declare Function NetRemoteTOD Lib "Netapi32.dll" (ByVal server As String, Buffer As Any) As Long
Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (PicDesc As PicBmp, RefIID As GUID, ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long
Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Declare Function PlaySound Lib "WINMM.DLL" Alias "PlaySoundA" (ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long
Declare Function RealizePalette Lib "gdi32" (ByVal hDC As Long) As Long
Declare Function ReleaseCapture Lib "user32" () As Long
Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Declare Function SelectPalette Lib "gdi32" (ByVal hDC As Long, ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Declare Function SetBkMode Lib "gdi32" (ByVal hDC As Long, ByVal nBkMode As Long) As Long
Declare Function SetCursorPos Lib "user32" (ByVal X As Long, ByVal Y As Long) As Long
Declare Function SetFileTimeA Lib "kernel32" Alias "SetFileTime" (ByVal hFile As Long, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME) As Long
Declare Function SetFocusAPI Lib "user32" Alias "SetFocus" (ByVal hwnd As Long) As Long
Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Declare Function SetMapMode Lib "gdi32" (ByVal hDC As Long, ByVal nMapMode As Long) As Long
Declare Function SetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Declare Function SetPriorityClass& Lib "kernel32" (ByVal hProcess As Long, ByVal dwPriorityClass As Long)
Declare Function SetSystemCursor Lib "user32" (ByVal hcur As Long, ByVal ID As Long) As Long
Declare Function SetUnhandledExceptionFilter Lib "kernel32" (ByVal lpTopLevelExceptionFilter As Long) As Long 'This API function is used to raise exceptions.
Declare Function SetVolumeLabelA Lib "kernel32" (ByVal lpRootPathName As String, ByVal lpVolumeName As String) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Declare Function SetWindowWord Lib "user32" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal wNewWord As Long) As Long
Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, pnid As NOTIFYICONDATA) As Boolean
Declare Function ShellAbout Lib "shell32.dll" Alias "ShellAboutA" (ByVal hwnd As Long, ByVal szApp As String, ByVal szOtherStuff As String, ByVal hIcon As Long) As Long
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpdirectory As String, ByVal nShowCmd As Long) As Long
Declare Function SHFileOperation Lib "shell32.dll" Alias "SHFileOperationA" (lpFileOP As SHFILEOPSTRUCT) As Long
Declare Function SHGetFileInfo Lib "shell32" Alias "SHGetFileInfoA" (ByVal pszPath As String, ByVal dwFileAttributes As Long, psfi As SHFILEINFO, ByVal cbSizeFileInfo As Long, ByVal uFlags As Long) As Long
Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long
Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Declare Function SndPlaySound Lib "WINMM.DLL" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long
Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Declare Function SystemTimeToFileTime Lib "kernel32" (lpSystemTime As SYSTEMTIME, lpFileTime As FILETIME) As Long
Declare Function TileWindows Lib "user32" (ByVal hwndParent As Long, ByVal wHow As Long, lpRect As RECT, ByVal cKids As Long, lpKids As Long) As Integer
Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Declare Function waveOutGetNumDevs Lib "winmm" () As Long
Declare Function waveOutGetVolume Lib "WINMM.DLL" (ByVal uDeviceID As Long, lpdwVolume As Long) As Long
Declare Function WinHelp Lib "user32" Alias "WinHelpA" (ByVal hwnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwDATA As Long) As Long
Declare Function WNetAddConnection2 Lib "mpr.dll" Alias "WNetAddConnection2A" (lpNetResource As NETRESOURCE, ByVal lpPassword As String, ByVal lpUserName As String, ByVal dwFlags As Long) As Long
Declare Function WNetCancelConnection2 Lib "mpr.dll" Alias "WNetCancelConnection2A" (ByVal lpName As String, ByVal dwFlags As Long, ByVal fForce As Long) As Long
Declare Function WNetGetUser Lib "mpr" Alias "WNetGetUserA" (ByVal lpName As String, ByVal lpUserName As String, lpnLength As Long) As Long
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Declare Function WriteProfileString Lib "kernel32" Alias "WriteProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

Declare Sub InitCommonControls Lib "comctl32" ()
Declare Sub CopyExceptionRecord Lib "kernel32" Alias "RtlMoveMemory" (pDest As EXCEPTION_RECORD, ByVal LPEXCEPTION_RECORD As Long, ByVal lngBytes As Long) 'This is a friendly declaration of the CopyMemory function. It is used to copy data into an EXTENSION_RECORD structure from a pointer to another structure.
Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)
Declare Sub DragAcceptFiles Lib "shell32.dll" (ByVal hwnd As Long, ByVal fAccept As Long)
Declare Sub GetSystemTime Lib "kernel32" (lpSystemTime As SYSTEMTIME)
Declare Sub keybd_event Lib "user32" (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Long, ByVal dwExtraInfo As Long)
Declare Sub LZClose Lib "lz32.dll" (ByVal hfFile As Long)
Declare Sub LZDone Lib "lz32" ()
Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, ByVal hpvSource As Long, ByVal cbCopy As Long)
Declare Sub RaiseException Lib "kernel32" (ByVal dwExceptionCode As Long, ByVal dwExceptionFlags As Long, ByVal nNumberOfArguments As Long, lpArguments As Long)
Declare Sub SHAddToRecentDocs Lib "shell32.dll" (ByVal uFlags As Long, ByVal pv As String)
Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Enum EDB: DBNoFooter = 1: DBFooter = 0: End Enum
Enum EnumFillStyle: Complete = 0: AcrossTop = 1: LeftSide = 2: End Enum
Enum usrProccessPriorities: NORMAL_PRIORITY_CLASS = &H20: IDLE_PRIORITY_CLASS = &H40: HIGH_PRIORITY_CLASS = &H80: REALTIME_PRIORITY_CLASS = &H100: End Enum
Enum WNetStatus: CONNECT_UPDATE_PROFILE = &H1: ERROR_ACCESS_DENIED = 5&: ERROR_ALREADY_ASSIGNED = 85&: ERROR_BAD_DEV_TYPE = 66&: ERROR_BAD_DEVICE = 1200&: ERROR_BAD_NET_NAME = 67&: ERROR_BAD_PROFILE = 1206&: ERROR_BAD_PROVIDER = 1204&: ERROR_BUSY = 170&: ERROR_CANNOT_OPEN_PROFILE = 1205&: ERROR_DEVICE_ALREADY_REMEMBERED = 1202&: ERROR_DEVICE_IN_USE = 2404&: ERROR_EXTENDED_ERROR = 1208&: ERROR_INVALID_PASSWORD = 86&: ERROR_NO_NET_OR_BAD_PATH = 1203&: ERROR_NO_NETWORK = 1222&: ERRR_NOT_CONNECTED = 2250&:: ERROR_OPEN_FILES = 2401&: NO_ERROR = 0: RESOURCETYPE_ANY = &H0: RESOURCETYPE_DISK = &H1: RESOURCETYPE_PRINT = &H2: RESOURCETYPE_UNKNOWN = &HFFFF: End Enum

Global Const ICC_LISTVIEW_CLASSES As Long = &H1
Global Const CLR_NONE = &HFFFFFFFF
Global Const LVBKIF_SOURCE_NONE = &H0
Global Const LVBKIF_SOURCE_HBITMAP = &H1
Global Const LVBKIF_SOURCE_URL = &H2
Global Const LVBKIF_SOURCE_MASK = &H3
Global Const LVBKIF_STYLE_NORMAL = &H0
Global Const LVBKIF_STYLE_TILE = &H10
Global Const LVBKIF_STYLE_MASK = &H10
Global Const ALTERNATE = 1
Global Const AUDIO_MIDI = 2
Global Const AUDIO_NONE = 0
Global Const AUDIO_WAVE = 1
Global Const BIF_RETURNONLYFSDIRS = 1
Global Const BITSPIXEL = 12
Global Const CB_FINDSTRING = &H14C
Global Const cbCopy = 1
Global Const CBCUT = 0
Global Const CBDELETE = 3
Global Const CBPASTE = 2
Global Const CCDEVICENAME = 32
Global Const CCFORMNAME = 32
Global Const CDS_TEST = &H4
Global Const CDS_UPDATEREGISTRY = &H1
Global Const DH_Normal = 0
Global Const DH_Ok = 2
Global Const DH_Warning = 1
Global Const DISP_CHANGE_RESTART = 1
Global Const DISP_CHANGE_SUCCESSFUL = 0
Global Const DM_BITSPERPEL = &H40000
Global Const DM_COLLATE As Long = &H8000
Global Const DM_COLOR = &H800&
Global Const DM_COPIES = &H100&
Global Const DM_COPY = 2
Global Const DM_DEFAULTSOURCE = &H200&
Global Const DM_DITHERTYPE = &H10000000
Global Const DM_DUPLEX = &H1000&
Global Const DM_FORMNAME As Long = &H10000
Global Const DM_GRAYSCALE = &H1
Global Const DM_ICMINTENT = &H4000000
Global Const DM_ICMMETHOD = &H2000000
Global Const DM_INTERLACED = &H2
Global Const DM_MEDIATYPE = &H8000000
Global Const DM_MODIFY = 8
Global Const DM_ORIENTATION = &H1&
Global Const DM_PAPERLENGTH = &H4&
Global Const DM_PAPERSIZE = &H2&
Global Const DM_PAPERWIDTH = &H8&
Global Const DM_PELSHEIGHT = &H100000
Global Const DM_PELSWIDTH = &H80000
Global Const DM_PRINTQUALITY = &H400&
Global Const DM_PROMPT = 4
Global Const DM_RESERVED1 = &H800000
Global Const DM_RESERVED2 = &H1000000
Global Const DM_SCALE = &H10&
Global Const DM_SPECVERSION = &H320
Global Const DM_TTOPTION = &H4000&
Global Const DM_UPDATE = 1
Global Const DM_YRESOLUTION = &H2000&
Global Const DRIVE_CDROM = 5
Global Const DRIVE_FIXED = 3
Global Const DRIVE_RAMDISK = 6
Global Const DRIVE_REMOTE = 4
Global Const DRIVE_REMOVABLE = 2
Global Const DRIVE_UNKNOWN = 0 'Unknown, or unable to be determined.
Global Const EQ_ARGS = 1104 ' Invalids arguments to function:
Global Const EQ_FUNCTION = 1101 ' Unknown function:
Global Const EQ_INVALID = 1103 ' Invalid Equation
Global Const EQ_NAME = 1105 ' Unable to add an unnamed function:
Global Const EQ_PAREN = 1100 ' Unbalanced parenthesis
Global Const EQ_VARIABLE = 1102 ' Unknown variable:
Global Const EWX_FORCE = 4
Global Const EWX_LOGOFF = 0
Global Const EWX_REBOOT = 2
Global Const EWX_SHUTDOWN = 1
Global Const EXCEPTION_ACCESS_VIOLATION = &HC0000005: Global Const EXCEPTION_DATATYPE_MISALIGNMENT = &H80000002: Global Const EXCEPTION_BREAKPOINT = &H80000003: Global Const EXCEPTION_SINGLE_STEP = &H80000004: Global Const EXCEPTION_ARRAY_BOUNDS_EXCEEDED = &HC000008C: Global Const EXCEPTION_FLT_DENORMAL_OPERAND = &HC000008D: Global Const EXCEPTION_FLT_DIVIDE_BY_ZERO = &HC000008E: Global Const EXCEPTION_FLT_INEXACT_RESULT = &HC000008F: Global Const EXCEPTION_FLT_INVALID_OPERATION = &HC0000090: Global Const EXCEPTION_FLT_OVERFLOW = &HC0000091: Global Const EXCEPTION_FLT_STACK_CHECK = &HC0000092: Global Const EXCEPTION_FLT_UNDERFLOW = &HC0000093: Global Const EXCEPTION_INT_DIVIDE_BY_ZERO = &HC0000094: Global Const EXCEPTION_INT_OVERFLOW = &HC0000095: Global Const EXCEPTION_PRIVILEGED_INSTRUCTION = &HC0000096: Global Const EXCEPTION_IN_PAGE_ERROR = &HC0000006: Global Const EXCEPTION_ILLEGAL_INSTRUCTION = &HC000001D: Global Const EXCEPTION_NONCONTINUABLE_EXCEPTION = &HC0000025
Global Const EXCEPTION_CONTINUE_EXECUTION = -1: Global Const EXCEPTION_CONTINUE_SEARCH = 0: Global Const EXCEPTION_EXECUTE_HANDLER = 1: Global Const EXCEPTION_MAXIMUM_PARAMETERS = 15
Global Const EXCEPTION_STACK_OVERFLOW = &HC00000FD: Global Const EXCEPTION_INVALID_DISPOSITION = &HC0000026: Global Const EXCEPTION_GUARD_PAGE_VIOLATION = &H80000001: Global Const EXCEPTION_INVALID_HANDLE = &HC0000008: Global Const EXCEPTION_CONTROL_C_EXIT = &HC000013A: 'Standard Exception Codes
Global Const EXIT_LOGOFF = 0
Global Const EXIT_REBOOT = 2
Global Const EXIT_SHUTDOWN = 1
Global Const FILE_SHARE_READ = &H1
Global Const FILE_SHARE_WRITE = &H2
Global Const FO_DELETE = &H3
Global Const FOF_ALLOWUNDO = &H40
Global Const FOF_NOCONFIRMATION = &H10
Global Const FOF_SILENT = &H4
Global Const GENERIC_WRITE = &H40000000
Global Const GWL_WNDPROC = -4
Global Const HEAP_GENERATE_EXCEPTIONS = &H4
Global Const HEAP_ZERO_MEMORY = &H8
Global Const HELP_HELPONHELP = 4
Global Const HELP_INDEX = 3
Global Const HELP_PARTIALKEY = &H105
Global Const HELP_QUIT = 2
Global Const HTBORDER = 18
Global Const HTBOTTOM = 15
Global Const HTBOTTOMLEFT = 16
Global Const HTBOTTOMRIGHT = 17
Global Const HTCAPTION = 2
Global Const HTCLIENT = 1
Global Const HTERROR = (-2)
Global Const HTGROWBOX = 4
Global Const HTHSCROLL = 6
Global Const HTLEFT = 10
Global Const HTMAXBUTTON = 9
Global Const HTMENU = 5
Global Const HTMINBUTTON = 8
Global Const HTNOWHERE = 0
Global Const HTREDUCE = HTMINBUTTON
Global Const HTRIGHT = 11
Global Const HTSIZE = HTGROWBOX
Global Const HTSIZEFIRST = HTLEFT
Global Const HTSIZELAST = HTBOTTOMRIGHT
Global Const HTSYSMENU = 3
Global Const HTTOP = 12
Global Const HTTOPLEFT = 13
Global Const HTTOPRIGHT = 14
Global Const HTTRANSPARENT = -1
Global Const HTVSCROLL = 7
Global Const HTZOOM = HTMAXBUTTON
Global Const HWND_BROADCAST = &HFFFF
Global Const HWND_NOTOPMOST = -2
Global Const HWND_TOPMOST = -1
Global Const INFINITE = -1&
Global Const JOY_BUTTON1 = &H1
Global Const JOY_BUTTON2 = &H2
Global Const JOY_BUTTON3 = &H4
Global Const JOY_BUTTON4 = &H8
Global Const JOYERR_BASE = 160
Global Const JOYERR_NOCANDO = (JOYERR_BASE + 6)
Global Const JOYERR_NOERROR = (0)
Global Const JOYERR_PARMS = (JOYERR_BASE + 5)
Global Const JOYERR_UNPLUGGED = (JOYERR_BASE + 7)
Global Const LB_ADDFILE = &H196
Global Const LB_ADDSTRING = &H180
Global Const LB_CTLCODE = 0&
Global Const LB_DELETESTRING = &H182
Global Const LB_DIR = &H18D
Global Const LB_ERR = -1
Global Const LB_ERRSPACE = -2
Global Const LB_FINDSTRING = &H18F
Global Const LB_FINDSTRINGEXACT = &H1A2
Global Const LB_GETANCHORINDEX = &H19D
Global Const LB_GETCARETINDEX = &H19F
Global Const LB_GETCOUNT = &H18B
Global Const LB_GETCURSEL = &H188
Global Const LB_GETHORIZONTALEXTENT = &H193
Global Const LB_GETITEMDATA = &H199
Global Const LB_GETITEMHEIGHT = &H1A1
Global Const LB_GETITEMRECT = &H198
Global Const LB_GETLOCALE = &H1A6
Global Const LB_GETSEL = &H187
Global Const LB_GETSELITEMS = &H191
Global Const LB_GETTEXT = &H189
Global Const LB_GETTEXTLEN = &H18A
Global Const LB_GETTOPINDEX = &H18E
Global Const LB_INSERTSTRING = &H181
Global Const LB_MSGMAX = &H1A8
Global Const LB_OKAY = 0
Global Const LB_RESETCONTENT = &H184
Global Const LB_SELECTSTRING = &H18C
Global Const LB_SELITEMRANGE = &H19B
Global Const LB_SELITEMRANGEEX = &H183
Global Const LB_SETANCHORINDEX = &H19C
Global Const LB_SETCARETINDEX = &H19E
Global Const LB_SETCOLUMNWIDTH = &H195
Global Const LB_SETCOUNT = &H1A7
Global Const LB_SETCURSEL = &H186
Global Const LB_SETHORIZONTALEXTENT = &H194
Global Const LB_SETITEMDATA = &H19A
Global Const LB_SETITEMHEIGHT = &H1A0
Global Const LB_SETLengthS = &H192
Global Const LB_SETLOCALE = &H1A5
Global Const LB_SETSEL = &H185
Global Const LB_SETTOPINDEX = &H197
Global Const LF_FACESIZE = 32
Global Const LVM_FIRST As Long = &H1000
Global Const LVM_GETBKIMAGEA = (LVM_FIRST + 69)
Global Const LVM_GETBKIMAGEW = (LVM_FIRST + 139)
Global Const LVM_SETCOLUMNWIDTH As Long = (LVM_FIRST + 30)
Global Const LVM_SETBKIMAGEA = (LVM_FIRST + 68)
Global Const LVM_SETBKIMAGEW = (LVM_FIRST + 138)
Global Const LVM_SETBKIMAGE = LVM_SETBKIMAGEA
Global Const LVM_GETBKIMAGE = LVM_GETBKIMAGEA
Global Const LVM_SETTEXTBKCOLOR = (LVM_FIRST + 38)
Global Const LVM_SETEXTENDEDLISTVIEWSTYLE As Long = (LVM_FIRST + 54)
Global Const LVS_EX_FULLROWSELECT As Long = &H20
Global Const LVSCW_AUTOSIZE As Long = -1
Global Const LVSCW_AUTOSIZE_USEHEADER As Long = -2
Global Const MARGIN_BOTTOM = 2
Global Const MARGIN_LEFT = 3
Global Const MARGIN_RIGHT = 4
Global Const MARGIN_TOP = 1
Global Const MAX_FILENAME_LEN = 256
Global Const MAX_PATH = 260
Global Const MAXDWORD As Long = &HFFFFFFFF
Global Const MAXPNAMELEN = 32
Global Const MF_BITMAP = 4
Global Const MF_CHECKED = 8
Global Const MM_TEXT = 1
Global Const MMSYSERR_NOERROR = 0
Global Const NCBASTAT = &H33
Global Const NCBNAMSZ = 16
Global Const NCBRESET = &H32
Global Const NIF_ICON = &H2
Global Const NIF_MESSAGE = &H1
Global Const NIF_TIP = &H4
Global Const NIM_ADD = &H0
Global Const NIM_DELETE = &H2
Global Const NIM_MODIFY = &H1
Global Const OCR_SIZENESW = 32643 ' The NESW Size Arrow
Global Const OCR_SIZENS = 32645 ' The NS Size ArrowGlobal
Global Const OCR_SIZENWSE = 32642 ' The NWSE Diagonal Size Arrow
Global Const OCR_SIZEWE = 32644 ' The WE Size Arrow
Global Const OCR_UP = 32516 'The Up Arrow
Global Const OCR_WAIT = 32514 ' The Wait cursor
Global Const OFS_MAXPATHNAME = 128
Global Const OPAQUE = 2
Global Const OPEN_EXISTING = 3
Global Const PHYSICALOFFSETX = 112
Global Const PHYSICALOFFSETY = 113
Global Const PLANES = 14
Global Const PROCESS_DUP_HANDLE = &H40
Global Const RASTERCAPS As Long = 38
Global Const RC_PALETTE As Long = &H100
Global Const RGB_GAMMA_MAX = 65000
Global Const RGB_GAMMA_MIN = 2500
Global Const RGN_AND = 1
Global Const RGN_COPY = 5
Global Const RGN_DIFF = 4
Global Const RGN_MAX = RGN_COPY
Global Const RGN_MIN = RGN_AND
Global Const RGN_OR = 2
Global Const RGN_XOR = 3
Global Const SHGFI_DISPLAYNAME As Long = &H200
Global Const SHGFI_EXETYPE As Long = &H2000
Global Const SHGFI_TYPENAME As Long = &H400
Global Const SIZEPALETTE As Long = 104
Global Const SND_ALIAS = &H10000
Global Const SND_ASYNC = &H1
Global Const SND_FILENAME = &H20000
Global Const SND_LOOP = &H8
Global Const SND_NODEFAULT = &H2
Global Const SND_NOSTOP = &H10
Global Const SND_NOWAIT = &H2000
Global Const SND_SYNC = &H0
Global Const SRCAND = &H8800C6
Global Const SRCCOPY = &HCC0020
Global Const SRCERASE = &H440328
Global Const SRCINVERT = &H660046
Global Const SRCPAINT = &HEE0086
Global Const SW_ERASE = &H4
Global Const SW_HIDE = 0
Global Const SW_INVALIDATE = &H2
Global Const SW_MAX = 10
Global Const SW_MAXIMIZE = 3
Global Const SW_MINIMIZE = 6
Global Const SW_NORMAL = 1
Global Const SW_OTHERUNZOOM = 4
Global Const SW_OTHERZOOM = 2
Global Const SW_PARENTCLOSING = 1
Global Const SW_PARENTOPENING = 3
Global Const SW_RESTORE = 9
Global Const SW_SCROLLCHILDREN = &H1
Global Const SW_SHOW = 5
Global Const SW_SHOWDEFAULT = 10
Global Const SW_SHOWMAXIMIZED = 3
Global Const SW_SHOWMINIMIZED = 2
Global Const SW_SHOWMINNOACTIVE = 7
Global Const SW_SHOWNA = 8
Global Const SW_SHOWNOACTIVATE = 4
Global Const SW_SHOWNORMAL = 1
Global Const SWP_DRAWFRAME = &H20
Global Const SWP_FRAMECHANGED = &H20        '  The frame changed:send WM_NCCALCSIZE
Global Const SWP_HIDEWINDOW = &H80
Global Const SWP_NOACTIVATE = &H10
Global Const SWP_NOCOPYBITS = &H100
Global Const SWP_NOMOVE = &H2
Global Const SWP_NOOWNERZORDER = &H200      '  Don't do owner Z ordering
Global Const SWP_NOREDRAW = &H8
Global Const SWP_NOREPOSITION = &H200
Global Const SWP_NOSIZE = &H1
Global Const SWP_NOZORDER = &H4
Global Const SWP_SHOWWINDOW = &H40
Global Const SYNCHRONIZE = &H100000
Global Const Transparent = 1
Global Const TV_FIRST As Long = &H1100
Global Const TVM_GETNEXTITEM As Long = (TV_FIRST + 10)
Global Const TVM_GETITEM As Long = (TV_FIRST + 12)
Global Const TVM_SETITEM As Long = (TV_FIRST + 13)
Global Const TVM_SETBKCOLOR As Long = (TV_FIRST + 29)
Global Const TVM_SETTEXTCOLOR As Long = (TV_FIRST + 30)
Global Const TVM_GETBKCOLOR As Long = (TV_FIRST + 31)
Global Const TVM_GETTEXTCOLOR As Long = (TV_FIRST + 32)
Global Const UNIQUE_NAME = &H0
Global Const VER_PLATFORM_WIN32_NT = 2
Global Const VER_PLATFORM_WIN32_WINDOWS = 1
Global Const WINDING = 2
Global Const WM_DROPFILES = &H233
Global Const WM_FONTCHANGE = &H1D
Global Const WM_LBUTTONDBLCLK = &H203
Global Const WM_LBUTTONDOWN = &H201
Global Const WM_LBUTTONUP = &H202
Global Const WM_MOUSEMOVE = &H200
Global Const WM_NCACTIVATE = &H86
Global Const WM_NCCALCSIZE = &H83
Global Const WM_NCCREATE = &H81
Global Const WM_NCDESTROY = &H82
Global Const WM_NCHITTEST = &H84
Global Const WM_NCLBUTTONDBLCLK = &HA3
Global Const WM_NCLBUTTONDOWN = &HA1
Global Const WM_NCLBUTTONUP = &HA2
Global Const WM_NCMBUTTONDBLCLK = &HA9
Global Const WM_NCMBUTTONDOWN = &HA7
Global Const WM_NCMBUTTONUP = &HA8
Global Const WM_NCMOUSEMOVE = &HA0
Global Const WM_NCPAINT = &H85
Global Const WM_NCRBUTTONDBLCLK = &HA6
Global Const WM_NCRBUTTONDOWN = &HA4
Global Const WM_NCRBUTTONUP = &HA5
Global Const WM_NEXTDLGCTL = &H28
Global Const WM_NULL = &H0
Global Const WM_OTHERWINDOWCREATED = &H42
Global Const WM_OTHERWINDOWDESTROYED = &H43
Global Const WM_PAINT = &HF
Global Const WM_PAINTCLIPBOARD = &H309
Global Const WM_PAINTICON = &H26
Global Const WM_PALETTECHANGED = &H311
Global Const WM_PALETTEISCHANGING = &H310
Global Const WM_PARENTNOTIFY = &H210
Global Const WM_PASTE = &H302
Global Const WM_PENWINFIRST = &H380
Global Const WM_PENWINLAST = &H38F
Global Const WM_POWER = &H48
Global Const WM_RBUTTONDBLCLK = &H206
Global Const WM_RBUTTONDOWN = &H204
Global Const WM_RBUTTONUP = &H205
Global Const WM_SETREDRAW = &HB
Global Const WM_USER = &H400
Global Const XMAX = 2
Global Const XMB_WARNING = 0
Global Const XMED = 4
Global Const XMIN = 1
Global Const YMAX = 16
Global Const YMED = 32
Global Const YMIN = 8

Global Const DM_IN_BUFFER = DM_MODIFY
Global Const DM_IN_PROMPT = DM_PROMPT
Global Const DM_OUT_BUFFER = DM_COPY
Global Const DM_OUT_DEFAULT = DM_UPDATE
Global Const EM_SETREADONLY = (WM_USER + 31)
Global Const FLAG = SWP_NOMOVE Or SWP_NOSIZE

Global Cursor As Long, Cursor2 As Long ' The variables used to hold your cursors
Global GlobalSQL As SQLPattern
Global HoldCursor As Long ' This will hold the system cursor until used to change back
Global lShowCursor As Long
Global Msg As String, CRLF As String * 2
Global OsVer As OSVERSIONINFO
Global ProcName As String
Global TaskBarhWnd As Long
Global VBGTray As NOTIFYICONDATA

Type LVBKIMAGE: uFlags As Long: hBmp As Long: pszImage As String: cchImageMax As Long: xOffsetPercent As Long: yOffsetPercent As Long: End Type
Type tagINITCOMMONCONTROLSEX: dwSize As Long: dwICC As Long: End Type
Type ADAPTER_STATUS: adapter_address(5) As Byte: rev_major As Byte: reserved0 As Byte: adapter_type As Byte: rev_minor As Byte: duration As Integer: frmr_recv As Integer: frmr_xmit As Integer: iframe_recv_err As Integer: xmit_aborts As Integer: xmit_success As Long: recv_success As Long: iframe_xmit_err As Integer: recv_buff_unavail As Integer: t1_timeouts As Integer: ti_timeouts As Integer: reserved1 As Long: free_ncbs As Integer: max_cfg_ncbs As Integer: max_ncbs As Integer: xmit_buf_unavail As Integer: max_dgram_size As Integer: pending_sess As Integer: max_cfg_sess As Integer: max_sess As Integer: max_sess_pkt_size As Integer: name_count As Integer: End Type
Type BrowseInfo: hwndOwner As Long: pIDLRoot As Long: pszDisplayName As Long: lpszTitle As Long: ulFlags As Long: lpfnCallback As Long: lParam As Long: iImage As Long: End Type
Type Complex: I As Double: R As Double: End Type
Type CONTEXT: FltF0 As Double: FltF1 As Double: FltF2 As Double: FltF3 As Double: FltF4 As Double: FltF5 As Double: FltF6 As Double: FltF7 As Double: FltF8 As Double: FltF9 As Double: FltF10 As Double: FltF11 As Double: FltF12 As Double: FltF13 As Double: FltF14 As Double: FltF15 As Double: FltF16 As Double: FltF17 As Double: FltF18 As Double: FltF19 As Double: FltF20 As Double: FltF21 As Double: FltF22 As Double: FltF23 As Double: FltF24 As Double: FltF25 As Double: FltF26 As Double: FltF27 As Double: FltF28 As Double: FltF29 As Double: FltF30 As Double: FltF31 As Double: IntV0 As Double: IntT0 As Double: IntT1 As Double: IntT2 As Double: IntT3 As Double: IntT4 As Double: IntT5 As Double: IntT6 As Double: IntT7 As Double: IntS0 As Double: IntS1 As Double: IntS2 As Double: IntS3 As Double: IntS4 As Double: IntS5 As Double: IntFp As Double: IntA0 As Double: IntA1 As Double: IntA2 As Double: IntA3 As Double: IntA4 As Double: IntA5 As Double: IntT8 As Double: IntT9 As Double: IntT10 As Double:
IntT11 As Double: IntRa As Double: IntT12 As Double: IntAt As Double: IntGp As Double: IntSp As Double: IntZero As Double: Fpcr As Double: SoftFpcr As Double: Fir As Double: Psr As Long: ContextFlags As Long: Fill(4) As Long: End Type: 'Structure that contains processor-specific register data
Type Coordinates: X As Double: Y As Double: End Type
Type DEVMODE: dmDeviceName As String * CCDEVICENAME: dmSpecVersion As Integer: dmDriverVersion As Integer: dmSize As Integer: dmDriverExtra As Integer: dmFields As Long: dmOrientation As Integer: dmPaperSize As Integer: dmPaperLength As Integer: dmPaperWidth As Integer: dmScale As Integer: dmCopies As Integer: dmDefaultSource As Integer: dmPrintQuality As Integer: dmColor As Integer: dmDuplex As Integer: dmYResolution As Integer: dmTTOption As Integer: dmCollate As Integer: dmFormName As String * CCFORMNAME: dmUnusedPadding As Integer: dmBitsPerPel As Integer: dmPelsWidth As Long: dmPelsHeight As Long: dmDisplayFlags As Long: dmDisplayFrequency As Long: End Type
Type ErrorType: Source As String: Description As String: number As Long: End Type
Type EXCEPTION_RECORD: ExceptionCode As Long: ExceptionFlags As Long: pExceptionRecord As Long: ExceptionAddress As Long: NumberParameters As Long: ExceptionInformation(EXCEPTION_MAXIMUM_PARAMETERS) As Long: End Type 'Structure that Describes an exception.
Type FILETIME: dwLowDateTime As Long: dwHighDateTime As Long: End Type
Type FormPos: Left As Long: Top As Long: Width As Long: Height As Long: Visible As Boolean: End Type
Type GUID: DATA1 As Long: DATA2 As Integer: DATA3 As Integer: DATA4(7) As Byte: End Type
Type JOYCAPS: wMid As Integer: wPid As Integer: szPname As String * MAXPNAMELEN: wXmin As Long: wXmax As Long: wYmin As Long: wYmax As Long: wZmin As Long: wZmax As Long: wNumButtons As Long: wPeriodMin As Long: wPeriodMax As Long: End Type
Type JOYINFO: X As Long: Y As Long: Z As Long: Buttons As Long: End Type
Type LOGFONT: lfHeight As Long: lfWidth As Long: lfEscapement As Long: lfOrientation As Long: lfWeight As Long: lfItalic As Byte: lfUnderline As Byte: lfStrikeOut As Byte: lfCharSet As Byte: lfOutPrecision As Byte: lfClipPrecision As Byte: lfQuality As Byte: lfPitchAndFamily As Byte: lfFaceName As String * LF_FACESIZE: End Type
Type NAME_BUFFER: Name As String * NCBNAMSZ: name_num As Integer: name_flags As Integer: End Type
Type NCB: ncb_command As Byte: ncb_retcode As Byte: ncb_lsn As Byte: ncb_num As Byte: ncb_buffer As Long: ncb_length As Integer: ncb_callname As String * NCBNAMSZ: ncb_name As String * NCBNAMSZ: ncb_rto As Byte: ncb_sto As Byte: ncb_post As Long: ncb_lana_num As Byte: ncb_cmd_cplt As Byte: ncb_reserve(9) As Byte: ncb_event As Long: End Type
Type NETRESOURCE: dwScope As Long: dwType As Long: dwDisplayType As Long: dwUsage As Long: lpLocalName As String: lpRemoteName As String: lpComment As String: lpProvider As String: End Type
Type NOTIFYICONDATA: cbSize As Long: hwnd As Long: uId As Long: uFlags As Long: ucallbackMessage As Long: hIcon As Long: szTip As String * 64: End Type
Type OFSTRUCT: cBytes As Byte: fFixedDisk As Byte: nErrCode As Integer: reserved1 As Integer: Reserved2 As Integer: szPathName(OFS_MAXPATHNAME) As Byte: End Type
Type OPENFILENAME: lStructSize As Long: hwndOwner As Long: hInstance As Long: lpstrFilter As String: lpstrCustomFilter As String: nMaxCustFilter As Long: nFilterIndex As Long: lpstrFile As String: nMaxFile As Long: lpstrFileTitle As String: nMaxFileTitle As Long: lpstrInitialDir As String: lpstrTitle As String: Flags As Long: nFileOffset As Integer: nFileExtension As Integer: lpstrDefExt As String: lCustDATA As Long: lpfnHook As Long: lptemplateName As String: End Type
Type OSVERSIONINFO: dwOSVersionInfoSize As Long: dwMajorVersion As Long: dwMinorVersion As Long: dwBuildNumber As Long: dwPlatformId As Long: szCSDVersion As String * 128: End Type
Type PaletteEntry: peRed As Byte: peGreen As Byte: peBlue As Byte: peFlags As Byte: End Type
Type PicBmp: Size As Long: Type As Long: hBmp As Long: hPal As Long: Reserved As Long: End Type
Type POINTAPI: X As Long: Y As Long: End Type
Type Polar: Z As Double: Th As Double: End Type
Type Process_Information: hProcess As Long: hThread As Long: dwProcessId As Long: dwThreadID As Long: End Type
Type RECT: Left As Long: Top As Long: Right As Long: Bottom As Long: End Type
Type SHFILEINFO: hIcon As Long: iIcon As Long: dwAttributes As Long: szDisplayName As String * MAX_PATH: szTypeName As String * 80: End Type
Type SHFILEOPSTRUCT: hwnd As Long: wFunc As Long: pFrom As String: pTo As String: fFlags As Integer: fAborted As Boolean: hNameMaps As Long: sProgress As String: End Type
Type SQLPattern: Select As String: from As String: Where As String: Group As String: Order As String: Having As String: End Type
Type StartupInfo: cb As Long: lpReserved As String: lpDesktop As String: lpTitle As String: dwX As Long: dwY As Long: dwXSize As Long: dwYSize As Long: dwXCountChars As Long: dwYCountChars As Long: dwFillAttribute As Long: dwFlags As Long: wShowWindow As Integer: cbReserved2 As Integer: lpReserved2 As Long: hStdInput As Long: hStdOutput As Long: hStdError As Long: End Type
Type SysInfo: Network As Boolean: MaxUsers As Integer: ServerPath As String: Secure As Boolean: End Type
Type SYSTEMTIME: wYear As Integer: wMonth As Integer: wDayOfWeek As Integer: wDay As Integer: wHour As Integer: wMinute As Integer: wSecond As Integer: wMilliseconds As Integer: End Type
Type TEXTMETRIC: tmHeight As Integer: tmAscent As Integer: tmDescent As Integer: tmInternalLeading As Integer: tmExternalLeading As Integer: tmAveCharWidth As Integer: tmMaxCharWidth As Integer: tmWeight As Integer: tmItalic As String * 1: tmUnderlined As String * 1: tmStruckOut As String * 1: tmFirstChar As String * 1: tmLastChar As String * 1: tmDefaultChar As String * 1: tmBreakChar As String * 1: tmPitchAndFamily As String * 1: tmCharSet As String * 1: tmOverhang As Integer: tmDigitizedASPECtX As Integer: tmDigitizedASPECtY As Integer: End Type
Type TIME_OF_DAY: t_elapsedt As Long: t_msecs As Long: t_hours As Long: t_mins As Long: t_secs As Long: t_hunds As Long: t_timezone As Long: t_tinterval As Long: t_day As Long: t_month As Long: t_year As Long: t_weekday As Long: End Type
Type TypesAsString: I As String * 2: L As String * 4: S As String * 4: D As String * 8: c As String * 8: D1 As String * 6: D2 As String * 2: End Type
Type TypesAsType: I As Integer: L As Long: S As Single: D As Double: c As Currency: Dat As Double: End Type
Type UserPattern: Name As String: Nick As String: Password As String: level As Integer: ID As Long: SmartMode As Boolean: MultiThreading As Boolean: TimeLastLogon As Date: End Type
Type WIN32_FIND_DATA: dwFileAttributes As Long: ftCreationTime As FILETIME: ftLastAccessTime As FILETIME: ftLastWriteTime As FILETIME: nFileSizeHigh As Long: nFileSizeLow As Long: dwReserved As Long: dwReserved1 As Long: cFileName As String * MAX_PATH: cAlternate As String * 14: End Type
Type WindowCoordinates: Visible As Boolean: Left As Integer: Top As Integer: Width As Integer: Height As Integer: End Type
Type WINDOWPLACEMENT: length As Long: Flags As Long: showCmd As Long: ptMinPosition As POINTAPI: ptMaxPosition As POINTAPI: rcNormalPosition As RECT: End Type
Type ASTAT: adapt As ADAPTER_STATUS: NameBuff(30) As NAME_BUFFER: End Type
Type EXCEPTION_DEBUG_INFO: pExceptionRecord As EXCEPTION_RECORD: dwFirstChance As Long: End Type: 'Structure that contains exception information that can be used by a debugger.
Type EXCEPTION_POINTERS: pExceptionRecord As EXCEPTION_RECORD: ContextRecord As CONTEXT: End Type: 'The EXCEPTION_POINTERS structure contains an exception record with a machine-independent Description of an exception and a context record with a machine-dependent Description of the processor context at the time of the exception.
Type LogPalette: palVersion As Integer: palNumEntries As Integer: palPalEntry(255) As PaletteEntry: End Type
Type LV_FINDINFO: Flags As Long: psz As String: lParam As Long: pt As POINTAPI: vkDirection As Long: End Type

