Attribute VB_Name = "LibDatabase"
Option Explicit

Global GlobalDB As Database
Global GlobalWS As Workspace

Sub GenerateQuery(DesSQL As SQLPattern, ByVal DesName As String)
On Error GoTo GenerateQuery_Err

Dim Query As QueryDef, Valid As Boolean

Valid = True

 Set Query = GlobalDB.QueryDefs(DesName)
 
    If Not Valid Then
    Set Query = GlobalDB.CreateQueryDef(DesName, AssembleSQL(DesSQL))
    Exit Sub
    End If
    
Query.SQL = AssembleSQL(DesSQL)

Exit Sub
GenerateQuery_Err:
ErrH App.ProductName & " code library", "Sub GenerateQuery"
Exit Sub

End Sub

Sub MountSingleList(ByVal Cntl As Control, ESQL As String, GlobalDB As Database, Optional uSetFirst As Boolean = False)
On Error GoTo MountSingleList_Err

Dim A As Recordset, Counter As Integer, IDField As String, DField As String

Set A = GlobalDB.OpenRecordset(ESQL)

    If A.EOF Then Exit Sub

Cntl.Clear
A.MoveLast
A.MoveFirst

IDField = A.Fields(0).name
DField = A.Fields(1).name

    For Counter = 0 To A.RecordCount - 1
    Cntl.AddItem A(DField)
    Cntl.ItemData(Counter) = A(IDField)
    If uSetFirst And (Counter = 0) Then Cntl.ListIndex = 0
    A.MoveNext
    Next Counter

Exit Sub
MountSingleList_Err:
ErrH App.ProductName & " code library", "Sub MountSingleList"
Exit Sub

End Sub
