Attribute VB_Name = "LibGeneral"
Option Explicit
Public uErrAmount       As Long
Public Data             As uAppLocalTypeDataBag
Function GetDriveTypeText(ByVal N$, Optional M As Byte) As String
On Error GoTo GetDriveTypeText_Err

N$ = Left$(Trim(N$), 3)

M = GetDriveTypeA(N)

   Select Case M
    Case 1
    GetDriveTypeText = "Dispositivo indisponvel"
    
    Case 2
    GetDriveTypeText = "Disco flexvel"
    
    Case 3
    GetDriveTypeText = "Disco rgido"
    
    Case 5
    GetDriveTypeText = "CD-ROM"
    
    Case Else
    GetDriveTypeText = "Desconhecido"
    
    End Select

Exit Function
GetDriveTypeText_Err:
ErrH , "Function GetDriveTypeText"
Exit Function

End Function
Sub Run(ByVal parm)
'Pass-Troughter: NUL Simulation Procedure
End Sub
Sub ErrH(Optional PName As String, Optional SPlace As String, Optional Ent As Integer, Optional ShowWindow As Boolean = True)

    If PName = "" Then PName = App.ProductName & " code library"

uErrAmount = uErrAmount + 1
    
SysLog "Erro em " & Chr$(34) & PName & Chr$(34) & ", procedure " & _
Chr$(34) & SPlace & Chr$(34) & ": Cdigo " & Err.number & ", " & Chr$(34) & Err.Description & _
IIf(Right$(Err.Description, 1) = ".", "", ".") & " - Fonte: " & Err.Source & "."

    If ShowWindow Then
    Msg = ""
    
    Msg = "Um erro foi detectado pelo sistema e no gerenciado, e a ateno do usurio  requerida para que a manuteno do procedimento seja realizada." & vbCrLf & vbCrLf & _
    "Mdulo " & Chr$(34) & PName & Chr$(34) & ", procedimento " & Chr$(34) & SPlace & Chr$(34) & ";" & vbCrLf & _
    "Cdigo de erro " & Err.number & ", " & Chr$(34) & Err.Description & IIf(Right$(Err.Description, 1) = ".", "", ".") & Chr$(34) & vbCrLf & vbCrLf & _
    "Fonte do cdigo de erro: " & Err.Source & "." & vbCrLf & vbCrLf & vbCrLf & _
    "Anote este Valores para fins de reparo no sistema, e contacte o suporte a este produto."
    
        If MsgBox(Msg, vbMsgBoxHelpButton & vbOKCancel, "Mdulo de tratamento de erros: " & App.Title, Err.HelpFile, Err.HelpContext) = vbCancel Then
        Stop
        End If
        
    End If
    
End Sub
Sub SysLog(ByVal M)
On Error GoTo 0

Dim N As Long
N = FreeFile()
Open Data.InstanceIdentifier & ".txt" For Append As #N
Print #N, Now(), M
Close #N

End Sub
Sub InitializeInstanceIdentifier()
Data.InstanceIdentifier = App.ProductName & "-" & Int(Rnd(-Time) * 10000000)
End Sub
