Attribute VB_Name = "LibJoystick"
Public Function GetJoyMin(ByVal joy As Integer, ji As JOYINFO) As Boolean
On Error GoTo GetJoyMin_Err

Dim jc As JOYCAPS
   
   If joyGetDevCaps(joy, jc, Len(jc)) <> JOYERR_NOERROR Then
      GetJoyMin = False
      
   Else
      ji.X = jc.wXmin
      ji.Y = jc.wYmin
      ji.Z = jc.wZmin
      ji.Buttons = jc.wNumButtons
   
      GetJoyMin = True
   End If

Exit Function
GetJoyMin_Err:
ErrH App.ProductName & " code library", "Public Function GetJoyMin"
Exit Function

End Function
Public Function GetJoyMax(ByVal joy As Integer, ji As JOYINFO) As Boolean
On Error GoTo GetJoyMax_Err

Dim jc As JOYCAPS
   
   If joyGetDevCaps(joy, jc, Len(jc)) <> JOYERR_NOERROR Then
      GetJoyMax = False
      
   Else
      ji.X = jc.wXmax
      ji.Y = jc.wYmax
      ji.Z = jc.wZmax
      ji.Buttons = jc.wNumButtons
   
      GetJoyMax = True
   End If

Exit Function
GetJoyMax_Err:
ErrH App.ProductName & " code library", "Public Function GetJoyMax"
Exit Function

End Function
Public Function GetJoystick(ByVal joy As Integer, ji As JOYINFO) As Boolean
On Error GoTo GetJoystick_Err

If joyGetPos(joy, ji) <> JOYERR_NOERROR Then
      GetJoystick = False
   Else
      GetJoystick = True
   End If

Exit Function
GetJoystick_Err:
ErrH App.ProductName & " code library", "Public Function GetJoystick"
Exit Function

End Function
Public Function IsJoyPresent(Optional IsConnected As Variant) As Long
On Error GoTo IsJoyPresent_Err

Dim ic As Boolean
   Dim i As Long
   Dim J As Long
   Dim Ret As Long
   Dim ji As JOYINFO
   
   ic = IIf(IsMissing(IsConnected), True, CBool(IsConnected))

   i = joyGetNumDevs
   
   If ic Then
      J = 0
      Do While i > 0
         i = i - 1   'Joysticks id's are 0 and 1
         If joyGetPos(i, ji) = JOYERR_NOERROR Then
            J = J + 1
         End If
      Loop
   
      IsJoyPresent = J
   Else
      IsJoyPresent = i
   End If
   

Exit Function
IsJoyPresent_Err:
ErrH App.ProductName & " code library", "Public Function IsJoyPresent"
Exit Function

End Function
