Attribute VB_Name = "LibSettings"
Option Explicit
Sub GetDefaultReg(ByVal uSession As String, uKey As String, uMessage As String, uDefault As String)
RegWrite uSession, uKey, _
InputBox(uMessage, "Configurao de " & App.ProductName, _
IIf(RegRead(uSession, uKey) = "NULL", uDefault, RegRead(uSession, uKey)))
End Sub
Function INIRead(ByVal PSPath As String, ByVal PSPlace As String, ByVal PSKey As String)
On Error GoTo INIRead_Error

Dim PSDev As String, PSDef As String, Dummy As Integer

PSDev = Space$(50)
Dummy = GetPrivateProfileString(PSPlace, PSKey, Null, PSDev, 50, PSPath)
PSDev = Left$(PSDev, Dummy)
INIRead = PSDev

Exit Function

INIRead_Error:
ErrH App.ProductName & " code library", "INIRead"
Exit Function
End Function
Function RegRead(ByVal PSPlace As String, ByVal PSKey As String, Optional DefaultValue As String) As String
On Error GoTo RegRead_Error

RegRead = GetSetting(App.ProductName, PSPlace, PSKey, DefaultValue)

Exit Function

RegRead_Error:
ErrH App.ProductName & " code library", "Function RegRead"
Exit Function
End Function
Function INIWrite(ByVal Path As String, ByVal Place As String, ByVal Key As String, ByVal DesValue As String)
On Error GoTo INIWrite_Error

INIWrite = WritePrivateProfileString(Place, Key, DesValue, Path)

Exit Function

INIWrite_Error:
ErrH App.ProductName & " code library", "INIWrite"
Exit Function
End Function
Function RegWrite(ByVal Place As String, ByVal Key As String, ByVal DesValue As String)
On Error GoTo RegWrite_Error

SaveSetting App.ProductName, Place, Key, DesValue

Exit Function
RegWrite_Error:
ErrH App.ProductName & " code library", "Function RegWrite"
Exit Function
End Function

