VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RegistryAccess"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Type FILETIME
    lLowDateTime    As Long
    lHighDateTime   As Long
End Type
 
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegQueryValueExA Lib "advapi32.dll" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByRef lpData As Long, lpcbData As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Private Declare Function RegSetValueExA Lib "advapi32.dll" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByRef lpData As Long, ByVal cbData As Long) As Long
Private Declare Function RegSetValueExB Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByRef lpData As Byte, ByVal cbData As Long) As Long

Private Const ERROR_SUCCESS = 0&
Private Const ERROR_BADDB = 1009&
Private Const ERROR_BADKEY = 1010&
Private Const ERROR_CANTOPEN = 1011&
Private Const ERROR_CANTREAD = 1012&
Private Const ERROR_CANTWRITE = 1013&
Private Const ERROR_OUTOFMEMORY = 14&
Private Const ERROR_INVALID_PARAMETER = 87&
Private Const ERROR_ACCESS_DENIED = 5&
Private Const ERROR_NO_MORE_ITEMS = 259&
Private Const ERROR_MORE_DATA = 234&

    Public Enum uRegistryTypes
    REG_NONE = 0&
    REG_SZ = 1&
    REG_EXPAND_SZ = 2&
    REG_BINARY = 3&
    REG_DWORD = 4&
    REG_DWORD_LITTLE_ENDIAN = 4&
    REG_DWORD_BIG_ENDIAN = 5&
    REG_LINK = 6&
    REG_MULTI_SZ = 7&
    REG_RESOURCE_LIST = 8&
    REG_FULL_RESOURCE_DESCRIPTOR = 9&
    REG_RESOURCE_REQUIREMENTS_LIST = 10&
    End Enum

Private Const KEY_QUERY_VALUE = &H1&
Private Const KEY_SET_VALUE = &H2&
Private Const KEY_CREATE_SUB_KEY = &H4&
Private Const KEY_ENUMERATE_SUB_KEYS = &H8&
Private Const KEY_NOTIFY = &H10&
Private Const KEY_CREATE_LINK = &H20&
Private Const READ_CONTROL = &H20000
Private Const WRITE_DAC = &H40000
Private Const WRITE_OWNER = &H80000
Private Const SYNCHRONIZE = &H100000
Private Const STANDARD_RIGHTS_REQUIRED = &HF0000
Private Const STANDARD_RIGHTS_READ = READ_CONTROL
Private Const STANDARD_RIGHTS_WRITE = READ_CONTROL
Private Const STANDARD_RIGHTS_EXECUTE = READ_CONTROL
Private Const KEY_READ = STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY
Private Const KEY_WRITE = STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY
Private Const KEY_EXECUTE = KEY_READ

Private Const HKEY_CLASSES_ROOT = &H80000000
Private Const HKEY_CURRENT_USER = &H80000001
Private Const HKEY_LOCAL_MACHINE = &H80000002
Private Const HKEY_USERS = &H80000003
Private Const HKEY_PERFORMANCE_DATA = &H80000004
Private Const HKEY_CURRENT_CONFIG = &H80000005
Private Const HKEY_DYN_DATA = &H80000006

Private hKey As Long, lLngMainHeyHandle As Long
Private rtn As Long, lLngBuffer As Long, lStrBuffer As String
Private lLngBufferSize As Long
Private lLngDataSize As Long
Private ByteArray() As Byte

'This constant determins wether or not to display error messages to the
'user. I have set the default value to False as an error message can and
'does become irritating after a while. Turn this value to true if you want
'to debug your programming code when reading and writing to your system
'registry, as any errors will be displayed in a message box.

Private Const DisplayErrorMsg = False
Private Function SetDWORDValue(Subkey As String, Entry As String, Value As Long)

Call ParseKey(Subkey, lLngMainHeyHandle)

    If lLngMainHeyHandle Then
    rtn = RegOpenKeyEx(lLngMainHeyHandle, Subkey, 0, KEY_WRITE, hKey) 'open the key
        
        If rtn = ERROR_SUCCESS Then 'if the key was open successfully then
        rtn = RegSetValueExA(hKey, Entry, 0, REG_DWORD, Value, 4) 'write the value
            
            If Not rtn = ERROR_SUCCESS Then   'if there was an error writting the value
            Err.Raise 10002, "SetDWORDValue", "Couldn't set Key Value: Wrong type"
            End If
        
        rtn = RegCloseKey(hKey) 'close the key
        Else 'if there was an error opening the key
        Err.Raise 10001, "SetDWORDValue", "Couldn't open Key: " & ErrorMsg(rtn) & "(" & rtn & ")"
        
        End If
    
    End If

End Function
Public Function GetValue(SubkeyEntry As String) As String
Dim lStrSubkey As String, lStrEntry As String, lStrReturn As String
On Error Resume Next

ParseKeyPath SubkeyEntry, lStrSubkey, lStrEntry


lStrReturn = GetDWORDValue(lStrSubkey, lStrEntry)

    If Err.number = 10002 Then 'Falhou com Long. Tentar um String.
    On Error Resume Next
    lStrReturn = GetBinaryValue(lStrSubkey, lStrEntry)
    End If
    
    If Err.number = 10002 Then 'Falhou com Long. Tentar um String.
    On Error Resume Next
    lStrReturn = GetStringValue(lStrSubkey, lStrEntry)
    End If

GetValue = lStrReturn

End Function
Private Function ParseKeyPath(ByVal uPath As String, rSubkey As String, rEntry As String)
Dim lStrSubkey As String, lStrEntry As String, lStrtemp As String, lLngBarPointer As Long, lStrReturn As String

lStrtemp = StrReverse(uPath)

lLngBarPointer = InStr(lStrtemp, "\")

    If lLngBarPointer = 0 Then
    Err.Raise 10001, App.ProductName, "String not in comformity."
    Exit Function
    
    Else
    rEntry = Right$(uPath, lLngBarPointer - 1)
    rSubkey = Left$(uPath, Len(uPath) - lLngBarPointer)
    
    End If

End Function
Public Function SetValue(SubkeyEntry As String, pValue As String, Optional uType As uRegistryTypes = REG_NONE) As String
Dim lStrSubkey As String, lStrEntry As String, lStrReturn As String, lLngType As uRegistryTypes

ParseKeyPath SubkeyEntry, lStrSubkey, lStrEntry

    If uType = REG_NONE Then 'tentar adivinhar o tipo a ser gravado.
    
        If IsNumeric(pValue) Then
        lLngType = REG_DWORD
        
        Else
        lLngType = REG_SZ
        
        End If
    
    End If
    

    If lLngType = REG_DWORD Then
    lStrReturn = SetDWORDValue(lStrSubkey, lStrEntry, CLng(pValue))
    
    ElseIf lLngType = REG_BINARY Then
    lStrReturn = SetBinaryValue(lStrSubkey, lStrEntry, pValue)
    
    Else
    lStrReturn = SetStringValue(lStrSubkey, lStrEntry, pValue)
    
    End If
    
SetValue = lStrReturn

End Function
Private Function GetDWORDValue(ByVal Subkey As String, ByVal Entry As String)

Call ParseKey(Subkey, lLngMainHeyHandle)

    If lLngMainHeyHandle Then
    rtn = RegOpenKeyEx(lLngMainHeyHandle, Subkey, 0, KEY_READ, hKey) 'open the key
    
        If rtn = ERROR_SUCCESS Then 'if the key could be opened then
        rtn = RegQueryValueExA(hKey, Entry, 0, REG_DWORD, lLngBuffer, 4) 'get the value from the registry
        
            If rtn = ERROR_SUCCESS Then 'if the value could be retreived then
            rtn = RegCloseKey(hKey)  'close the key
            GetDWORDValue = lLngBuffer  'return the value
            
            Else                        'otherwise, if the value couldnt be retreived
            Err.Raise 10002, "GetDWORDValue", "Couldn't get Key Value: " & ErrorMsg(rtn) & "(" & rtn & ")"
        
        End If
        
        Else 'otherwise, if the key couldnt be opened
        Err.Raise 10001, "GetDWORDValue", "Couldn't open Key: " & ErrorMsg(rtn) & "(" & rtn & ")"
        
        End If
    
    End If

End Function
Private Function SetBinaryValue(Subkey As String, Entry As String, Value As String)
Dim i As Integer
Call ParseKey(Subkey, lLngMainHeyHandle)

If lLngMainHeyHandle Then
   rtn = RegOpenKeyEx(lLngMainHeyHandle, Subkey, 0, KEY_WRITE, hKey) 'open the key
   If rtn = ERROR_SUCCESS Then 'if the key was open successfully then
      lLngDataSize = Len(Value)
      ReDim ByteArray(lLngDataSize)
      For i = 1 To lLngDataSize
      ByteArray(i) = Asc(Mid$(Value, i, 1))
      Next
      rtn = RegSetValueExB(hKey, Entry, 0, REG_BINARY, ByteArray(1), lLngDataSize) 'write the value
      If Not rtn = ERROR_SUCCESS Then   'if the was an error writting the value
         If DisplayErrorMsg = True Then 'if the user want errors displayed
            MsgBox ErrorMsg(rtn)        'display the error
         End If
      End If
      rtn = RegCloseKey(hKey) 'close the key
   Else 'if there was an error opening the key
      If DisplayErrorMsg = True Then 'if the user wants errors displayed
         MsgBox ErrorMsg(rtn) 'display the error
      End If
   End If
End If

End Function
Private Function GetBinaryValue(ByVal Subkey As String, ByVal Entry As String)

Call ParseKey(Subkey, lLngMainHeyHandle)

If lLngMainHeyHandle Then
rtn = RegOpenKeyEx(lLngMainHeyHandle, Subkey, 0, KEY_READ, hKey) 'open the key

    If rtn = ERROR_SUCCESS Then 'if the key could be opened
    lLngBufferSize = 1
    rtn = RegQueryValueEx(hKey, Entry, 0, REG_BINARY, 0, lLngBufferSize) 'get the value from the registry
    lStrBuffer = Space(lLngBufferSize)
    rtn = RegQueryValueEx(hKey, Entry, 0, REG_BINARY, lStrBuffer, lLngBufferSize) 'get the value from the registry
        
        If rtn = ERROR_SUCCESS Then 'if the value could be retreived then
        rtn = RegCloseKey(hKey)  'close the key
        GetBinaryValue = lStrBuffer 'return the value to the user
        
        Else                        'otherwise, if the value couldnt be retreived
        Err.Raise 10002, "GetBinaryValue", "Couldn't get Key Value: " & ErrorMsg(rtn) & "(" & rtn & ")"
        
        End If
    
    Else 'otherwise, if the key couldnt be opened
    Err.Raise 10001, "GetBinaryValue", "Couldn't open Key: " & ErrorMsg(rtn) & "(" & rtn & ")"
    
    GetBinaryValue = "Error" 'return Error to the user
        
        If DisplayErrorMsg = True Then 'if the user wants to errors displayed
        MsgBox ErrorMsg(rtn)  'display the error to the user
        End If
    
    End If

End If

End Function
Public Function DeleteKey(Keyname As String)

Call ParseKey(Keyname, lLngMainHeyHandle)

If lLngMainHeyHandle Then
   rtn = RegOpenKeyEx(lLngMainHeyHandle, Keyname, 0, KEY_WRITE, hKey) 'open the key
   If rtn = ERROR_SUCCESS Then 'if the key could be opened then
      rtn = RegDeleteKey(hKey, Keyname) 'delete the key
      rtn = RegCloseKey(hKey)  'close the key
   End If
End If

End Function
Private Function GetlLngMainHeyHandle(ByVal MainKeyName As String) As Long

Select Case UCase(MainKeyName)
       Case "HKEY_CLASSES_ROOT"
            GetlLngMainHeyHandle = HKEY_CLASSES_ROOT
       Case "HKEY_CURRENT_USER"
            GetlLngMainHeyHandle = HKEY_CURRENT_USER
       Case "HKEY_LOCAL_MACHINE"
            GetlLngMainHeyHandle = HKEY_LOCAL_MACHINE
       Case "HKEY_USERS"
            GetlLngMainHeyHandle = HKEY_USERS
       Case "HKEY_PERFORMANCE_DATA"
            GetlLngMainHeyHandle = HKEY_PERFORMANCE_DATA
       Case "HKEY_CURRENT_CONFIG"
            GetlLngMainHeyHandle = HKEY_CURRENT_CONFIG
       Case "HKEY_DYN_DATA"
            GetlLngMainHeyHandle = HKEY_DYN_DATA
End Select

End Function
Private Function ErrorMsg(lErrorCode As Long) As String
    
'If an error does accurr, and the user wants error messages displayed, then
'display one of the following error messages
Dim GetErrorMsg As String
Select Case lErrorCode
       Case 1009, 1015
            GetErrorMsg = "The Registry Database is corrupt!"
       Case 2, 1010
            GetErrorMsg = "Bad Key Name"
       Case 1011
            GetErrorMsg = "Can't Open Key"
       Case 4, 1012
            GetErrorMsg = "Can't Read Key"
       Case 5
            GetErrorMsg = "Access to this key is denied"
       Case 1013
            GetErrorMsg = "Can't Write Key"
       Case 8, 14
            GetErrorMsg = "Out of memory"
       Case 87
            GetErrorMsg = "Invalid Parameter"
       Case 234
            GetErrorMsg = "There is more data than the buffer has been allocated to hold."
       Case Else
            GetErrorMsg = "Undefined Error Code:  " & str$(lErrorCode)
End Select

End Function
Private Function AGetStringValue(Subkey As String, Entry As String)

Call ParseKey(Subkey, lLngMainHeyHandle)

If lLngMainHeyHandle Then
rtn = RegOpenKeyEx(lLngMainHeyHandle, Subkey, 0, KEY_READ, hKey) 'open the key
    
    If rtn = ERROR_SUCCESS Then 'if the key could be opened then
    lStrBuffer = Space(255)     'make a buffer
    lLngBufferSize = Len(lStrBuffer)
    rtn = RegQueryValueEx(hKey, Entry, 0, REG_SZ, lStrBuffer, lLngBufferSize) 'get the value from the registry
        
        If rtn = ERROR_SUCCESS Then 'if the value could be retreived then
        rtn = RegCloseKey(hKey)  'close the key
        lStrBuffer = Trim(lStrBuffer)
        AGetStringValue = Left(lStrBuffer, Len(lStrBuffer) - 1) 'return the value to the user
        
        Else                        'otherwise, if the value couldnt be retreived
        Err.Raise 10002, "AGetStringValue", "Couldn't get Key Value: " & ErrorMsg(rtn) & "(" & rtn & ")"
        
        End If
    
    Else 'otherwise, if the key couldnt be opened
    Err.Raise 10001, "GetDWORDValue", "Couldn't open Key: " & ErrorMsg(rtn) & "(" & rtn & ")"
    
    End If

End If

End Function
Private Sub ParseKey(Keyname As String, Keyhandle As Long)
    
rtn = InStr(Keyname, "\") 'return if "\" is contained in the Keyname

    If Left(Keyname, 5) <> "HKEY_" Or Right(Keyname, 1) = "\" Then 'if the is a "\" at the end of the Keyname then
    MsgBox "Incorrect Format:" + Chr(10) + Chr(10) + Keyname 'display error to the user
    Exit Sub 'exit the procedure
    
    ElseIf rtn = 0 Then 'if the Keyname contains no "\"
    Keyhandle = GetlLngMainHeyHandle(Keyname)
    Keyname = "" 'leave Keyname blank
    
    Else 'otherwise, Keyname contains "\"
    Keyhandle = GetlLngMainHeyHandle(Left(Keyname, rtn - 1)) 'seperate the Keyname
    Keyname = Right(Keyname, Len(Keyname) - rtn)
    
    End If

End Sub
Public Function CreateKey(Subkey As String)

Call ParseKey(Subkey, lLngMainHeyHandle)

If lLngMainHeyHandle Then
   rtn = RegCreateKey(lLngMainHeyHandle, Subkey, hKey) 'create the key
   If rtn = ERROR_SUCCESS Then 'if the key was created then
      rtn = RegCloseKey(hKey)  'close the key
   End If
End If

End Function
Private Function SetStringValue(Subkey As String, Entry As String, Value As String)

Call ParseKey(Subkey, lLngMainHeyHandle)

If lLngMainHeyHandle Then
   rtn = RegOpenKeyEx(lLngMainHeyHandle, Subkey, 0, KEY_WRITE, hKey) 'open the key
   If rtn = ERROR_SUCCESS Then 'if the key was open successfully then
      rtn = RegSetValueEx(hKey, Entry, 0, REG_SZ, ByVal Value, Len(Value)) 'write the value
      If Not rtn = ERROR_SUCCESS Then   'if there was an error writting the value
         If DisplayErrorMsg = True Then 'if the user wants errors displayed
            MsgBox ErrorMsg(rtn)        'display the error
         End If
      End If
      rtn = RegCloseKey(hKey) 'close the key
   Else 'if there was an error opening the key
      If DisplayErrorMsg = True Then 'if the user wants errors displayed
         MsgBox ErrorMsg(rtn)        'display the error
      End If
   End If
End If

End Function
Public Function DeleteEntry(ByVal SubkeyEntry)
Dim Subkey As String, Entry As String

Call ParseKeyPath(SubkeyEntry, Subkey, Entry)
Call ParseKey(Subkey, lLngMainHeyHandle)

If lLngMainHeyHandle Then
rtn = RegOpenKeyEx(lLngMainHeyHandle, Subkey, 0, KEY_WRITE, hKey) 'open the key
    
    If rtn = ERROR_SUCCESS Then 'if the key was open successfully then
    rtn = RegDeleteValue(hKey, Entry)  'Kill the Entry
        
        If Not rtn = ERROR_SUCCESS Then   'if there was an error writting the value
'        Err.Raise 10002, "DeleteEntry", "Couldn't get Key Value: " & ErrorMsg(rtn) & "(" & rtn & ")"
        
        End If
    
    rtn = RegCloseKey(hKey) 'close the key
    
    Else 'if there was an error opening the key
    Err.Raise 10001, "DeleteEntry", "Couldn't open Key: " & ErrorMsg(rtn) & "(" & rtn & ")"
    
    End If

End If

End Function
Private Function GetStringValue(ByVal Subkey As String, ByVal Entry As String) As String
Dim MemString As String
MemString = AGetStringValue(Subkey, Entry)
If InStr(MemString, Chr(0)) Then
    GetStringValue = Left(MemString, InStr(MemString, Chr(0)) - 1)
Else
    GetStringValue = MemString
End If
End Function
Public Function ClearString(ByVal uString) As String
    
    If InStr(uString, Chr(0)) Then
    ClearString = Left(uString, InStr(uString, Chr(0)) - 1)
    
    Else
    ClearString = uString
    
    End If

End Function
