VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "System"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Type LUID: UsedPart As Long: IgnoredForNowHigh32BitPart As Long: End Type
Private Type TOKEN_PRIVILEGES: PrivilegeCount As Long: TheLuid As LUID: Attributes As Long: End Type
Private Type OSVERSIONINFO: dwOSVersionInfoSize As Long: dwMajorVersion As Long: dwMinorVersion As Long: dwBuildNumber As Long: dwPlatformId As Long: szCSDVersion As String * 128: End Type

Private Const TOKEN_ADJUST_PRIVILEGES = &H20
Private Const TOKEN_QUERY = &H8
Private Const SE_PRIVILEGE_ENABLED = &H2
Private Const EWX_SHUTDOWN As Long = 1
Private Const EWX_FORCE As Long = 4
Private Const EWX_REBOOT = 2
Private Const HKLM = &H80000002
Private Const KEY_READ = &H20019
Private Const MAX_SIZE = 2048
Private Const ERROR_MORE_DATA = 234
Private Const ERROR_SUCCESS = 0&
Private Const REG_SZ = 1
Private Const REG_EXPAND_SZ = 2
Private Const REG_BINARY = 3
Private Const REG_DWORD = 4
Private Const REG_MULTI_SZ = 7

Private Declare Function GetVolumeInformation Lib "kernel32.dll" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Integer, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long
Private Declare Function GetTickCount Lib "kernel32" () As Long
Private Declare Function GetCurrentProcess Lib "kernel32" () As Long
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (LpVersionInformation As OSVERSIONINFO) As Long
Private Declare Function OpenProcessToken Lib "advapi32" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long
Private Declare Function LookupPrivilegeValue Lib "advapi32" Alias "LookupPrivilegeValueA" (ByVal lpSystemName As String, ByVal lpName As String, lpLuid As LUID) As Long
Private Declare Function AdjustTokenPrivileges Lib "advapi32" (ByVal TokenHandle As Long, ByVal DisableAllPrivileges As Long, NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Long, PreviousState As TOKEN_PRIVILEGES, ReturnLength As Long) As Long
Private Declare Function ExitWindowsEx Lib "user32" (ByVal dwOptions As Long, ByVal dwReserved As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, source As Any, ByVal numBytes As Long)
Private Declare Function lstrlenA Lib "kernel32" (ByVal lpString As Long) As Long
Private Declare Function CopyStringA Lib "kernel32" Alias "lstrcpyA" (ByVal NewString As String, ByVal OldString As Long) As Long
Public Function GetDeviceSerialNumber(strDrive As String) As Long
  Dim SerialNum As Long
  Dim Res As Long
  Dim Temp1 As String
  Dim Temp2 As String
  
  Temp1 = String$(255, Chr$(0))
  Temp2 = String$(255, Chr$(0))
  Res = GetVolumeInformation(strDrive, Temp1, _
  Len(Temp1), SerialNum, 0, 0, Temp2, Len(Temp2))
  
  GetDeviceSerialNumber = SerialNum
End Function
Public Function TickCount()
TickCount = GetTickCount()
End Function
Private Sub AdjustToken()
Dim hdlProcessHandle As Long
Dim hdlTokenHandle As Long
Dim tmpLuid As LUID
Dim tkp As TOKEN_PRIVILEGES
Dim tkpNewButIgnored As TOKEN_PRIVILEGES
Dim lBufferNeeded As Long

hdlProcessHandle = GetCurrentProcess()
OpenProcessToken hdlProcessHandle, (TOKEN_ADJUST_PRIVILEGES Or _
TOKEN_QUERY), hdlTokenHandle

' Get the LUID for shutdown privilege.
LookupPrivilegeValue "", "SeShutdownPrivilege", tmpLuid

tkp.PrivilegeCount = 1    ' One privilege to set
tkp.TheLuid = tmpLuid
tkp.Attributes = SE_PRIVILEGE_ENABLED

' Enable the shutdown privilege in the access token of this process.
AdjustTokenPrivileges hdlTokenHandle, False, _
tkp, Len(tkpNewButIgnored), tkpNewButIgnored, lBufferNeeded

End Sub
Public Sub RebooTNT()
AdjustToken
ExitWindowsEx (EWX_REBOOT), &HFFFF
End Sub
Public Sub LogOffNT()
AdjustToken
ExitWindowsEx (EWX_FORCE), &HFFFF
End Sub
Public Sub ShutdownNT()
AdjustToken
ExitWindowsEx (EWX_SHUTDOWN), &HFFFF
End Sub
Public Function SystemIsNTTechnology() As Boolean
Dim verinfo As OSVERSIONINFO
verinfo.dwOSVersionInfoSize = Len(verinfo)
    
    If (GetVersionEx(verinfo)) = 0 Then Exit Function
    If verinfo.dwPlatformId = 2 Then SystemIsNTTechnology = True

End Function
Public Property Get VideoBiosDate() As String
    
    If SystemIsNTTechnology Then
    VideoBiosDate = GetRegistryValue(HKLM, "Hardware\Description\System", "VideoBiosDate", "")
    
    Else
    '       VideoBiosDate = Mid(StrFromPtrA(&HC00A8), 1, 8) '-Date build
    VideoBiosDate = Mid(StrFromPtrA(&HC00A8), 9, 8) '-Date revision
    
    End If

End Property

Public Property Get VideoBiosVersion() As String
Dim s As String

    If SystemIsNTTechnology Then
    s = GetRegistryValue(HKLM, "Hardware\Description\System", "VideoBiosVersion", "")
    
    Else
    s = StrFromPtrA(&HC0048)
    s = Left(s, InStr(1, s, vbCrLf) - 1)
    s = s & vbCrLf & "ChipType: " & GetRegistryValue(HKLM, "System\CurrentControlSet\Services\Class\Display\0000\INFO", "ChipType", "")
    
    End If

VideoBiosVersion = s

End Property
Public Property Get VideoBiosCopyRight() As String
Dim s As String
    
    If SystemIsNTTechnology Then
    s = "Unavailable on NT"
    
    Else
    s = StrFromPtrA(&HC0048)
    s = Mid$(s, InStr(1, s, vbCrLf) + 2)
    
    End If

VideoBiosCopyRight = s

End Property
Public Property Get SystemBiosDate() As String

    If SystemIsNTTechnology Then
    SystemBiosDate = GetRegistryValue(HKLM, "Hardware\Description\System", "SystemBiosDate", "")
    
    Else
    SystemBiosDate = StrFromPtrA(&HFFFF5)
    
    End If

End Property
Public Property Get SystemBiosCopyRight() As String
    
    If SystemIsNTTechnology Then
    SystemBiosCopyRight = "Unvailable on NT"
    
    Else
    SystemBiosCopyRight = StrFromPtrA(&HFE08E)
    
    End If

End Property
Public Property Get SystemBiosVersion() As String
Dim vAns As Variant

    If SystemIsNTTechnology Then
    On Error Resume Next
    SystemBiosVersion = CDate(GetRegistryValue(HKLM, "Hardware\Description\System", "SystemBiosVersion", ""))
    
        If Err.Number > 0 Then SystemBiosVersion = "Unavailable"
    
    Else
    SystemBiosVersion = StrFromPtrA(&HFE060)
    
    End If

End Property
Public Property Get SystemBiosExtraInfo() As String
    
    If SystemIsNTTechnology Then
    SystemBiosExtraInfo = "Unvailable on NT"
    
    Else
    SystemBiosExtraInfo = StrFromPtrA(&HFEC71)
    
    End If

End Property
Public Function GetRegistryValue(ByVal hKey As Long, ByVal KeyName As String, _
    ByVal ValueName As String, Optional DefaultValue As Variant) As Variant
Dim handle As Long
Dim resLong As Long
Dim resString As String
Dim resBinary() As Byte
Dim length As Long
Dim retVal As Long
Dim valueType As Long
GetRegistryValue = IIf(IsMissing(DefaultValue), Empty, DefaultValue)
    
    If RegOpenKeyEx(hKey, KeyName, 0, KEY_READ, handle) Then
    Exit Function
    End If

length = MAX_SIZE
ReDim resBinary(0 To length - 1) As Byte
retVal = RegQueryValueEx(handle, ValueName, 0, valueType, resBinary(0), length)
    
    If retVal = ERROR_MORE_DATA Then
    ReDim resBinary(0 To length - 1) As Byte
    retVal = RegQueryValueEx(handle, ValueName, 0, valueType, resBinary(0), length)
    End If

    Select Case valueType
    
    Case REG_DWORD
    CopyMemory resLong, resBinary(0), 4
    GetRegistryValue = resLong
    
    Case REG_SZ, REG_EXPAND_SZ
    resString = Space$(length - 1)
    CopyMemory ByVal resString, resBinary(0), length - 1
    GetRegistryValue = resString
    
    Case REG_BINARY
        
        If length <> UBound(resBinary) + 1 Then
        ReDim Preserve resBinary(0 To length - 1) As Byte
        End If
    
    GetRegistryValue = resBinary()
    
    Case REG_MULTI_SZ
    resString = Space$(length - 2)
    CopyMemory ByVal resString, resBinary(0), length - 2
    GetRegistryValue = resString
    
    Case Else
    RegCloseKey handle
    
    End Select

RegCloseKey handle

End Function
Public Function StrFromPtrA(ByVal lpszA As Long) As String
Dim s As String
s = String(lstrlenA(lpszA), Chr$(0))
CopyStringA s, ByVal lpszA
StrFromPtrA = TrimNULL(s)
End Function
Private Function TrimNULL(ByVal str As String) As String

    If InStr(str, Chr$(0)) > 0& Then
    TrimNULL = Left$(str, InStr(str, Chr$(0)) - 1&)
    
    Else
    TrimNULL = str
    
    End If

End Function
