VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsBase64"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Base64Tab(63) As Byte
Private DecodeTable(233) As Byte
Public Sub Class_Initialize()
On Error GoTo psClass_InitializeErr 'EHCG.UID.psClass_Initialize

Dim i As Byte
    'initialize the base64 table
    Dim tDecodeTable As Variant
    tDecodeTable = Array("255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "62", "255", "255", "255", "63", "52", "53", "54", "55", "56", "57", "58", "59", "60", "61", "255", "255", "255", "64", "255", "255", "255", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", _
        "18", "19", "20", "21", "22", "23", "24", "25", "255", "255", "255", "255", "255", "255", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255" _
        , "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255", "255")
    For i = LBound(tDecodeTable) To UBound(tDecodeTable)
        DecodeTable(i) = tDecodeTable(i)
    Next
    For i = 65 To 90
        Base64Tab(i - 65) = i
    Next
    For i = 97 To 122
        Base64Tab(i - 71) = i
    Next
    For i = 0 To 9
        Base64Tab(i + 52) = 48 + i
    Next
    Base64Tab(62) = 43
    Base64Tab(63) = 47

Exit Sub
psClass_InitializeErr:
Err.Raise Err.Number, Err.Source, "ps.Class_Initialize (" & Err.Number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Public Function Encode(ByVal strInput As Variant) As String
On Error GoTo pfEncodeErr 'EHCG.UID.pfEncode

Dim tmpSlot(2) As Byte
Dim tmpCounter As Long
Dim lngLenght As Long
Dim bytRemaining As Byte
Dim tmpOutput As String

lngLenght = Len(strInput) 'lngLenght of the string
bytRemaining = ((lngLenght) Mod 3)

    For tmpCounter = 0 To lngLenght - (bytRemaining + 1) Step 3
    '3 bytes in
    tmpSlot(0) = Asc(Mid$(strInput, tmpCounter + 1, 1))
    tmpSlot(1) = Asc(Mid$(strInput, tmpCounter + 2, 1))
    tmpSlot(2) = Asc(Mid$(strInput, tmpCounter + 3, 1))
    '4 bytes out
    Add tmpOutput, Chr$(Base64Tab((tmpSlot(0) \ 4) And &H3F))
    Add tmpOutput, Chr$(Base64Tab((tmpSlot(0) And &H3) * 16 Or (tmpSlot(1) \ 16) And &HF))
    Add tmpOutput, Chr$(Base64Tab((tmpSlot(1) And &HF) * 4 Or (tmpSlot(2) \ 64) And &H3))
    Add tmpOutput, Chr$(Base64Tab(tmpSlot(2) And &H3F))
    Next


    If bytRemaining = 1 Then ' if there is 1 byte bytRemaining
    'read 1 byte, the second in 0
    tmpSlot(0) = Asc(Mid$(strInput, Len(strInput), 1)) ''''''''
    tmpSlot(1) = 0
    '    Out(UBound(Out) - 3) = Base64Tab((tmpSlot(0) \ 4) And &H3F)
    '    Out(UBound(Out) - 2) = Base64Tab((tmpSlot(0) And &H3) * 16 Or (tmpSlot(1) \ 16) And &HF)
    '    Out(UBound(Out) - 1) = 61
    '    Out(UBound(Out)) = 61

    Add tmpOutput, Chr$(Base64Tab((tmpSlot(0) \ 4) And &H3F))
    Add tmpOutput, Chr$(Base64Tab((tmpSlot(0) And &H3) * 16 Or (tmpSlot(1) \ 16) And &HF))
    Add tmpOutput, Chr$(61)
    Add tmpOutput, Chr$(61)

    ElseIf bytRemaining = 2 Then 'if there are 2 bytes bytRemaining
    'read 2 bytes, the third is 0
    tmpSlot(0) = Asc(Mid$(strInput, Len(strInput) - 1, 1)) ''''''''''''''
    tmpSlot(1) = Asc(Mid$(strInput, Len(strInput), 1)) ''''''''''''''
    tmpSlot(2) = 0
    Add tmpOutput, Chr$(Base64Tab((tmpSlot(0) \ 4) And &H3F))
    Add tmpOutput, Chr$(Base64Tab((tmpSlot(0) And &H3) * 16 Or (tmpSlot(1) \ 16) And &HF))
    Add tmpOutput, Chr$(Base64Tab((tmpSlot(1) And &HF) * 4 Or (tmpSlot(2) \ 64) And &H3))
    Add tmpOutput, Chr$(61)
    End If

Encode = tmpOutput

Exit Function
pfEncodeErr:
Err.Raise Err.Number, Err.Source, "pf.Encode (" & Err.Number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Function
Public Sub Str2ByteArray(StringIn As String, ByteArray() As Byte)
On Error GoTo psStr2ByteArrayErr 'EHCG.UID.psStr2ByteArray

    ByteArray = StrConv(StringIn, vbFromUnicode)

Exit Sub
psStr2ByteArrayErr:
Err.Raise Err.Number, Err.Source, "ps.Str2ByteArray (" & Err.Number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Public Sub Span(CharsPerLine As Long, InArray() As Byte, OutArray() As Byte)
On Error GoTo psSpanErr 'EHCG.UID.psSpan

Dim Lines As Long
Dim i2 As Long
Dim i As Long
Dim TempI As Long
Lines = ((UBound(InArray) + 1) + (UBound(InArray) + 1) Mod CharsPerLine) / CharsPerLine
ReDim OutArray(LBound(InArray) To UBound(InArray) + (Lines * 2))
TempI = 0
While Not TempI > UBound(InArray)
    For i = TempI To TempI + CharsPerLine - 1
        If i2 > UBound(OutArray) Or i > UBound(InArray) Then Exit Sub
        OutArray(i2) = InArray(i)
        i2 = i2 + 1
    Next
    If i2 > UBound(OutArray) Then Exit Sub
    OutArray(i2) = 13
    OutArray(i2 + 1) = 10
    TempI = TempI + CharsPerLine
    i2 = i2 + 2
Wend

Exit Sub
psSpanErr:
Err.Raise Err.Number, Err.Source, "ps.Span (" & Err.Number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Public Function Decode(ByVal uInput1 As Variant) As String
On Error GoTo pfDecodeErr 'EHCG.UID.pfDecode

Dim tmpSlot(3) As Byte
Dim tmpCounter As Long
Dim bytRemaining As Byte
Dim lngBytesOut As Long
Dim uOutput As String
Dim lngLenght As Long
Dim lStrStep As String
Dim uInput As String

uInput = uInput1
lStrStep = "Init"

    If uInput = "" Then Exit Function

If Asc(Right(uInput, 1)) = 61 Then
    bytRemaining = 1
    If Asc(Right(uInput, 2)) = 61 Then
        bytRemaining = 2
    End If
End If

lStrStep = "After first IF"


lngLenght = Len(uInput) 'lngLenght of the string
lngBytesOut = ((lngLenght / 4) * 3) - bytRemaining ' how many bytes will the decoded string have


For tmpCounter = 0 To lngLenght - 1 Step 4
    lStrStep = "First FOR loop"
    tmpSlot(0) = DecodeTable(Asc(Mid$(uInput, tmpCounter + 1)))
    tmpSlot(1) = DecodeTable(Asc(Mid$(uInput, tmpCounter + 2)))
    tmpSlot(2) = DecodeTable(Asc(Mid$(uInput, tmpCounter + 3)))
    tmpSlot(3) = DecodeTable(Asc(Mid$(uInput, tmpCounter + 4)))

    If tmpSlot(3) = 64 Or tmpSlot(2) = 64 Then
    lStrStep = "Second FOR loop"

        If tmpSlot(3) = 64 And Not (tmpSlot(2) = 64) Then
        lStrStep = "Third FOR loop"

            tmpSlot(0) = DecodeTable(Asc(Mid$(uInput, tmpCounter + 1)))
            tmpSlot(1) = DecodeTable(Asc(Mid$(uInput, tmpCounter + 2)))
            tmpSlot(2) = DecodeTable(Asc(Mid$(uInput, tmpCounter + 3)))
            '2 bytes out
            Add uOutput, Chr$((tmpSlot(0) * 4) Or ((tmpSlot(1) \ 16) And &H3))
            Add uOutput, Chr$(((tmpSlot(1) And &HF) * 16) Or ((tmpSlot(2) \ 4) And &HF))
            Decode = uOutput
            Exit Function
        ElseIf tmpSlot(2) = 64 Then
        lStrStep = "First ELSE condition"

            tmpSlot(0) = DecodeTable(Asc(Mid$(uInput, tmpCounter + 1)))
            tmpSlot(1) = DecodeTable(Asc(Mid$(uInput, tmpCounter + 2)))
            '1 byte out
            Add uOutput, Chr$((tmpSlot(0) * 4) Or ((tmpSlot(1) \ 16) And &H3))
            Decode = uOutput
            Exit Function
        End If
    End If
    '3 bytes out
    Add uOutput, Chr$((tmpSlot(0) * 4) Or ((tmpSlot(1) \ 16) And &H3))
    Add uOutput, Chr$(((tmpSlot(1) And &HF) * 16) Or ((tmpSlot(2) \ 4) And &HF))
    Add uOutput, Chr$(((tmpSlot(2) And &H3) * 64) Or tmpSlot(3))
'    iTemp = iTemp + 3
Next

Decode = uOutput

Exit Function
pfDecodeErr:
Err.Raise Err.Number, Err.Source, "pf.Decode (" & Err.Number & ": " & Err.Description & ") in " & lStrStep & ". Contents: " & vbCrLf & uInput, Err.HelpFile, Err.HelpContext

End Function
Public Sub Unspan(ArrayIn() As Byte, ArrayOut() As Byte)
On Error GoTo psUnspanErr 'EHCG.UID.psUnspan

    Dim sTemp As String
    sTemp = StrConv(ArrayIn, vbUnicode)
    sTemp = Replace(sTemp, vbCrLf, "")
    ArrayOut = StrConv(sTemp, vbFromUnicode)

Exit Sub
psUnspanErr:
Err.Raise Err.Number, Err.Source, "ps.Unspan (" & Err.Number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
