VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Ambients"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"UserDefinedCollection"
Attribute VB_Ext_KEY = "Member0" ,"Ambient"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'================================================================================================
'ambients Collection
'================================================================================================

Option Explicit

'local variable to hold collection
Private mCol As Collection
Public Function Add(ByVal uambient As Ambient) As Ambient
Dim lObjRS As Recordset, lStrSQL As String

    With uambient
        If False Then
        Err.Raise &H5002, "ambients Collection", "Couldn't insert Item: Essential info missing."
        Exit Function
        End If

    Set lObjRS = Data.Database.Execute("SELECT * FROM [ambient] WHERE [ID]=" & .ID)

        If Not lObjRS.EOF Then
        Err.Raise &H5003, "ambients Collection", "Couldn't insert Item: trying to replicate Unique Identifier field [ID]."
        Exit Function
        End If

Dim uTmpShop As String, _
uTmpName As String, _
uTmpDescr As String

    If TypeName(.Shop) = "Nothing" Then uTmpShop = "null" Else uTmpShop = .Shop.ID
uTmpName = IIf(.Name = "", "null", "'" & .Name & "'")
uTmpDescr = IIf(.Descr = "", "null", "'" & .Descr & "'")

    lStrSQL = "INSERT INTO [ambient] ([ShopID], [Name], [Descr]) VALUES (" & _
    uTmpShop & ", " & _
    uTmpName & ", " & _
    uTmpDescr & ")"

    Data.Database.Execute lStrSQL
    Set lObjRS = Data.Database.Execute("SELECT TOP 1 ID FROM [ambient] ORDER BY ID DESC")
    .ID = lObjRS("ID")

    mCol.Add uambient, "N" & uambient.ID

    Set Add = uambient
    Set uambient = Nothing

    End With

End Function
Public Property Get Item(vntIndexKey As Variant) As Ambient
Set Item = mCol(vntIndexKey)
End Property
Public Property Get Count() As Long
Count = mCol.Count
End Property
Public Sub Remove(vntIndexKey As Variant)
Dim lObjRS As Recordset, lStrSQL As String, lambient As Ambient
Set lambient = mCol(vntIndexKey)
Data.Database.Execute "DELETE FROM [ambient] WHERE [ID]=" & lambient.ID
mCol.Remove vntIndexKey
End Sub
Public Property Get NewEnum() As IUnknown
Set NewEnum = mCol.[_NewEnum]
End Property
Private Sub Class_Initialize()
Set mCol = New Collection
Call LoadItems
End Sub
Private Sub Class_Terminate()
Set mCol = Nothing
End Sub
Private Sub LoadItems()
Dim lObjRS As Recordset, lClsambient As Ambient
Set lObjRS = Data.Database.Execute("SELECT * FROM [ambient]")

    Do While Not lObjRS.EOF
    Set lClsambient = New Ambient

        With lClsambient
        .OnParse = True
        .ID = ValidNum(lObjRS("ID"))
        If Not IsNull(lObjRS("ShopID")) Then Set .Shop = Data.Shops.SeekID(lObjRS("ShopID"))
        .Name = ValidStr(lObjRS("Name"))
        .Descr = ValidStr(lObjRS("Descr"))
        .OnParse = False
        End With

    mCol.Add lClsambient, ValidStr("N" & lObjRS("ID"))
    lObjRS.MoveNext
    Loop

End Sub
Public Function SeekID(uParm As Long) As Ambient
Dim uItem As Ambient

    For Each uItem In mCol

        If uItem.ID = uParm Then
        Set SeekID = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekShop(uParm As Shop) As Ambient
Dim uItem As Ambient

    For Each uItem In mCol

        If uItem.Shop = uParm Then
        Set SeekShop = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekName(uParm As String) As Ambient
Dim uItem As Ambient

    For Each uItem In mCol

        If uItem.Name = uParm Then
        Set SeekName = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekDescr(uParm As String) As Ambient
Dim uItem As Ambient

    For Each uItem In mCol

        If uItem.Descr = uParm Then
        Set SeekDescr = uItem
        Exit Function
        End If

    Next uItem

End Function


