VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Application"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
'================================================================================================
'Application Member Class
'================================================================================================

Option Explicit

'local variable(s) to hold property value(s)
Public OnParse As Boolean 'If set, no database updates will be made.
Private mvarID As Long 'Local Copy
Private mvarExecutable As String 'Local Copy
Private mvarName As String 'Local Copy
Private mvarDescr As String 'Local Copy
Private mvarBase_age As Long 'Local Copy

Public Property Let ID(ByVal pData As Long)
On Error GoTo ErrHPropLetID
Dim uEval As String

    If mvarID <> 0 Then
    Err.Raise &H5001, "Application Item Class", "Couldn't change [ID] field value after initial setting."
    Exit Property
    End If

mvarID = pData

Exit Property
ErrHPropLetID:
Err.Raise Err.number, Err.Source, "Property Let ID (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Executable(ByVal pData As String)
On Error GoTo ErrHPropLetExecutable
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = "", "null", "'" & pData & "'")
    Data.Database.Execute "UPDATE [Application] SET [Executable]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarExecutable = pData

Exit Property
ErrHPropLetExecutable:
Err.Raise Err.number, Err.Source, "Property Let Executable (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Name(ByVal pData As String)
On Error GoTo ErrHPropLetName
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = "", "null", "'" & pData & "'")
    Data.Database.Execute "UPDATE [Application] SET [Name]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarName = pData

Exit Property
ErrHPropLetName:
Err.Raise Err.number, Err.Source, "Property Let Name (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Descr(ByVal pData As String)
On Error GoTo ErrHPropLetDescr
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = "", "null", "'" & pData & "'")
    Data.Database.Execute "UPDATE [Application] SET [Descr]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarDescr = pData

Exit Property
ErrHPropLetDescr:
Err.Raise Err.number, Err.Source, "Property Let Descr (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Base_age(ByVal pData As Long)
On Error GoTo ErrHPropLetBase_age
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = 0, "null", pData)
    Data.Database.Execute "UPDATE [Application] SET [Base_age]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarBase_age = pData

Exit Property
ErrHPropLetBase_age:
Err.Raise Err.number, Err.Source, "Property Let Base_age (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Get ID() As Long
ID = mvarID
End Property
Public Property Get Executable() As String
Executable = mvarExecutable
End Property
Public Property Get Name() As String
Name = mvarName
End Property
Public Property Get Descr() As String
Descr = mvarDescr
End Property
Public Property Get Base_age() As Long
Base_age = mvarBase_age
End Property

