VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Applications"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"UserDefinedCollection"
Attribute VB_Ext_KEY = "Member0" ,"Application"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'================================================================================================
'Applications Collection
'================================================================================================

Option Explicit

'local variable to hold collection
Private mCol As Collection
Public Function Add(ByVal uApplication As Application) As Application
Dim lObjRS As Recordset, lStrSQL As String

    With uApplication
        If False Then
        Err.Raise &H5002, "Applications Collection", "Couldn't insert Item: Essential info missing."
        Exit Function
        End If

    Set lObjRS = Data.Database.Execute("SELECT * FROM [Application] WHERE [ID]=" & .ID)

        If Not lObjRS.EOF Then
        Err.Raise &H5003, "Applications Collection", "Couldn't insert Item: trying to replicate Unique Identifier field [ID]."
        Exit Function
        End If

Dim uTmpExecutable As String, _
uTmpName As String, _
uTmpDescr As String, _
uTmpBase_age As String

uTmpExecutable = IIf(.Executable = "", "null", "'" & .Executable & "'")
uTmpName = IIf(.Name = "", "null", "'" & .Name & "'")
uTmpDescr = IIf(.Descr = "", "null", "'" & .Descr & "'")
uTmpBase_age = IIf(.Base_age = 0, "null", .Base_age)

    lStrSQL = "INSERT INTO [Application] ([Executable], [Name], [Descr], [Base_age]) VALUES (" & _
    uTmpExecutable & ", " & _
    uTmpName & ", " & _
    uTmpDescr & ", " & _
    uTmpBase_age & ")"

    Data.Database.Execute lStrSQL
    Set lObjRS = Data.Database.Execute("SELECT TOP 1 ID FROM [Application] ORDER BY ID DESC")
    .ID = lObjRS("ID")

    mCol.Add uApplication, "N" & uApplication.ID

    Set Add = uApplication
    Set uApplication = Nothing

    End With

End Function
Public Property Get Item(vntIndexKey As Variant) As Application
Set Item = mCol(vntIndexKey)
End Property
Public Property Get Count() As Long
Count = mCol.Count
End Property
Public Sub Remove(vntIndexKey As Variant)
Dim lObjRS As Recordset, lStrSQL As String, lApplication As Application
Set lApplication = mCol(vntIndexKey)
Data.Database.Execute "DELETE FROM [Application] WHERE [ID]=" & lApplication.ID
mCol.Remove vntIndexKey
End Sub
Public Property Get NewEnum() As IUnknown
Set NewEnum = mCol.[_NewEnum]
End Property
Private Sub Class_Initialize()
Set mCol = New Collection
Call LoadItems
End Sub
Private Sub Class_Terminate()
Set mCol = Nothing
End Sub
Private Sub LoadItems()
Dim lObjRS As Recordset, lClsApplication As Application
Set lObjRS = Data.Database.Execute("SELECT * FROM [Application]")

    Do While Not lObjRS.EOF
    Set lClsApplication = New Application

        With lClsApplication
        .OnParse = True
        .ID = ValidNum(lObjRS("ID"))
        .Executable = ValidStr(lObjRS("Executable"))
        .Name = ValidStr(lObjRS("Name"))
        .Descr = ValidStr(lObjRS("Descr"))
        .Base_age = ValidNum(lObjRS("Base_age"))
        .OnParse = False
        End With

    mCol.Add lClsApplication, ValidStr("N" & lObjRS("ID"))
    lObjRS.MoveNext
    Loop

End Sub
Public Function SeekID(uParm As Long) As Application
Dim uItem As Application

    For Each uItem In mCol

        If uItem.ID = uParm Then
        Set SeekID = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekExecutable(uParm As String) As Application
Dim uItem As Application

    For Each uItem In mCol

        If uItem.Executable = uParm Then
        Set SeekExecutable = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekName(uParm As String) As Application
Dim uItem As Application

    For Each uItem In mCol

        If uItem.Name = uParm Then
        Set SeekName = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekDescr(uParm As String) As Application
Dim uItem As Application

    For Each uItem In mCol

        If uItem.Descr = uParm Then
        Set SeekDescr = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekBase_age(uParm As Long) As Application
Dim uItem As Application

    For Each uItem In mCol

        If uItem.Base_age = uParm Then
        Set SeekBase_age = uItem
        Exit Function
        End If

    Next uItem

End Function


