VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Discount"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"Application"
Attribute VB_Ext_KEY = "Member1" ,"Discount_scope"
Attribute VB_Ext_KEY = "Member2" ,"Franchise"
Attribute VB_Ext_KEY = "Member3" ,"Shop"
Attribute VB_Ext_KEY = "Member4" ,"User"
Attribute VB_Ext_KEY = "Member5" ,"User_clan"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'================================================================================================
'Discount Member Class
'================================================================================================

Option Explicit

'local variable(s) to hold property value(s)
Public OnParse As Boolean 'If set, no database updates will be made.
Private mvarID As Long 'Local Copy
Private mvarFranchise As Franchise 'Local Copy
Private mvarShop As Shop 'Local Copy
Private mvarName As String 'Local Copy
Private mvarDescr As String 'Local Copy
Private mvarDiscount_scope As Discount_scope 'Local Copy
Private mvarUser_clan As User_clan 'Local Copy
Private mvarUser As User 'Local Copy
Private mvarApplication As Application 'Local Copy
Private mvarDatehourinit As Date 'Local Copy
Private mvarDatehourend As Date 'Local Copy
Private mvarLimittoend As Boolean 'Local Copy
Private mvarTokenduration As Long 'Local Copy
Private mvarEnabled As Boolean 'Local Copy
Private mvarValueispercentage As Boolean 'Local Copy
Private mvarValue As Single 'Local Copy
Private mvarOnlyforprepaid As Boolean 'Local Copy

Public Property Let ID(ByVal pData As Long)
On Error GoTo ErrHPropLetID
Dim uEval As String

    If mvarID <> 0 Then
    Err.Raise &H5001, "Discount Item Class", "Couldn't change [ID] field value after initial setting."
    Exit Property
    End If

mvarID = pData

Exit Property
ErrHPropLetID:
Err.Raise Err.number, Err.Source, "Property Let ID (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Set Franchise(ByVal pData As Franchise)
On Error GoTo ErrHPropSetFranchise
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then

        If TypeName(pData) = "Nothing" Then uEval = "null" Else uEval = pData.ID

    Data.Database.Execute "UPDATE [Discount] SET [FranchiseID]=" & uEval & " WHERE [ID]=" & mvarID
    End If

Set mvarFranchise = pData

Exit Property
ErrHPropSetFranchise:
Err.Raise Err.number, Err.Source, "Property Set Franchise (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Set Shop(ByVal pData As Shop)
On Error GoTo ErrHPropSetShop
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then

        If TypeName(pData) = "Nothing" Then uEval = "null" Else uEval = pData.ID

    Data.Database.Execute "UPDATE [Discount] SET [ShopID]=" & uEval & " WHERE [ID]=" & mvarID
    End If

Set mvarShop = pData

Exit Property
ErrHPropSetShop:
Err.Raise Err.number, Err.Source, "Property Set Shop (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Name(ByVal pData As String)
On Error GoTo ErrHPropLetName
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = "", "null", "'" & pData & "'")
    Data.Database.Execute "UPDATE [Discount] SET [Name]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarName = pData

Exit Property
ErrHPropLetName:
Err.Raise Err.number, Err.Source, "Property Let Name (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Descr(ByVal pData As String)
On Error GoTo ErrHPropLetDescr
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = "", "null", "'" & pData & "'")
    Data.Database.Execute "UPDATE [Discount] SET [Descr]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarDescr = pData

Exit Property
ErrHPropLetDescr:
Err.Raise Err.number, Err.Source, "Property Let Descr (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Set Discount_scope(ByVal pData As Discount_scope)
On Error GoTo ErrHPropSetDiscount_scope
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then

        If TypeName(pData) = "Nothing" Then uEval = "null" Else uEval = pData.ID

    Data.Database.Execute "UPDATE [Discount] SET [Discount_scopeID]=" & uEval & " WHERE [ID]=" & mvarID
    End If

Set mvarDiscount_scope = pData

Exit Property
ErrHPropSetDiscount_scope:
Err.Raise Err.number, Err.Source, "Property Set Discount_scope (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Set User_clan(ByVal pData As User_clan)
On Error GoTo ErrHPropSetUser_clan
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then

        If TypeName(pData) = "Nothing" Then uEval = "null" Else uEval = pData.ID

    Data.Database.Execute "UPDATE [Discount] SET [User_clanID]=" & uEval & " WHERE [ID]=" & mvarID
    End If

Set mvarUser_clan = pData

Exit Property
ErrHPropSetUser_clan:
Err.Raise Err.number, Err.Source, "Property Set User_clan (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Set User(ByVal pData As User)
On Error GoTo ErrHPropSetUser
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then

        If TypeName(pData) = "Nothing" Then uEval = "null" Else uEval = pData.ID

    Data.Database.Execute "UPDATE [Discount] SET [UserID]=" & uEval & " WHERE [ID]=" & mvarID
    End If

Set mvarUser = pData

Exit Property
ErrHPropSetUser:
Err.Raise Err.number, Err.Source, "Property Set User (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Set Application(ByVal pData As Application)
On Error GoTo ErrHPropSetApplication
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then

        If TypeName(pData) = "Nothing" Then uEval = "null" Else uEval = pData.ID

    Data.Database.Execute "UPDATE [Discount] SET [ApplicationID]=" & uEval & " WHERE [ID]=" & mvarID
    End If

Set mvarApplication = pData

Exit Property
ErrHPropSetApplication:
Err.Raise Err.number, Err.Source, "Property Set Application (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Datehourinit(ByVal pData As Date)
On Error GoTo ErrHPropLetDatehourinit
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = "", "null", "#" & pData & "#")
    Data.Database.Execute "UPDATE [Discount] SET [Datehourinit]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarDatehourinit = pData

Exit Property
ErrHPropLetDatehourinit:
Err.Raise Err.number, Err.Source, "Property Let Datehourinit (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Datehourend(ByVal pData As Date)
On Error GoTo ErrHPropLetDatehourend
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = "", "null", "#" & pData & "#")
    Data.Database.Execute "UPDATE [Discount] SET [Datehourend]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarDatehourend = pData

Exit Property
ErrHPropLetDatehourend:
Err.Raise Err.number, Err.Source, "Property Let Datehourend (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Limittoend(ByVal pData As Boolean)
On Error GoTo ErrHPropLetLimittoend
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = 0, "null", pData)
    Data.Database.Execute "UPDATE [Discount] SET [Limittoend]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarLimittoend = pData

Exit Property
ErrHPropLetLimittoend:
Err.Raise Err.number, Err.Source, "Property Let Limittoend (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Tokenduration(ByVal pData As Long)
On Error GoTo ErrHPropLetTokenduration
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = 0, "null", pData)
    Data.Database.Execute "UPDATE [Discount] SET [Tokenduration]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarTokenduration = pData

Exit Property
ErrHPropLetTokenduration:
Err.Raise Err.number, Err.Source, "Property Let Tokenduration (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Enabled(ByVal pData As Boolean)
On Error GoTo ErrHPropLetEnabled
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = 0, "null", pData)
    Data.Database.Execute "UPDATE [Discount] SET [Enabled]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarEnabled = pData

Exit Property
ErrHPropLetEnabled:
Err.Raise Err.number, Err.Source, "Property Let Enabled (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Valueispercentage(ByVal pData As Boolean)
On Error GoTo ErrHPropLetValueispercentage
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = 0, "null", pData)
    Data.Database.Execute "UPDATE [Discount] SET [Valueispercentage]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarValueispercentage = pData

Exit Property
ErrHPropLetValueispercentage:
Err.Raise Err.number, Err.Source, "Property Let Valueispercentage (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Value(ByVal pData As Single)
On Error GoTo ErrHPropLetValue
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = 0, "null", pData)
    Data.Database.Execute "UPDATE [Discount] SET [Value]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarValue = pData

Exit Property
ErrHPropLetValue:
Err.Raise Err.number, Err.Source, "Property Let Value (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Let Onlyforprepaid(ByVal pData As Boolean)
On Error GoTo ErrHPropLetOnlyforprepaid
Dim uEval As String

    If (Not OnParse) And (mvarID <> 0) Then
    uEval = IIf(pData = 0, "null", pData)
    Data.Database.Execute "UPDATE [Discount] SET [Onlyforprepaid]=" & uEval & " WHERE [ID]=" & mvarID
    End If

mvarOnlyforprepaid = pData

Exit Property
ErrHPropLetOnlyforprepaid:
Err.Raise Err.number, Err.Source, "Property Let Onlyforprepaid (Code " & Err.number & "): " & vbCrLf & vbCrLf & Err.Description, Err.HelpFile, Err.HelpContext
End Property
Public Property Get ID() As Long
ID = mvarID
End Property
Public Property Get Franchise() As Franchise
Set Franchise = mvarFranchise
End Property
Public Property Get Shop() As Shop
Set Shop = mvarShop
End Property
Public Property Get Name() As String
Name = mvarName
End Property
Public Property Get Descr() As String
Descr = mvarDescr
End Property
Public Property Get Discount_scope() As Discount_scope
Set Discount_scope = mvarDiscount_scope
End Property
Public Property Get User_clan() As User_clan
Set User_clan = mvarUser_clan
End Property
Public Property Get User() As User
Set User = mvarUser
End Property
Public Property Get Application() As Application
Set Application = mvarApplication
End Property
Public Property Get Datehourinit() As Date
Datehourinit = mvarDatehourinit
End Property
Public Property Get Datehourend() As Date
Datehourend = mvarDatehourend
End Property
Public Property Get Limittoend() As Boolean
Limittoend = mvarLimittoend
End Property
Public Property Get Tokenduration() As Long
Tokenduration = mvarTokenduration
End Property
Public Property Get Enabled() As Boolean
Enabled = mvarEnabled
End Property
Public Property Get Valueispercentage() As Boolean
Valueispercentage = mvarValueispercentage
End Property
Public Property Get Value() As Single
Value = mvarValue
End Property
Public Property Get Onlyforprepaid() As Boolean
Onlyforprepaid = mvarOnlyforprepaid
End Property

