VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Discount_Scopes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'================================================================================================
'Discount_Scopes Collection
'================================================================================================

Option Explicit

'local variable to hold collection
Private mCol As Collection
Public Function Add(ByVal uDiscount_Scope As Discount_scope) As Discount_scope
Dim lObjRS As Recordset, lStrSQL As String

    With uDiscount_Scope
        If False Then
        Err.Raise &H5002, "Discount_Scopes Collection", "Couldn't insert Item: Essential info missing."
        Exit Function
        End If

    Set lObjRS = Data.Database.Execute("SELECT * FROM [Discount_Scope] WHERE [ID]=" & .ID)

        If Not lObjRS.EOF Then
        Err.Raise &H5003, "Discount_Scopes Collection", "Couldn't insert Item: trying to replicate Unique Identifier field [ID]."
        Exit Function
        End If

Dim uTmpDescr As String, _
uTmpPrefix As String

uTmpDescr = IIf(.Descr = "", "null", "'" & .Descr & "'")
uTmpPrefix = IIf(.Prefix = "", "null", "'" & .Prefix & "'")

    lStrSQL = "INSERT INTO [Discount_Scope] ([Descr], [Prefix]) VALUES (" & _
    uTmpDescr & ", " & _
    uTmpPrefix & ")"

    Data.Database.Execute lStrSQL
    Set lObjRS = Data.Database.Execute("SELECT TOP 1 ID FROM [Discount_Scope] ORDER BY ID DESC")
    .ID = lObjRS("ID")

    mCol.Add uDiscount_Scope, "N" & uDiscount_Scope.ID

    Set Add = uDiscount_Scope
    Set uDiscount_Scope = Nothing

    End With

End Function
Public Property Get Item(vntIndexKey As Variant) As Discount_scope
Set Item = mCol(vntIndexKey)
End Property
Public Property Get Count() As Long
Count = mCol.Count
End Property
Public Sub Remove(vntIndexKey As Variant)
Dim lObjRS As Recordset, lStrSQL As String, lDiscount_Scope As Discount_scope
Set lDiscount_Scope = mCol(vntIndexKey)
Data.Database.Execute "DELETE FROM [Discount_Scope] WHERE [ID]=" & lDiscount_Scope.ID
mCol.Remove vntIndexKey
End Sub
Public Property Get NewEnum() As IUnknown
Set NewEnum = mCol.[_NewEnum]
End Property
Private Sub Class_Initialize()
Set mCol = New Collection
Call LoadItems
End Sub
Private Sub Class_Terminate()
Set mCol = Nothing
End Sub
Private Sub LoadItems()
Dim lObjRS As Recordset, lClsDiscount_Scope As Discount_scope
Set lObjRS = Data.Database.Execute("SELECT * FROM [Discount_Scope]")

    Do While Not lObjRS.EOF
    Set lClsDiscount_Scope = New Discount_scope

        With lClsDiscount_Scope
        .OnParse = True
        .ID = ValidNum(lObjRS("ID"))
        .Descr = ValidStr(lObjRS("Descr"))
        .Prefix = ValidStr(lObjRS("Prefix"))
        .OnParse = False
        End With

    mCol.Add lClsDiscount_Scope, ValidStr("N" & lObjRS("ID"))
    lObjRS.MoveNext
    Loop

End Sub
Public Function SeekID(uParm As Long) As Discount_scope
Dim uItem As Discount_scope

    For Each uItem In mCol

        If uItem.ID = uParm Then
        Set SeekID = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekDescr(uParm As String) As Discount_scope
Dim uItem As Discount_scope

    For Each uItem In mCol

        If uItem.Descr = uParm Then
        Set SeekDescr = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekPrefix(uParm As String) As Discount_scope
Dim uItem As Discount_scope

    For Each uItem In mCol

        If uItem.Prefix = uParm Then
        Set SeekPrefix = uItem
        Exit Function
        End If

    Next uItem

End Function

