VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Discounts"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'================================================================================================
'Discounts Collection
'================================================================================================

Option Explicit

'local variable to hold collection
Private mCol As Collection
Public Function Add(ByVal uDiscount As Discount) As Discount
Dim lObjRS As Recordset, lStrSQL As String

    With uDiscount
        If False Then
        Err.Raise &H5002, "Discounts Collection", "Couldn't insert Item: Essential info missing."
        Exit Function
        End If

    Set lObjRS = Data.Database.Execute("SELECT * FROM [Discount] WHERE [ID]=" & .ID)

        If Not lObjRS.EOF Then
        Err.Raise &H5003, "Discounts Collection", "Couldn't insert Item: trying to replicate Unique Identifier field [ID]."
        Exit Function
        End If

Dim uTmpFranchise As String, _
uTmpShop As String, _
uTmpName As String, _
uTmpDescr As String, _
uTmpDiscount_scope As String, _
uTmpUser_clan As String, _
uTmpUser As String, _
uTmpApplication As String, _
uTmpDatehourinit As String, _
uTmpDatehourend As String, _
uTmpLimittoend As String, _
uTmpTokenduration As String, _
uTmpEnabled As String, _
uTmpValueispercentage As String, _
uTmpValue As String, _
uTmpOnlyforprepaid As String

    If TypeName(.Franchise) = "Nothing" Then uTmpFranchise = "null" Else uTmpFranchise = .Franchise.ID
    If TypeName(.Shop) = "Nothing" Then uTmpShop = "null" Else uTmpShop = .Shop.ID
uTmpName = IIf(.Name = "", "null", "'" & .Name & "'")
uTmpDescr = IIf(.Descr = "", "null", "'" & .Descr & "'")
    If TypeName(.Discount_scope) = "Nothing" Then uTmpDiscount_scope = "null" Else uTmpDiscount_scope = .Discount_scope.ID
    If TypeName(.User_clan) = "Nothing" Then uTmpUser_clan = "null" Else uTmpUser_clan = .User_clan.ID
    If TypeName(.User) = "Nothing" Then uTmpUser = "null" Else uTmpUser = .User.ID
    If TypeName(.Application) = "Nothing" Then uTmpApplication = "null" Else uTmpApplication = .Application.ID
uTmpDatehourinit = IIf(.Datehourinit = "", "null", "#" & .Datehourinit & "#")
uTmpDatehourend = IIf(.Datehourend = "", "null", "#" & .Datehourend & "#")
uTmpLimittoend = IIf(.Limittoend = 0, "0", .Limittoend)
uTmpTokenduration = IIf(.Tokenduration = 0, "null", .Tokenduration)
uTmpEnabled = IIf(.Enabled = 0, "0", .Enabled)
uTmpValueispercentage = IIf(.Valueispercentage = 0, "0", .Valueispercentage)
uTmpValue = IIf(.Value = 0, "null", .Value)
uTmpOnlyforprepaid = IIf(.Onlyforprepaid = 0, "0", .Onlyforprepaid)

    lStrSQL = "INSERT INTO [Discount] ([FranchiseID], [ShopID], [Name], [Descr], [Discount_scopeID], [User_clanID], [UserID], [ApplicationID], [Datehourinit], [Datehourend], [Limittoend], [Tokenduration], [Enabled], [Valueispercentage], [Value], [Onlyforprepaid]) VALUES (" & _
    uTmpFranchise & ", " & _
    uTmpShop & ", " & _
    uTmpName & ", " & _
    uTmpDescr & ", " & _
    uTmpDiscount_scope & ", " & _
    uTmpUser_clan & ", " & _
    uTmpUser & ", " & _
    uTmpApplication & ", " & _
    uTmpDatehourinit & ", " & _
    uTmpDatehourend & ", " & _
    uTmpLimittoend & ", " & _
    uTmpTokenduration & ", " & _
    uTmpEnabled & ", " & _
    uTmpValueispercentage & ", " & _
    uTmpValue & ", " & _
    uTmpOnlyforprepaid & ")"

    Data.Database.Execute lStrSQL
    Set lObjRS = Data.Database.Execute("SELECT TOP 1 ID FROM [Discount] ORDER BY ID DESC")
    .ID = lObjRS("ID")

    mCol.Add uDiscount, "N" & uDiscount.ID

    Set Add = uDiscount
    Set uDiscount = Nothing

    End With

End Function
Public Property Get Item(vntIndexKey As Variant) As Discount
Set Item = mCol(vntIndexKey)
End Property
Public Property Get Count() As Long
Count = mCol.Count
End Property
Public Sub Remove(vntIndexKey As Variant)
Dim lObjRS As Recordset, lStrSQL As String, lDiscount As Discount
Set lDiscount = mCol(vntIndexKey)
Data.Database.Execute "DELETE FROM [Discount] WHERE [ID]=" & lDiscount.ID
mCol.Remove vntIndexKey
End Sub
Public Property Get NewEnum() As IUnknown
Set NewEnum = mCol.[_NewEnum]
End Property
Private Sub Class_Initialize()
Set mCol = New Collection
Call LoadItems
End Sub
Private Sub Class_Terminate()
Set mCol = Nothing
End Sub
Private Sub LoadItems()
Dim lObjRS As Recordset, lClsDiscount As Discount
Set lObjRS = Data.Database.Execute("SELECT * FROM [Discount]")

    Do While Not lObjRS.EOF
    Set lClsDiscount = New Discount

        With lClsDiscount
        .OnParse = True
        .ID = ValidNum(lObjRS("ID"))
        If Not IsNull(lObjRS("FranchiseID")) Then Set .Franchise = Data.Franchises.SeekID(lObjRS("FranchiseID"))
        If Not IsNull(lObjRS("ShopID")) Then Set .Shop = Data.Shops.SeekID(lObjRS("ShopID"))
        .Name = ValidStr(lObjRS("Name"))
        .Descr = ValidStr(lObjRS("Descr"))
        If Not IsNull(lObjRS("Discount_scopeID")) Then Set .Discount_scope = Data.Discount_Scopes.SeekID(lObjRS("Discount_scopeID"))
        If Not IsNull(lObjRS("User_clanID")) Then Set .User_clan = Data.User_Clans.SeekID(lObjRS("User_clanID"))
        If Not IsNull(lObjRS("UserID")) Then Set .User = Data.Users.SeekID(lObjRS("UserID"))
        If Not IsNull(lObjRS("ApplicationID")) Then Set .Application = Data.Applications.SeekID(lObjRS("ApplicationID"))
        .Datehourinit = (lObjRS("Datehourinit"))
        .Datehourend = (lObjRS("Datehourend"))
        .Limittoend = (lObjRS("Limittoend"))
        .Tokenduration = ValidNum(lObjRS("Tokenduration"))
        .Enabled = (lObjRS("Enabled"))
        .Valueispercentage = (lObjRS("Valueispercentage"))
        .Value = ValidNum(lObjRS("Value"))
        .Onlyforprepaid = (lObjRS("Onlyforprepaid"))
        .OnParse = False
        End With

    mCol.Add lClsDiscount, ValidStr("N" & lObjRS("ID"))
    lObjRS.MoveNext
    Loop

End Sub
Public Function SeekID(uParm As Long) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.ID = uParm Then
        Set SeekID = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekFranchise(uParm As Franchise) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.Franchise = uParm Then
        Set SeekFranchise = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekShop(uParm As Shop) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.Shop = uParm Then
        Set SeekShop = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekName(uParm As String) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.Name = uParm Then
        Set SeekName = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekDescr(uParm As String) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.Descr = uParm Then
        Set SeekDescr = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekDiscount_scope(uParm As Discount_scope) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.Discount_scope = uParm Then
        Set SeekDiscount_scope = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekUser_clan(uParm As User_clan) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.User_clan = uParm Then
        Set SeekUser_clan = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekUser(uParm As User) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.User = uParm Then
        Set SeekUser = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekApplication(uParm As Application) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.Application = uParm Then
        Set SeekApplication = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekDatehourinit(uParm As Date) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.Datehourinit = uParm Then
        Set SeekDatehourinit = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekDatehourend(uParm As Date) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.Datehourend = uParm Then
        Set SeekDatehourend = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekLimittoend(uParm As Boolean) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.Limittoend = uParm Then
        Set SeekLimittoend = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekTokenduration(uParm As Long) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.Tokenduration = uParm Then
        Set SeekTokenduration = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekEnabled(uParm As Boolean) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.Enabled = uParm Then
        Set SeekEnabled = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekValueispercentage(uParm As Boolean) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.Valueispercentage = uParm Then
        Set SeekValueispercentage = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekValue(uParm As Single) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.Value = uParm Then
        Set SeekValue = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekOnlyforprepaid(uParm As Boolean) As Discount
Dim uItem As Discount

    For Each uItem In mCol

        If uItem.Onlyforprepaid = uParm Then
        Set SeekOnlyforprepaid = uItem
        Exit Function
        End If

    Next uItem

End Function


