VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Franchises"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"UserDefinedCollection"
Attribute VB_Ext_KEY = "Member0" ,"Franchise"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'================================================================================================
'Franchises Collection
'================================================================================================

Option Explicit

'local variable to hold collection
Private mCol As Collection
Public Function Add(ByVal uFranchise As Franchise) As Franchise
Dim lObjRS As Recordset, lStrSQL As String

    With uFranchise
        If False Then
        Err.Raise &H5002, "Franchises Collection", "Couldn't insert Item: Essential info missing."
        Exit Function
        End If

    Set lObjRS = Data.Database.Execute("SELECT * FROM [Franchise] WHERE [ID]=" & .ID)

        If Not lObjRS.EOF Then
        Err.Raise &H5003, "Franchises Collection", "Couldn't insert Item: trying to replicate Unique Identifier field [ID]."
        Exit Function
        End If

Dim uTmpName As String, _
uTmpDescr As String, _
uTmpTokenvalue As String, _
uTmpTokenduration As String

uTmpName = IIf(.Name = "", "null", "'" & .Name & "'")
uTmpDescr = IIf(.Descr = "", "null", "'" & .Descr & "'")
uTmpTokenvalue = IIf(.Tokenvalue = 0, "null", .Tokenvalue)
uTmpTokenduration = IIf(.Tokenduration = 0, "null", .Tokenduration)

    lStrSQL = "INSERT INTO [Franchise] ([Name], [Descr], [Tokenvalue], [Tokenduration]) VALUES (" & _
    uTmpName & ", " & _
    uTmpDescr & ", " & _
    uTmpTokenvalue & ", " & _
    uTmpTokenduration & ")"

    Data.Database.Execute lStrSQL
    Set lObjRS = Data.Database.Execute("SELECT TOP 1 ID FROM [Franchise] ORDER BY ID DESC")
    .ID = lObjRS("ID")

    mCol.Add uFranchise, "N" & uFranchise.ID

    Set Add = uFranchise
    Set uFranchise = Nothing

    End With

End Function
Public Property Get Item(vntIndexKey As Variant) As Franchise
Set Item = mCol(vntIndexKey)
End Property
Public Property Get Count() As Long
Count = mCol.Count
End Property
Public Sub Remove(vntIndexKey As Variant)
Dim lObjRS As Recordset, lStrSQL As String, lFranchise As Franchise
Set lFranchise = mCol(vntIndexKey)
Data.Database.Execute "DELETE FROM [Franchise] WHERE [ID]=" & lFranchise.ID
mCol.Remove vntIndexKey
End Sub
Public Property Get NewEnum() As IUnknown
Set NewEnum = mCol.[_NewEnum]
End Property
Private Sub Class_Initialize()
Set mCol = New Collection
Call LoadItems
End Sub
Private Sub Class_Terminate()
Set mCol = Nothing
End Sub
Private Sub LoadItems()
Dim lObjRS As Recordset, lClsFranchise As Franchise
Set lObjRS = Data.Database.Execute("SELECT * FROM [Franchise]")

    Do While Not lObjRS.EOF
    Set lClsFranchise = New Franchise

        With lClsFranchise
        .OnParse = True
        .ID = ValidNum(lObjRS("ID"))
        .Name = ValidStr(lObjRS("Name"))
        .Descr = ValidStr(lObjRS("Descr"))
        .Tokenvalue = ValidNum(lObjRS("Tokenvalue"))
        .Tokenduration = ValidNum(lObjRS("Tokenduration"))
        .OnParse = False
        End With

    mCol.Add lClsFranchise, ValidStr("N" & lObjRS("ID"))
    lObjRS.MoveNext
    Loop

End Sub
Public Function SeekID(uParm As Long) As Franchise
Dim uItem As Franchise

    For Each uItem In mCol

        If uItem.ID = uParm Then
        Set SeekID = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekName(uParm As String) As Franchise
Dim uItem As Franchise

    For Each uItem In mCol

        If uItem.Name = uParm Then
        Set SeekName = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekDescr(uParm As String) As Franchise
Dim uItem As Franchise

    For Each uItem In mCol

        If uItem.Descr = uParm Then
        Set SeekDescr = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekTokenvalue(uParm As Currency) As Franchise
Dim uItem As Franchise

    For Each uItem In mCol

        If uItem.Tokenvalue = uParm Then
        Set SeekTokenvalue = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekTokenduration(uParm As Long) As Franchise
Dim uItem As Franchise

    For Each uItem In mCol

        If uItem.Tokenduration = uParm Then
        Set SeekTokenduration = uItem
        Exit Function
        End If

    Next uItem

End Function

