VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Machine_Statuses"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable to hold collection
Private mCol As Collection
Public Function Add(ByVal uMachine_Status As Machine_Status) As Machine_Status
Dim lObjRS As Recordset, lStrSQL As String

    With uMachine_Status
        If False Then
        Err.Raise &H5002, "Machine_Statuses Collection", "Couldn't insert Item: Essential info missing."
        Exit Function
        End If

    Set lObjRS = Data.Database.Execute("SELECT * FROM [Machine_Status] WHERE [ID] = " & .ID)

        If Not lObjRS.EOF Then
        Err.Raise &H5003, "Machine_Statuses Collection", "Couldn't insert Item: trying to replicate Unique Identifier field [ID]."
        Exit Function
        End If

    Dim uTmpMachine As String
        If TypeName(.Machine) = "Nothing" Then
        uTmpMachine = "null"
        Else
        uTmpMachine = .Machine.ID
        End If

    Dim uTmpUser As String
        If TypeName(.User) = "Nothing" Then
        uTmpUser = "null"
        Else
        uTmpUser = .User.ID
        End If

    lStrSQL = "INSERT INTO [machine_status] ([machineID], [machine_status_defID], [lastchange], [userID], [user_initTime], [user_endTime], [NextTokenCheck]) VALUES (" & _
    uTmpMachine & ", " & _
    .machine_status_def & ", " & _
    SQLDate(.lastchange) & ", " & _
    uTmpUser & ", " & _
    SQLDate(.user_initTime) & ", " & _
    SQLDate(.user_endTime) & ", " & _
    SQLDate(.NextTokenCheck) & ")"

    Data.Database.Execute lStrSQL
    Set lObjRS = Data.Database.Execute("SELECT TOP 1 ID FROM [Machine_Status] ORDER BY ID Desc")
    .ID = lObjRS("ID")

    mCol.Add uMachine_Status, "N" & uMachine_Status.ID

    Set Add = uMachine_Status
    Set uMachine_Status = Nothing

    End With

End Function
Public Property Get Item(vntIndexKey As Variant) As Machine_Status
Set Item = mCol(vntIndexKey)
End Property
Public Property Get Count() As Long
Count = mCol.Count
End Property
Public Sub Remove(vntIndexKey As Variant)
Dim lObjRS As Recordset, lStrSQL As String, lMachine_Status As Machine_Status
Set lMachine_Status = mCol("N" & vntIndexKey)
Data.Database.Execute "DELETE FROM [Machine_Status] WHERE [ID] = " & lMachine_Status.ID & ""
mCol.Remove "N" & vntIndexKey
End Sub
Public Property Get NewEnum() As IUnknown
Set NewEnum = mCol.[_NewEnum]
End Property
Private Sub Class_Initialize()
Set mCol = New Collection
Call LoadItems
End Sub
Private Sub Class_Terminate()
Set mCol = Nothing
End Sub
Private Sub LoadItems()
Dim lObjRS As Recordset, lClsMachine_Status As Machine_Status
Set lObjRS = Data.Database.Execute("SELECT * FROM [Machine_Status]")

    Do While Not lObjRS.EOF
    Set lClsMachine_Status = New Machine_Status

        With lClsMachine_Status
        .OnParse = True
        .ID = ValidNum(lObjRS("ID"))
        If Not IsNull(lObjRS("MachineID")) Then Set .Machine = Data.Machines.SeekID(lObjRS("MachineID"))
        .machine_status_def = lObjRS("machine_status_defID")
        .lastchange = ValidDate(lObjRS("lastchange"))
        If Not IsNull(lObjRS("UserID")) Then Set .User = Data.Users.SeekID(lObjRS("UserID"))
        .user_initTime = ValidDate(lObjRS("user_initTime"))
        .user_endTime = ValidDate(lObjRS("user_endTime"))
        .NextTokenCheck = ValidDate(lObjRS("NextTokenCheck"))
        .OnParse = False
        End With

    mCol.Add lClsMachine_Status, ValidStr("N" & lObjRS("ID"))
    lObjRS.MoveNext
    Loop

End Sub
Public Function SeekID(uParm As Long) As Machine_Status
Dim uItem As Machine_Status

    For Each uItem In mCol

        If uItem.ID = uParm Then
        Set SeekID = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekMachine(uParm As Machine) As Machine_Status
Dim uItem As Machine_Status

    For Each uItem In mCol

        If uItem.Machine.ID = uParm.ID Then
        Set SeekMachine = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekUser(uParm As User) As Machine_Status
Dim uItem As Machine_Status

    For Each uItem In mCol

        If TypeName(uItem.User) <> "Nothing" Then
            
            If uItem.User.ID = uParm.ID Then
            Set SeekUser = uItem
            Exit Function
            End If
        
        End If

    Next uItem

End Function
Sub CheckStatus()
Dim uItem As Machine_Status, uUser As User, uMustSendAlarm As Boolean

    For Each uItem In mCol
    
        If Year(uItem.user_endTime) <> 1899 Then
        
            If CDate(uItem.user_endTime) <= Now() Then
            uMustSendAlarm = True
            
            Else
            uMustSendAlarm = False
            
            End If
        
        Else
        uMustSendAlarm = False
        
        End If
        
    
        If uItem.TimeOverAlarmSent <> uMustSendAlarm Then
        uItem.TimeOverAlarmSent = uMustSendAlarm
        
            If uMustSendAlarm = True Then
            
                If Data.Settings.TimerOverWarning Then
                Send uItem.Machine.Ipaddress, "SAY|Ateno: Seu tempo Acabou. Se desejar renovar, procure um dos nssos atendentes."
                End If

            End If
            
        End If
        
        
        If uItem.TimeOverAlarmSent Then
        
            If Data.Settings.TimeOverAutoKickUse Then
            
                If DateAdd("n", Data.Settings.TimeOverAutoKickPeriod / 60000, CDate(uItem.user_endTime)) <= Now() Then 'AutoKick.
                KickUser uItem.Machine.Macaddress
                End If
            
            End If

        End If
        
        
        If Data.MachineListLoaded Then
        
            If TypeName(uItem.User) <> "Nothing" Then
            frmMachines.UpdateItem uItem.Machine.Macaddress
            End If
            
        End If

    Next uItem

End Sub
