VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "User_Classes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"UserDefinedCollection"
Attribute VB_Ext_KEY = "Member0" ,"User_class"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'================================================================================================
'User_Classes Collection
'================================================================================================

Option Explicit

'local variable to hold collection
Private mCol As Collection
Public Function Add(ByVal uUser_Class As User_class) As User_class
Dim lObjRS As Recordset, lStrSQL As String

    With uUser_Class
        If False Then
        Err.Raise &H5002, "User_Classes Collection", "Couldn't insert Item: Essential info missing."
        Exit Function
        End If

    Set lObjRS = Data.Database.Execute("SELECT * FROM [User_Class] WHERE [ID]=" & .ID)

        If Not lObjRS.EOF Then
        Err.Raise &H5003, "User_Classes Collection", "Couldn't insert Item: trying to replicate Unique Identifier field [ID]."
        Exit Function
        End If

Dim uTmpName As String, _
uTmpDescr As String

uTmpName = IIf(.Name = "", "null", "'" & .Name & "'")
uTmpDescr = IIf(.Descr = "", "null", "'" & .Descr & "'")

    lStrSQL = "INSERT INTO [User_Class] ([Name], [Descr]) VALUES (" & _
    uTmpName & ", " & _
    uTmpDescr & ")"

    Data.Database.Execute lStrSQL
    Set lObjRS = Data.Database.Execute("SELECT TOP 1 ID FROM [User_Class] ORDER BY ID DESC")
    .ID = lObjRS("ID")

    mCol.Add uUser_Class, "N" & uUser_Class.ID

    Set Add = uUser_Class
    Set uUser_Class = Nothing

    End With

End Function
Public Property Get Item(vntIndexKey As Variant) As User_class
Set Item = mCol(vntIndexKey)
End Property
Public Property Get Count() As Long
Count = mCol.Count
End Property
Public Sub Remove(vntIndexKey As Variant)
Dim lObjRS As Recordset, lStrSQL As String, lUser_Class As User_class
Set lUser_Class = mCol(vntIndexKey)
Data.Database.Execute "DELETE FROM [User_Class] WHERE [ID]=" & lUser_Class.ID
mCol.Remove vntIndexKey
End Sub
Public Property Get NewEnum() As IUnknown
Set NewEnum = mCol.[_NewEnum]
End Property
Private Sub Class_Initialize()
Set mCol = New Collection
Call LoadItems
End Sub
Private Sub Class_Terminate()
Set mCol = Nothing
End Sub
Private Sub LoadItems()
Dim lObjRS As Recordset, lClsUser_Class As User_class
Set lObjRS = Data.Database.Execute("SELECT * FROM [User_Class]")

    Do While Not lObjRS.EOF
    Set lClsUser_Class = New User_class

        With lClsUser_Class
        .OnParse = True
        .ID = ValidNum(lObjRS("ID"))
        .Name = ValidStr(lObjRS("Name"))
        .Descr = ValidStr(lObjRS("Descr"))
        .OnParse = False
        End With

    mCol.Add lClsUser_Class, ValidStr("N" & lObjRS("ID"))
    lObjRS.MoveNext
    Loop

End Sub
Public Function SeekID(uParm As Long) As User_class
Dim uItem As User_class

    For Each uItem In mCol

        If uItem.ID = uParm Then
        Set SeekID = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekName(uParm As String) As User_class
Dim uItem As User_class

    For Each uItem In mCol

        If uItem.Name = uParm Then
        Set SeekName = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekDescr(uParm As String) As User_class
Dim uItem As User_class

    For Each uItem In mCol

        If uItem.Descr = uParm Then
        Set SeekDescr = uItem
        Exit Function
        End If

    Next uItem

End Function


