VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Users"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"User"
Attribute VB_Ext_KEY = "Member0" ,"User"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'================================================================================================
'Users Collection
'================================================================================================

Option Explicit

'local variable to hold collection
Private mCol As Collection
Public Function Add(ByVal uUser As User) As User
Dim lObjRS As Recordset, lStrSQL As String

    With uUser
        If .Alias = "" Then
        Err.Raise &H5002, "Users Collection", "No foi possvel inserir o Registro: Falta o Apelido do Usurio."
        Exit Function
        End If

    Set lObjRS = Data.Database.Execute("SELECT * FROM [User] WHERE [ID]=" & .ID)

        If Not lObjRS.EOF Then
        Err.Raise &H5003, "Users Collection", "Couldn't insert Item: trying to replicate Unique Identifier field [ID]."
        Exit Function
        End If

Dim uTmpAlias As String, _
uTmpName As String, _
uTmpAdress As String, _
uTmpPhone As String, _
uTmpHomecontact As String, _
uTmpHomecontactid As String, _
uTmpEmail As String, _
uTmpIcq As String, _
uTmpUser_class As String, _
uTmpUser_clan As String, _
uTmpPwd As String, _
uTmpBirth As Date, _
uTmpCredit As String, _
uTmpBanned As String, _
uTmpRestrictedcredit As String

uTmpAlias = IIf(.Alias = "", "null", "'" & .Alias & "'")
uTmpName = IIf(.Name = "", "null", "'" & .Name & "'")
uTmpAdress = IIf(.Adress = "", "null", "'" & .Adress & "'")
uTmpPhone = IIf(.Phone = "", "null", "'" & .Phone & "'")
uTmpHomecontact = IIf(.Homecontact = "", "null", "'" & .Homecontact & "'")
uTmpHomecontactid = IIf(.Homecontactid = "", "null", "'" & .Homecontactid & "'")
uTmpEmail = IIf(.Email = "", "null", "'" & .Email & "'")
uTmpIcq = IIf(.Icq = 0, "null", .Icq)
    If TypeName(.User_class) = "Nothing" Then uTmpUser_class = "null" Else uTmpUser_class = .User_class.ID
    If TypeName(.User_clan) = "Nothing" Then uTmpUser_clan = "null" Else uTmpUser_clan = .User_clan.ID
uTmpPwd = IIf(.Pwd = "", "null", "'" & .Pwd & "'")
uTmpBirth = IIf(Year(.Birth = 1899), "null", "#" & .Birth & "#")
uTmpCredit = IIf(.Credit = 0, "null", .Credit)
uTmpBanned = IIf(.Banned = 0, "0", .Banned)
uTmpRestrictedcredit = IIf(.Restrictedcredit = 0, "0", .Restrictedcredit)

    lStrSQL = "INSERT INTO [User] ([Alias], [Name], [Adress], [Phone], [Homecontact], [Homecontactid], [Email], [Icq], [User_classID], [User_clanID], [Pwd], [Birth], [Credit], [Banned], [Restrictedcredit]) VALUES (" & _
    uTmpAlias & ", " & _
    uTmpName & ", " & _
    uTmpAdress & ", " & _
    uTmpPhone & ", " & _
    uTmpHomecontact & ", " & _
    uTmpHomecontactid & ", " & _
    uTmpEmail & ", " & _
    uTmpIcq & ", " & _
    uTmpUser_class & ", " & _
    uTmpUser_clan & ", " & _
    uTmpPwd & ", " & _
    uTmpBirth & ", " & _
    uTmpCredit & ", " & _
    uTmpBanned & ", " & _
    uTmpRestrictedcredit & ")"

    Data.Database.Execute lStrSQL
    Set lObjRS = Data.Database.Execute("SELECT TOP 1 ID FROM [User] ORDER BY ID DESC")
    .ID = lObjRS("ID")

    mCol.Add uUser, "N" & uUser.ID

    Set Add = uUser
    Set uUser = Nothing

    End With

End Function
Public Property Get Item(vntIndexKey As Variant) As User
On Error Resume Next
Set Item = mCol(vntIndexKey)
End Property
Public Property Get Count() As Long
Count = mCol.Count
End Property
Public Sub Remove(vntIndexKey As Variant)
Dim lObjRS As Recordset, lStrSQL As String, lUser As User
Set lUser = mCol("N" & vntIndexKey)
Data.Database.Execute "DELETE FROM [User] WHERE [ID]=" & lUser.ID
mCol.Remove "N" & vntIndexKey
End Sub
Public Property Get NewEnum() As IUnknown
Set NewEnum = mCol.[_NewEnum]
End Property
Private Sub Class_Initialize()
Set mCol = New Collection
Call LoadItems
End Sub
Private Sub Class_Terminate()
Set mCol = Nothing
End Sub
Private Sub LoadItems()
Dim lObjRS As Recordset, lClsUser As User
Set lObjRS = Data.Database.Execute("SELECT * FROM [User]")

    Do While Not lObjRS.EOF
    Set lClsUser = New User

        With lClsUser
        .OnParse = True
        .ID = ValidNum(lObjRS("ID"))
        .Alias = ValidStr(lObjRS("Alias"))
        .Name = ValidStr(lObjRS("Name"))
        .Adress = ValidStr(lObjRS("Adress"))
        .Phone = ValidStr(lObjRS("Phone"))
        .Homecontact = ValidStr(lObjRS("Homecontact"))
        .Homecontactid = ValidStr(lObjRS("Homecontactid"))
        .Email = ValidStr(lObjRS("Email"))
        .Icq = ValidNum(lObjRS("Icq"))
        If Not IsNull(lObjRS("User_classID")) Then Set .User_class = Data.User_Classes.SeekID(lObjRS("User_classID"))
        If Not IsNull(lObjRS("User_clanID")) Then Set .User_clan = Data.User_Clans.SeekID(lObjRS("User_clanID"))
        .Pwd = ValidStr(lObjRS("Pwd"))
        .Birth = ValidDate(lObjRS("Birth"))
        .Credit = ValidNum(lObjRS("Credit"))
        .Banned = (lObjRS("Banned"))
        .Restrictedcredit = (lObjRS("Restrictedcredit"))
        .OnParse = False
        End With

    mCol.Add lClsUser, ValidStr("N" & lObjRS("ID"))
    lObjRS.MoveNext
    Loop

End Sub
Public Function SeekID(uParm As Long) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.ID = uParm Then
        Set SeekID = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekAlias(uParm As String) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.Alias = uParm Then
        Set SeekAlias = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekName(uParm As String) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.Name = uParm Then
        Set SeekName = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekAdress(uParm As String) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.Adress = uParm Then
        Set SeekAdress = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekPhone(uParm As String) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.Phone = uParm Then
        Set SeekPhone = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekHomecontact(uParm As String) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.Homecontact = uParm Then
        Set SeekHomecontact = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekHomecontactid(uParm As String) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.Homecontactid = uParm Then
        Set SeekHomecontactid = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekEmail(uParm As String) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.Email = uParm Then
        Set SeekEmail = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekIcq(uParm As Long) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.Icq = uParm Then
        Set SeekIcq = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekUser_class(uParm As User_class) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.User_class = uParm Then
        Set SeekUser_class = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekUser_clan(uParm As User_clan) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.User_clan = uParm Then
        Set SeekUser_clan = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekPwd(uParm As String) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.Pwd = uParm Then
        Set SeekPwd = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekBirth(uParm As Date) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.Birth = uParm Then
        Set SeekBirth = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekCredit(uParm As Currency) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.Credit = uParm Then
        Set SeekCredit = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekBanned(uParm As Boolean) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.Banned = uParm Then
        Set SeekBanned = uItem
        Exit Function
        End If

    Next uItem

End Function
Public Function SeekRestrictedcredit(uParm As Boolean) As User
Dim uItem As User

    For Each uItem In mCol

        If uItem.Restrictedcredit = uParm Then
        Set SeekRestrictedcredit = uItem
        Exit Function
        End If

    Next uItem

End Function


