Attribute VB_Name = "modMain"
Option Explicit

    Public Type uTrans
    Current As Currency
    Name As String
    Place As String
    Version As String
    Size As Currency
    Self As Boolean
    Itself As File
    Buffer As String
    End Type

    Public Type uAppLocalTypeDataBag
    MACAddress As String
    InstanceIdentifier As String
    CommBuffer As String
    ServerIP As String
    ServerName As String
    Status As Long
    TempStatus As Long
    AnimFrame As Long
    GamePath As String
    AppPath As String
    Transfer As uTrans
    Voice As Variant
    UserOnDrag As Long
    Log As Boolean
    Schedules As New Schedules
    End Type
Public Function Send(ByVal psIP As String, ByVal psInfo As String) As Boolean
Dim lStrData As String

    With frmMain.wskPort
    lStrData = Data.MACAddress & "|" & .LocalIP & "|" & .LocalHostName & "|" & psInfo
    frmMain.lblData(3) = "local time [" & Time & "]" & vbCrLf & "target [" & psIP & "]" & vbCrLf & "cmd [" & psInfo & "]"
    .RemotePort = 82 'Ajustando a porta remota para a Listening port do servidor Cortex
    .RemoteHost = psIP 'Identifica especificamente um IP.
    .SendData lStrData & vbCrLf
    Debug.Print "SEND: " & frmMain.wskPort.RemoteHost & ", " & lStrData
    If Data.Log Then SysLog "SEND: " & frmMain.wskPort.RemoteHost & ", " & lStrData
    End With

End Function
Function SendBroadcast(ByVal psInfo As String) As Boolean
On Error GoTo fSendBroadcastErr 'EHCG.UID.fSendBroadcast

SendBroadcast = Send("255.255.255.255", psInfo) 'Setando o IP para broadcast local.

Exit Function
fSendBroadcastErr:
Err.Raise Err.number, Err.Source, "f.SendBroadcast (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Function
Sub ProccessBuffer()
On Error GoTo sProccessBufferErr 'EHCG.UID.sProccessBuffer
Dim lsParseableCommand As String, InProcError As Boolean

Dim lsServerMAC As String, lsServerIP As String, lsServerName As String, lsServerCommand As String

    Do
    If InStr(Data.CommBuffer, vbCrLf) = 0 Then Exit Do

    Data.CommBuffer = StripLine(Data.CommBuffer, vbCrLf, lsParseableCommand)

    lsServerMAC = ParseDataBlock(lsParseableCommand, 0, "|")
    lsServerIP = ParseDataBlock(lsParseableCommand, 1, "|")
    lsServerName = ParseDataBlock(lsParseableCommand, 2, "|")
    lsServerCommand = Right$(lsParseableCommand, Len(lsParseableCommand) - (Len(lsServerIP & lsServerName & lsServerMAC) + 3))

    InProcError = True
    Call ParseServerInput(lsServerMAC, lsServerIP, lsServerName, lsServerCommand)
    InProcError = False
    
    Loop

Exit Sub
sProccessBufferErr:

    If InProcError Then
    Beep
    Send Data.ServerIP, "ERROR|" & Err.Description
    ErrH "Sub ProccessBuffer", "Neuron Main Event Handler", , False
    Resume Next
    End If

Err.Raise Err.number, Err.Source, "s.ProccessBuffer (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Function ParseServerInput(ByVal lsServerMAC As String, ByVal lsServerIP As String, ByVal lsServerName As String, ByVal lsServerCommand As String) As Boolean
On Error GoTo fParseServerInputErr 'EHCG.UID.fParseServerInput

Dim lsAction As String, uSchedPeriod As Long
Dim lsParmLine As String, lsParm As String, lsParm2 As String, lsParm3 As String, lsParm4 As String, lsParm5 As String, lsParm6 As String
Dim lObjFSO As New FileSystemObject, lObjReg As New RegistryAccess, uDebug As String

    If lsServerIP <> "" Then
    Data.ServerIP = lsServerIP
    End If

lsAction = ParseDataBlock(lsServerCommand, 0, "|")

    If lsAction = "SCHEDULE" Then 'Tratar a String.
    uSchedPeriod = CLng(ParseDataBlock(lsServerCommand, 1, "|"))
    lsServerCommand = Right$(lsServerCommand, Len(lsServerCommand) - (Len(lsAction) + Len(uSchedPeriod) + 2))
    AddSchedule uSchedPeriod, lsServerCommand
    lsAction = ParseDataBlock(lsServerCommand, 0, "|")
    End If
    
    If lsAction = "DESCHEDULE" Then 'Tratar a String.
    lsServerCommand = Right$(lsServerCommand, Len(lsServerCommand) - (Len(lsAction) + 1))
    RemoveSchedule lsServerCommand
    Exit Function
    End If
    
    If Len(lsAction) < Len(lsServerCommand) Then
    lsParmLine = Right$(lsServerCommand, Len(lsServerCommand) - (Len(lsAction) + 1))
    lsParm = ParseDataBlock(lsServerCommand, 1, "|")
    lsParm2 = ParseDataBlock(lsServerCommand, 2, "|")
    lsParm3 = ParseDataBlock(lsServerCommand, 3, "|")
    lsParm4 = ParseDataBlock(lsServerCommand, 4, "|")
    lsParm5 = ParseDataBlock(lsServerCommand, 5, "|")
    lsParm6 = ParseDataBlock(lsServerCommand, 6, "|")
    End If
    
frmMain.mftMain.Caption = "Server: " & lsAction

uDebug = IIf(lsServerMAC = "LocalSchedule", "SCHD: ", "RECV: ") & lsServerName & ":" & lsAction & _
IIf(lsParm <> "", "[" & lsParm & "]", "") & " " & _
IIf(lsParm2 <> "", "[" & lsParm2 & "]", "") & " " & _
IIf(lsParm3 <> "", "[" & lsParm3 & "]", "") & " " & _
IIf(lsParm4 <> "", "[" & lsParm4 & "]", "") & " " & _
IIf(lsParm5 <> "", "[" & lsParm5 & "]", "") & " " & _
IIf(lsParm6 <> "", "[" & lsParm6 & "]", "")

Debug.Print uDebug
    
    If Data.Log Then SysLog uDebug

    Select Case lsAction
    
    '=========================================================================
    'Client-specific Operations
    '-------------------------------------------------------------------------
    Case "SERVERINFO"
    Data.ServerIP = lsServerIP: Data.ServerName = lsParmLine: Call StartConnAnim: frmMain.lblData(0).Caption = Data.ServerName
    
    Case "CLIENTVERSION"
    Send Data.ServerIP, "CLIENTVERSION|" & App.Major & "." & App.Minor & "." & App.Revision
    
    Case "USERINFO"
    frmMain.lblData(1).Caption = lsParmLine

    Case "KILLUSER"
    frmMain.lblData(1).Caption = "Waiting..."

    Case "RESTART"
    Call AppRestart

    Case "SHUTDOWN"
    End

    Case "QUERYID"
    Send Data.ServerIP, "QUERYID|" & InputBox("Informe o ID desta mquina (numerao)")

    Case "LOCK"
    Call LockClient

    Case "UNLOCK"
    Call UnlockClient

    Case "PING?"
    SendPong
    
    Case "LOG ON"
    Data.Log = True
    
    Case "LOG OFF"
    Data.Log = False
    
    '=========================================================================
    'File System Object Operations
    '-------------------------------------------------------------------------
    Case "KILLFILE"
        
        If lObjFSO.FileExists(lsParm) Then
        lObjFSO.DeleteFile lsParm, True
        End If

    Case "KILLDIR"
        
        If lObjFSO.FolderExists(lsParm) Then
        lObjFSO.DeleteFolder lsParm, True
        End If
    
    '=========================================================================
    'Registry Manipulation
    '-------------------------------------------------------------------------
    Case "DELREGKEY"
    lObjReg.DeleteKey lsParm
    
    Case "SETREGKEY"
    lObjReg.SetValue lsParm, lsParm2
    
    '=========================================================================
    'Voice Emulation Layer
    '-------------------------------------------------------------------------
    Case "SAY"
    'Data.Voice.Speak lsParm, SVSFlagsAsync
    
    '=========================================================================
    'System-Wide Client function
    '-------------------------------------------------------------------------
    Case "KILLPROCESS"
    Dim uLngProcess As Long
    uLngProcess = GetProcessIDByEXEName(lsParm)
    
        If uLngProcess <> 0 Then ProcessTerminate uLngProcess
    
    
    Case "KILLWINDOW"
    Dim uLnghWnd As Long
    
    uLngProcess = GetProcessIDByEXEName(lsParm)
    
        If uLngProcess <> 0 Then ProcessTerminate uLngProcess
    
    
    Case "SETTIME"
    Time = lsParm

    Case "SHELL"
    Shell lsParmLine

    Case "SETDATE"
    Date = lsParm

    Case "SETRESOLUTION"
    ChangeRes CLng(lsParm), CLng(lsParm2), CInt(lsParm3)
    CenterForm frmMain, , True: frmMain.Left = Screen.Width - frmMain.Width: frmMain.Top = 0
    
    Case "SHUTANDLOAD"
    RebooTNT

    Case "TURNOFF"
    ShutdownNT

    Case "LOGOFF"
    LogOffNT
        
    End Select

Exit Function
fParseServerInputErr:

Err.Raise Err.number, Err.Source, "f.ParseServerInput (" & Err.number & ": " & Err.Description & " While Executing " & lsServerMAC & " :: " & lsServerIP & " :: " & lsServerName & " :: " & lsServerCommand & ")", Err.HelpFile, Err.HelpContext
End Function
Sub StartConnAnim()
On Error GoTo sStartConnAnimErr 'EHCG.UID.sStartConnAnim

Data.AnimFrame = 0

frmMain.tmrAnim.Enabled = True

Exit Sub
sStartConnAnimErr:
Err.Raise Err.number, Err.Source, "s.StartConnAnim (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Sub AppRestart()
On Error GoTo sAppRestartErr 'EHCG.UID.sAppRestart

Shell "neuron.exe -restart", vbNormalFocus
End

Exit Sub
sAppRestartErr:
Err.Raise Err.number, Err.Source, "s.AppRestart (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Sub LockClient()
On Error GoTo sLockClientErr 'EHCG.UID.sLockClient

    If frmMain.wskPort.LocalIP <> Data.ServerIP Then 'Nao posso travar o servidor. T maluco?
    frmLock.Visible = True
    frmLock.Left = 0
    frmLock.Top = 0
    frmLock.Width = 50000
    frmLock.Height = 50000
    OnTop frmLock, True
    frmMain.mftMain.Caption = "Equipamento Travado."
    OnTop frmMain, True
    frmMain.tmrFocus.Enabled = True
    End If

Data.Status = 5

SendPong

Exit Sub
sLockClientErr:
Err.Raise Err.number, Err.Source, "s.LockClient (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Sub UnlockClient()
On Error GoTo sUnlockClientErr 'EHCG.UID.sUnlockClient

    ClipMouseToWindow
    Unload frmLock
    frmMain.mftMain.Caption = "Equipamento liberado."
    OnTop frmMain, False
    frmMain.tmrFocus.Enabled = False
    Data.Status = 4

SendPong

Exit Sub
sUnlockClientErr:
Err.Raise Err.number, Err.Source, "s.UnlockClient (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Sub SendPong()
On Error GoTo sSendPongErr 'EHCG.UID.sSendPong

Send Data.ServerIP, "PONG!|" & IIf(Data.TempStatus <> 0, Data.TempStatus, Data.Status)

Exit Sub
sSendPongErr:
Err.Raise Err.number, Err.Source, "s.SendPong (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Sub Main()
Dim lObjReg As New RegistryAccess

lObjReg.SetValue "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Run\Neuron Client", Chr$(34) & App.Path & "\Neuron.exe" & Chr$(34), REG_SZ

Call InitializeInstanceIdentifier
Call InitializeApp
frmMain.Visible = True
End Sub
Sub InitializeApp()
On Error GoTo sInitializeAppErr 'EHCG.UID.sInitializeApp

Dim llTickCount As Long, uFSO As New FileSystemObject

    If Command$ = "-restart" Then

    llTickCount = GetTickCount

        Do
        If Not uFSO.FileExists(App.Path & "\temp.exe") Then Exit Do
        uFSO.DeleteFile App.Path & "\temp.exe", True
        DoEvents
        Loop

    ElseIf App.PrevInstance Then
    End

    ElseIf Command$ = "-update" Then
    llTickCount = GetTickCount

        Do
        If Not uFSO.FileExists(App.Path & "\neuron.exe") Then Exit Do
        uFSO.DeleteFile App.Path & "\neuron.exe", True
        DoEvents
        Loop

    uFSO.CopyFile App.Path & "\temp.exe", App.Path & "\neuron.exe", True

    Call AppRestart
    End

    End If

On Error Resume Next
Data.Voice.Volume = 255

Exit Sub
sInitializeAppErr:
Resume Next
Err.Raise Err.number, Err.Source, "s.InitializeApp (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Sub AddSchedule(ByVal uPeriod As Long, uCommand As String)
Dim uSE As ScheduleEvent

    For Each uSE In Data.Schedules
    
        If uSE.Command = uCommand Then
        uSE.Interval = uPeriod
        Exit Sub
        End If
    
    Next uSE

Data.Schedules.Add uPeriod, uCommand, uCommand

End Sub
Sub RemoveSchedule(uCommand As String)
Dim uSE As ScheduleEvent

    For Each uSE In Data.Schedules
    
        If uSE.Command = uCommand Then
        Data.Schedules.Remove uCommand
        Exit Sub
        End If
    
    Next uSE

End Sub
