Attribute VB_Name = "modMain"
Option Explicit

    Public Type uTrans
    Current As Currency
    Name As String
    Place As String
    Version As String
    Size As Currency
    Self As Boolean
    Itself As File
    Buffer As String
    End Type

    Public Type uAppLocalTypeDataBag
    MACAddress As String
    InstanceIdentifier As String
    CommBuffer As String
    ServerIP As String
    ServerName As String
    Status As Long
    TempStatus As Long
    AnimFrame As Long
    GamePath As String
    AppPath As String
    Transfer As uTrans
    End Type
Public Function Send(ByVal psIP As String, ByVal psInfo As String) As Boolean
On Error GoTo pfSendErr 'EHCG.UID.pfSend

Dim lStrData As String

    With frmMain.wskPort
    lStrData = Data.MACAddress & "|" & .LocalIP & "|" & .LocalHostName & "|" & psInfo
    frmMain.lblData(3) = "local time [" & Time & "]" & vbCrLf & "target [" & psIP & "]" & vbCrLf & "cmd [" & psInfo & "]"
    .RemotePort = 82 'Ajustando a porta remota para a Listening port do servidor Cortex
    .RemoteHost = psIP 'Identifica especificamente um IP.
    .SendData lStrData & vbCrLf
    End With

Exit Function
pfSendErr:
Err.Raise Err.number, Err.Source, "pf.Send (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Function
Function SendBroadcast(ByVal psInfo As String) As Boolean
On Error GoTo fSendBroadcastErr 'EHCG.UID.fSendBroadcast

SendBroadcast = Send("255.255.255.255", psInfo) 'Setando o IP para broadcast local.

Exit Function
fSendBroadcastErr:
Err.Raise Err.number, Err.Source, "f.SendBroadcast (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Function
Sub ProccessBuffer()
On Error GoTo sProccessBufferErr 'EHCG.UID.sProccessBuffer

Dim lsParseableCommand As String

Dim lsServerMAC As String, lsServerIP As String, lsServerName As String, lsServerCommand As String

    Do
    If InStr(Data.CommBuffer, vbCrLf) = 0 Then Exit Do

    Data.CommBuffer = StripLine(Data.CommBuffer, vbCrLf, lsParseableCommand)

    lsServerMAC = ParseDataBlock(lsParseableCommand, 0, "|")
    lsServerIP = ParseDataBlock(lsParseableCommand, 1, "|")
    lsServerName = ParseDataBlock(lsParseableCommand, 2, "|")
    lsServerCommand = Right$(lsParseableCommand, Len(lsParseableCommand) - (Len(lsServerIP & lsServerName & lsServerMAC) + 3))

    Call ParseServerInput(lsServerMAC, lsServerIP, lsServerName, lsServerCommand)

    Loop

Exit Sub
sProccessBufferErr:
Err.Raise Err.number, Err.Source, "s.ProccessBuffer (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Sub ProccessFileBuffer()
On Error GoTo sProccessFileBufferErr 'EHCG.UID.sProccessFileBuffer

Dim lsParseableCommand As String
Dim lsServerMAC As String, lsServerIP As String, lsServerName As String, lsServerCommand As String
Dim lObjFSO As New FileSystemObject, lObjFile As File, lObjFolder As Folder

    With Data.Transfer
    If .Buffer = "" Then Exit Sub
    
        If .Name = "" Then
    
        .Buffer = StripLine(.Buffer, vbCrLf, lsParseableCommand)
    
        lsServerMAC = ParseDataBlock(lsParseableCommand, 0, "|")
        lsServerIP = ParseDataBlock(lsParseableCommand, 1, "|")
        lsServerName = ParseDataBlock(lsParseableCommand, 2, "|")
        .Name = ParseDataBlock(lsParseableCommand, 3, "|")
        .Place = ParseDataBlock(lsParseableCommand, 4, "|")
        .Size = CCur(ValidNum(ParseDataBlock(lsParseableCommand, 5, "|")))
        Data.TempStatus = 2
        
        .Place = Replace(.Place, "[%SELF]", App.Path)
        .Place = Replace(.Place, "[%GAMES]", "C:\Games")
        
            If UCase(.Place) = UCase(App.Path) And UCase(.Name) = UCase("neuron.exe") Then 'Sobrescrever Neuron.
            .Name = "temp.exe"
            .Self = True
            End If
        
        frmMain.lblDeco(2).Visible = True
        frmMain.lblDeco(3).Visible = True
        frmMain.lblDeco(3).Caption = .Name
        frmMain.pgbFileReceive.Visible = True
        frmMain.pgbFileReceive.Min = 0
        frmMain.pgbFileReceive.Value = 0
        frmMain.pgbFileReceive.Max = 100
            
            If Not lObjFSO.FolderExists(.Place & "\") Then
            Set lObjFolder = lObjFSO.CreateFolder(.Place)
            End If
            
        lObjFSO.CreateTextFile .Place & "\" & .Name, True
        Set .Itself = lObjFSO.GetFile(.Place & "\" & .Name)
        .Itself.OpenAsTextStream(ForWriting).Write .Buffer
        .Buffer = ""
    
        End If
    
    End With

Exit Sub
sProccessFileBufferErr:
Err.Raise Err.number, Err.Source, "s.ProccessFileBuffer (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext
End Sub
Function ParseServerInput(ByVal lsServerMAC As String, ByVal lsServerIP As String, ByVal lsServerName As String, ByVal lsServerCommand As String) As Boolean
On Error GoTo fParseServerInputErr 'EHCG.UID.fParseServerInput

Dim lsAction As String, lsParm As String, lsParm2 As String, lsParm3 As String, lObjFSO As FileSystemObject

    If Data.ServerIP = "" Then Data.ServerIP = lsServerIP

Debug.Print lsServerIP & ": " & lsServerCommand

lsAction = ParseDataBlock(lsServerCommand, 0, "|")

    Select Case lsAction
    Case "SERVERINFO"
    lsParm = Right$(lsServerCommand, Len(lsServerCommand) - (Len(lsAction) + 1))
    Data.ServerIP = lsServerIP
    Data.ServerName = lsParm
    Call StartConnAnim
    frmMain.lblData(0).Caption = Data.ServerName

    Case "USERINFO"
    lsParm = Right$(lsServerCommand, Len(lsServerCommand) - (Len(lsAction) + 1))
    frmMain.lblData(1).Caption = lsParm
    frmMain.imgUserOn.Visible = True

    Case "KILLUSER"
    frmMain.imgUserOn.Visible = False
    frmMain.lblData(1).Caption = "Waiting..."

    Case "RESTART"
    Call AppRestart

    Case "SHUTANDLOAD"
    RebooTNT

    Case "TURNOFF"
    ShutdownNT

    Case "LOGOFF"
    LogOffNT

    Case "SHUTDOWN"
    End

    Case "QUERYID"
    Send Data.ServerIP, "QUERYID|" & InputBox("Informe o ID desta mquina (numerao)")

    Case "LOCK"
    Call LockClient

    Case "UNLOCK"
    Call UnlockClient

    Case "PING?"
    SendPong
    
    Case "SETRESOLUTION"
    lsParm = ParseDataBlock(lsServerCommand, 1, "|")
    lsParm2 = ParseDataBlock(lsServerCommand, 2, "|")
    lsParm3 = ParseDataBlock(lsServerCommand, 3, "|")
    ChangeRes CLng(lsParm), CLng(lsParm2), CInt(lsParm3)
    CenterForm frmMain, , True
    frmMain.Left = Screen.Width - frmMain.Width
    frmMain.Top = 0

    Case "SETTIME"
    lsParm = ParseDataBlock(lsServerCommand, 1, "|")
    Time = lsParm

    Case "SETDATE"
    lsParm = ParseDataBlock(lsServerCommand, 1, "|")
    Date = lsParm

    Case "KILLFILE"
    lsParm = ParseDataBlock(lsServerCommand, 1, "|")
        
        If lObjFSO.FileExists(lsParm) Then
        lObjFSO.DeleteFile lsParm, True
        End If

    Case "KILLDIR"
    lsParm = ParseDataBlock(lsServerCommand, 1, "|")
        
        If lObjFSO.FolderExists(lsParm) Then
        lObjFSO.DeleteFolder lsParm, True
        End If
    
    Case "FILETRANSEND"
    
        With Data
        
            If .Transfer.Name <> "" Then 'Mm... erro na transmisso.
            .Transfer.Buffer = ""
            .Transfer.Current = 0
                
                If Not IsEmpty(.Transfer.Itself) Then
                .Transfer.Itself.Delete
                Set .Transfer.Itself = Nothing
                End If
            
            .Transfer.Name = ""
            .Transfer.Place = ""
            .Transfer.Self = False
            .Transfer.Size = 0
            .Transfer.Version = ""
            frmMain.lblDeco(2).Visible = False
            frmMain.lblDeco(3).Visible = False
            frmMain.pgbFileReceive.Visible = False
            End If
        
        End With
        
    End Select

Exit Function
fParseServerInputErr:
Err.Raise Err.number, Err.Source, "f.ParseServerInput (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Function
Sub StartConnAnim()
On Error GoTo sStartConnAnimErr 'EHCG.UID.sStartConnAnim

Data.AnimFrame = 0

frmMain.tmrAnim.Enabled = True

Exit Sub
sStartConnAnimErr:
Err.Raise Err.number, Err.Source, "s.StartConnAnim (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Sub AppRestart()
On Error GoTo sAppRestartErr 'EHCG.UID.sAppRestart

Shell App.EXEName & " -restart", vbNormalFocus
End

Exit Sub
sAppRestartErr:
Err.Raise Err.number, Err.Source, "s.AppRestart (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Sub LockClient()
On Error GoTo sLockClientErr 'EHCG.UID.sLockClient

    frmLock.Visible = True
    frmLock.Left = 0
    frmLock.Top = 0
    frmLock.Width = 50000
    frmLock.Height = 50000
    OnTop frmLock, True
    frmMain.lblLock.Visible = True
    OnTop frmMain, True
    frmMain.tmrFocus.Enabled = True
    Data.Status = 5

SendPong

Exit Sub
sLockClientErr:
Err.Raise Err.number, Err.Source, "s.LockClient (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Sub UnlockClient()
On Error GoTo sUnlockClientErr 'EHCG.UID.sUnlockClient

    ClipMouseToWindow
    Unload frmLock
    frmMain.lblLock.Visible = False
    OnTop frmMain, False
    frmMain.tmrFocus.Enabled = False
    Data.Status = 4

SendPong

Exit Sub
sUnlockClientErr:
Err.Raise Err.number, Err.Source, "s.UnlockClient (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Sub SendPong()
On Error GoTo sSendPongErr 'EHCG.UID.sSendPong

Send Data.ServerIP, "PONG!|" & IIf(Data.TempStatus <> 0, Data.TempStatus, Data.Status)

Exit Sub
sSendPongErr:
Err.Raise Err.number, Err.Source, "s.SendPong (" & Err.number & ": " & Err.Description & ")", Err.HelpFile, Err.HelpContext

End Sub
Sub Main()

Call InitializeApp

frmMain.Visible = True
End Sub
Sub InitializeApp()

Dim llTickCount As Long

    If Command$ = "-restart" Then

    llTickCount = GetTickCount

        Do While Not GetTickCount > llTickCount + 2000
        DoEvents
        Loop

    ElseIf App.PrevInstance Then
    End
    
    ElseIf Command$ = "-update" Then
    llTickCount = GetTickCount

        Do While Not GetTickCount > llTickCount + 2000
        DoEvents
        Loop
    
    FileCopy "temp.exe", "neuron.exe"
    Call AppRestart
    End

    End If

End Sub
